;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.12 #12748 (MINGW64)
;--------------------------------------------------------
	.module main
	.optsdcc -mmcs51 --model-medium
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _ds1621_reset_flags
	.globl _ds1621_get_config
	.globl _init_ds1621
	.globl _ds1621_read_hrtemp
	.globl _ds1621_get_TL
	.globl _ds1621_get_TH
	.globl _ds1621_set_TL
	.globl _ds1621_set_TH
	.globl _ds1621_start_convert
	.globl _ftemp_to_u16
	.globl _uitemp_to_float
	.globl _net_sendbytes
	.globl _CY
	.globl _AC
	.globl _F0
	.globl _RS1
	.globl _RS0
	.globl _OV
	.globl _F1
	.globl _P
	.globl _FEXT
	.globl _FTMR
	.globl _FNET
	.globl _EEXT
	.globl _ETMR
	.globl _ENET
	.globl _NETTOUT
	.globl _NETSTAT
	.globl _NETRXLEN
	.globl _NETTXLEN
	.globl _NETCON
	.globl _RXCH
	.globl _RXPORT
	.globl _RXPORTH
	.globl _RXPORTL
	.globl _RXIP
	.globl _RXIP3
	.globl _RXIP2
	.globl _RXIP1
	.globl _RXIP0
	.globl _TXCH
	.globl _TXPORT
	.globl _TXPORTH
	.globl _TXPORTL
	.globl _TXIP
	.globl _TXIP3
	.globl _TXIP2
	.globl _TXIP1
	.globl _TXIP0
	.globl _TMR
	.globl _TMRH
	.globl _TMRL
	.globl _TMRCON
	.globl _IFLAG
	.globl _EXTCON
	.globl _I2CSTAT
	.globl _I2CRXLEN
	.globl _I2CTXLEN
	.globl _I2CFREQ
	.globl _SLVADDR
	.globl _I2CCON
	.globl _IE2
	.globl _B
	.globl _ACC
	.globl _PSW
	.globl _DPH
	.globl _DPL
	.globl _SP
	.globl _NETRXBUF
	.globl _NETTXBUF
	.globl _I2CRXBUF
	.globl _I2CTXBUF
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_IE2	=	0x00c0
_I2CCON	=	0x00c1
_SLVADDR	=	0x00c2
_I2CFREQ	=	0x00c3
_I2CTXLEN	=	0x00c4
_I2CRXLEN	=	0x00c5
_I2CSTAT	=	0x00c6
_EXTCON	=	0x00c7
_IFLAG	=	0x00c8
_TMRCON	=	0x00c9
_TMRL	=	0x00ca
_TMRH	=	0x00cb
_TMR	=	0xcbca
_TXIP0	=	0x00a9
_TXIP1	=	0x00aa
_TXIP2	=	0x00ab
_TXIP3	=	0x00ac
_TXIP	=	0xacabaaa9
_TXPORTL	=	0x00ad
_TXPORTH	=	0x00ae
_TXPORT	=	0xaead
_TXCH	=	0x00af
_RXIP0	=	0x00b1
_RXIP1	=	0x00b2
_RXIP2	=	0x00b3
_RXIP3	=	0x00b4
_RXIP	=	0xb4b3b2b1
_RXPORTL	=	0x00b5
_RXPORTH	=	0x00b6
_RXPORT	=	0xb6b5
_RXCH	=	0x00b7
_NETCON	=	0x00b9
_NETTXLEN	=	0x00ba
_NETRXLEN	=	0x00bb
_NETSTAT	=	0x00bc
_NETTOUT	=	0x00bd
;--------------------------------------------------------
; special function bits
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_ENET	=	0x00c0
_ETMR	=	0x00c1
_EEXT	=	0x00c2
_FNET	=	0x00c8
_FTMR	=	0x00c9
_FEXT	=	0x00ca
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;--------------------------------------------------------
; Stack segment in internal ram 
;--------------------------------------------------------
	.area	SSEG
__start__stack:
	.ds	1

;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; absolute internal ram data
;--------------------------------------------------------
	.area IABS    (ABS,DATA)
	.area IABS    (ABS,DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; paged external ram data
;--------------------------------------------------------
	.area PSEG    (PAG,XDATA)
_main_config_65536_26:
	.ds 1
_main_tmp16_65536_26:
	.ds 2
_main_socket_65536_26:
	.ds 8
_main_packet_65536_26:
	.ds 6
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_I2CTXBUF	=	0x0800
_I2CRXBUF	=	0x0900
_NETTXBUF	=	0x0a00
_NETRXBUF	=	0x0b00
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area XABS    (ABS,XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
	.area HOME    (CODE)
	.area GSINIT0 (CODE)
	.area GSINIT1 (CODE)
	.area GSINIT2 (CODE)
	.area GSINIT3 (CODE)
	.area GSINIT4 (CODE)
	.area GSINIT5 (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; interrupt vector 
;--------------------------------------------------------
	.area HOME    (CODE)
__interrupt_vect:
	ljmp	__sdcc_gsinit_startup
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME    (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
	.globl __sdcc_gsinit_startup
	.globl __sdcc_program_startup
	.globl __start__stack
	.globl __mcs51_genXINIT
	.globl __mcs51_genXRAMCLEAR
	.globl __mcs51_genRAMCLEAR
	.area GSFINAL (CODE)
	ljmp	__sdcc_program_startup
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area HOME    (CODE)
__sdcc_program_startup:
	ljmp	_main
;	return from main will return to caller
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'main'
;------------------------------------------------------------
;	main.c:18: void main(void)
;	-----------------------------------------
;	 function main
;	-----------------------------------------
_main:
	ar7 = 0x07
	ar6 = 0x06
	ar5 = 0x05
	ar4 = 0x04
	ar3 = 0x03
	ar2 = 0x02
	ar1 = 0x01
	ar0 = 0x00
;	main.c:22: uint8_t config = 0;
	mov	r0,#_main_config_65536_26
	clr	a
	movx	@r0,a
;	main.c:29: socket.ch = CH_TCP; // use socket 1 TCP/IP
	mov	r0,#(_main_socket_65536_26 + 0x0006)
	inc	a
	movx	@r0,a
;	main.c:30: socket.ip = 0;
	mov	r0,#_main_socket_65536_26
	clr	a
	movx	@r0,a
	inc	r0
	movx	@r0,a
	inc	r0
	movx	@r0,a
	inc	r0
	movx	@r0,a
;	main.c:31: socket.port = 0;
	mov	r0,#(_main_socket_65536_26 + 0x0004)
	movx	@r0,a
	inc	r0
	movx	@r0,a
;	main.c:32: socket.noheader = 0;
	mov	r0,#(_main_socket_65536_26 + 0x0007)
	movx	@r0,a
;	main.c:34: SET_I2CFREQ(100);   // set I2C SCL frequency to 100kHz
	mov	_I2CFREQ,#0x14
;	main.c:35: NETTOUT = 10;       // network transmitt timeout 10 * 10 = 100ms
	mov	_NETTOUT,#0x0a
;	main.c:37: sensor_initialized = init_ds1621(23.5, 29.5);
	mov	r0,#_init_ds1621_PARM_2
	movx	@r0,a
	inc	r0
	movx	@r0,a
	mov	a,#0xec
	inc	r0
	movx	@r0,a
	mov	a,#0x41
	inc	r0
	movx	@r0,a
	mov	dptr,#0x0000
	mov	b,#0xbc
	mov	a,#0x41
	lcall	_init_ds1621
	mov	r7,dpl
;	main.c:39: SET_TIMER(1000);
	mov	_TMRL,#0xe8
	mov	_TMRH,#0x03
;	main.c:40: TIMER_NONBLOCKING;
	mov	_TMRCON,#0x05
;	main.c:41: while(1)
00130$:
;	main.c:43: if (FNET) {
	jb	_FNET,00209$
	ljmp	00115$
00209$:
;	main.c:44: cmd = NETRXBUF[0];
	mov	dptr,#_NETRXBUF
	movx	a,@dptr
	mov	r6,a
;	main.c:45: switch (cmd) {
	cjne	r6,#0x10,00210$
	sjmp	00101$
00210$:
	cjne	r6,#0x11,00211$
	ljmp	00104$
00211$:
	cjne	r6,#0x20,00212$
	ljmp	00107$
00212$:
	cjne	r6,#0x21,00213$
	ljmp	00110$
00213$:
	ljmp	00113$
;	main.c:46: case 0x10 : ptemp = (FLU8_T*)&NETRXBUF[1];
00101$:
;	main.c:47: ds1621_set_TL(ftemp_to_u16(ptemp->fl));
	mov	dptr,#(_NETRXBUF + 0x0001)
	movx	a,@dptr
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	dpl,r3
	mov	dph,r4
	mov	b,r5
	push	ar7
	lcall	_ftemp_to_u16
	lcall	_ds1621_set_TL
;	main.c:49: if (ds1621_get_TL(&tmp16)) {
	mov	dptr,#_main_tmp16_65536_26
	mov	b,#0x60
	lcall	_ds1621_get_TL
	mov	a,dpl
	pop	ar7
	jnz	00214$
	ljmp	00113$
00214$:
;	main.c:50: packet.cmd = 0x20;
	mov	r0,#_main_packet_65536_26
	mov	a,#0x20
	movx	@r0,a
;	main.c:51: packet.temp.fl = uitemp_to_float(tmp16);
	mov	r0,#_main_tmp16_65536_26
	movx	a,@r0
	mov	dpl,a
	inc	r0
	movx	a,@r0
	mov	dph,a
	push	ar7
	lcall	_uitemp_to_float
	mov	r3,dpl
	mov	r4,dph
	mov	r5,b
	mov	r6,a
	mov	r0,#(_main_packet_65536_26 + 0x0001)
	mov	a,r3
	movx	@r0,a
	inc	r0
	mov	a,r4
	movx	@r0,a
	inc	r0
	mov	a,r5
	movx	@r0,a
	inc	r0
	mov	a,r6
	movx	@r0,a
;	main.c:52: net_sendbytes((uint8_t*)(&packet),5,&socket);
	mov	r0,#_net_sendbytes_PARM_3
	mov	a,#_main_socket_65536_26
	movx	@r0,a
	clr	a
	inc	r0
	movx	@r0,a
	mov	a,#0x60
	inc	r0
	movx	@r0,a
	mov	r0,#_net_sendbytes_PARM_2
	mov	a,#0x05
	movx	@r0,a
	mov	dptr,#_main_packet_65536_26
	mov	b,#0x60
	lcall	_net_sendbytes
	pop	ar7
;	main.c:54: break;
	ljmp	00113$
;	main.c:56: case 0x11 : ptemp = (FLU8_T*)&NETRXBUF[1];
00104$:
;	main.c:57: ds1621_set_TH(ftemp_to_u16(ptemp->fl));
	mov	dptr,#(_NETRXBUF + 0x0001)
	movx	a,@dptr
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	dpl,r3
	mov	dph,r4
	mov	b,r5
	push	ar7
	lcall	_ftemp_to_u16
	lcall	_ds1621_set_TH
;	main.c:59: if (ds1621_get_TH(&tmp16)) {
	mov	dptr,#_main_tmp16_65536_26
	mov	b,#0x60
	lcall	_ds1621_get_TH
	mov	a,dpl
	pop	ar7
	jnz	00215$
	ljmp	00113$
00215$:
;	main.c:60: packet.cmd = 0x21;
	mov	r0,#_main_packet_65536_26
	mov	a,#0x21
	movx	@r0,a
;	main.c:61: packet.temp.fl = uitemp_to_float(tmp16);
	mov	r0,#_main_tmp16_65536_26
	movx	a,@r0
	mov	dpl,a
	inc	r0
	movx	a,@r0
	mov	dph,a
	push	ar7
	lcall	_uitemp_to_float
	mov	r3,dpl
	mov	r4,dph
	mov	r5,b
	mov	r6,a
	mov	r0,#(_main_packet_65536_26 + 0x0001)
	mov	a,r3
	movx	@r0,a
	inc	r0
	mov	a,r4
	movx	@r0,a
	inc	r0
	mov	a,r5
	movx	@r0,a
	inc	r0
	mov	a,r6
	movx	@r0,a
;	main.c:62: net_sendbytes((uint8_t*)(&packet),5,&socket);
	mov	r0,#_net_sendbytes_PARM_3
	mov	a,#_main_socket_65536_26
	movx	@r0,a
	clr	a
	inc	r0
	movx	@r0,a
	mov	a,#0x60
	inc	r0
	movx	@r0,a
	mov	r0,#_net_sendbytes_PARM_2
	mov	a,#0x05
	movx	@r0,a
	mov	dptr,#_main_packet_65536_26
	mov	b,#0x60
	lcall	_net_sendbytes
	pop	ar7
;	main.c:64: break;
	ljmp	00113$
;	main.c:66: case 0x20 : if (ds1621_get_TL(&tmp16)) {
00107$:
	mov	dptr,#_main_tmp16_65536_26
	mov	b,#0x60
	push	ar7
	lcall	_ds1621_get_TL
	mov	a,dpl
	pop	ar7
	jnz	00216$
	ljmp	00113$
00216$:
;	main.c:67: packet.cmd = 0x20;
	mov	r0,#_main_packet_65536_26
	mov	a,#0x20
	movx	@r0,a
;	main.c:68: packet.temp.fl = uitemp_to_float(tmp16);
	mov	r0,#_main_tmp16_65536_26
	movx	a,@r0
	mov	dpl,a
	inc	r0
	movx	a,@r0
	mov	dph,a
	push	ar7
	lcall	_uitemp_to_float
	mov	r3,dpl
	mov	r4,dph
	mov	r5,b
	mov	r6,a
	mov	r0,#(_main_packet_65536_26 + 0x0001)
	mov	a,r3
	movx	@r0,a
	inc	r0
	mov	a,r4
	movx	@r0,a
	inc	r0
	mov	a,r5
	movx	@r0,a
	inc	r0
	mov	a,r6
	movx	@r0,a
;	main.c:69: net_sendbytes((uint8_t*)(&packet),5,&socket);
	mov	r0,#_net_sendbytes_PARM_3
	mov	a,#_main_socket_65536_26
	movx	@r0,a
	clr	a
	inc	r0
	movx	@r0,a
	mov	a,#0x60
	inc	r0
	movx	@r0,a
	mov	r0,#_net_sendbytes_PARM_2
	mov	a,#0x05
	movx	@r0,a
	mov	dptr,#_main_packet_65536_26
	mov	b,#0x60
	lcall	_net_sendbytes
	pop	ar7
;	main.c:71: break;
;	main.c:72: case 0x21 : if (ds1621_get_TH(&tmp16)) {
	sjmp	00113$
00110$:
	mov	dptr,#_main_tmp16_65536_26
	mov	b,#0x60
	push	ar7
	lcall	_ds1621_get_TH
	mov	a,dpl
	pop	ar7
	jz	00113$
;	main.c:73: packet.cmd = 0x21;
	mov	r0,#_main_packet_65536_26
	mov	a,#0x21
	movx	@r0,a
;	main.c:74: packet.temp.fl = uitemp_to_float(tmp16);
	mov	r0,#_main_tmp16_65536_26
	movx	a,@r0
	mov	dpl,a
	inc	r0
	movx	a,@r0
	mov	dph,a
	push	ar7
	lcall	_uitemp_to_float
	mov	r3,dpl
	mov	r4,dph
	mov	r5,b
	mov	r6,a
	mov	r0,#(_main_packet_65536_26 + 0x0001)
	mov	a,r3
	movx	@r0,a
	inc	r0
	mov	a,r4
	movx	@r0,a
	inc	r0
	mov	a,r5
	movx	@r0,a
	inc	r0
	mov	a,r6
	movx	@r0,a
;	main.c:75: net_sendbytes((uint8_t*)(&packet),5,&socket);
	mov	r0,#_net_sendbytes_PARM_3
	mov	a,#_main_socket_65536_26
	movx	@r0,a
	clr	a
	inc	r0
	movx	@r0,a
	mov	a,#0x60
	inc	r0
	movx	@r0,a
	mov	r0,#_net_sendbytes_PARM_2
	mov	a,#0x05
	movx	@r0,a
	mov	dptr,#_main_packet_65536_26
	mov	b,#0x60
	lcall	_net_sendbytes
	pop	ar7
;	main.c:78: }
00113$:
;	main.c:79: FNET = 0;
;	assignBit
	clr	_FNET
00115$:
;	main.c:82: if (FTMR) {     // check if timer flag is set
;	main.c:83: FTMR = 0;   // Clear timer flag
;	assignBit
	jbc	_FTMR,00218$
	ljmp	00130$
00218$:
;	main.c:84: if (sensor_initialized == 0) {
	mov	a,r7
	jnz	00125$
;	main.c:85: sensor_initialized = ds1621_start_convert();
	lcall	_ds1621_start_convert
	mov	r7,dpl
	ljmp	00130$
00125$:
;	main.c:87: if (ds1621_read_hrtemp(&packet.temp.fl)) {
	mov	dptr,#(_main_packet_65536_26 + 0x0001)
	mov	b,#0x60
	push	ar7
	lcall	_ds1621_read_hrtemp
	mov	a,dpl
	pop	ar7
	jnz	00220$
	ljmp	00130$
00220$:
;	main.c:88: if (ds1621_get_config(&config)) {
	mov	dptr,#_main_config_65536_26
	mov	b,#0x60
	push	ar7
	lcall	_ds1621_get_config
	mov	a,dpl
	pop	ar7
	jz	00120$
;	main.c:89: if(config & (DS1621_THF | DS1621_TLF)) {
	mov	r0,#_main_config_65536_26
	movx	a,@r0
	anl	a,#0x60
	jz	00120$
;	main.c:90: ds1621_reset_flags();
	push	ar7
	lcall	_ds1621_reset_flags
	pop	ar7
;	main.c:93: if (FEST1) {  // transmit if connection is established
00120$:
;	main.c:94: packet.cmd = 0xAA;
	mov	r0,#_main_packet_65536_26
	mov	a,#0xaa
	movx	@r0,a
;	main.c:95: packet.config = config;
	mov	r0,#(_main_packet_65536_26 + 0x0005)
	mov	r1,#_main_config_65536_26
	movx	a,@r1
	movx	@r0,a
;	main.c:96: net_sendbytes((uint8_t*)(&packet),6,&socket);
	mov	r0,#_net_sendbytes_PARM_3
	mov	a,#_main_socket_65536_26
	movx	@r0,a
	clr	a
	inc	r0
	movx	@r0,a
	mov	a,#0x60
	inc	r0
	movx	@r0,a
	mov	r0,#_net_sendbytes_PARM_2
	swap	a
	movx	@r0,a
	mov	dptr,#_main_packet_65536_26
	mov	b,#0x60
	push	ar7
	lcall	_net_sendbytes
	pop	ar7
;	main.c:102: }
	ljmp	00130$
	.area CSEG    (CODE)
	.area CONST   (CODE)
	.area XINIT   (CODE)
	.area CABS    (ABS,CODE)
