;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.12 #12748 (MINGW64)
;--------------------------------------------------------
	.module mb_ds1621_if
	.optsdcc -mmcs51 --model-large
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _BasicDeviceObjects
	.globl _mb_read_input_registers
	.globl _mb_read_holding_registers
	.globl _mb_mask_write_register
	.globl _mb_write_multiple_coils
	.globl _mb_write_single_register
	.globl _mb_write_single_coil
	.globl _mb_read_coils
	.globl _mb_set_data_length
	.globl _mb_init
	.globl _mb_register_function
	.globl _ds1621_set_config
	.globl _ds1621_get_config
	.globl _ds1621_read_hrtemp
	.globl _ds1621_read_slope
	.globl _ds1621_read_counter
	.globl _ds1621_get_TL
	.globl _ds1621_get_TH
	.globl _ds1621_set_TL
	.globl _ds1621_set_TH
	.globl _ds1621_read_temp
	.globl _ds1621_stop_convert
	.globl _ds1621_start_convert
	.globl _CY
	.globl _AC
	.globl _F0
	.globl _RS1
	.globl _RS0
	.globl _OV
	.globl _F1
	.globl _P
	.globl _FEXT
	.globl _FTMR
	.globl _FNET
	.globl _EEXT
	.globl _ETMR
	.globl _ENET
	.globl _NETTOUT
	.globl _NETSTAT
	.globl _NETRXLEN
	.globl _NETTXLEN
	.globl _NETCON
	.globl _RXCH
	.globl _RXPORT
	.globl _RXPORTH
	.globl _RXPORTL
	.globl _RXIP
	.globl _RXIP3
	.globl _RXIP2
	.globl _RXIP1
	.globl _RXIP0
	.globl _TXCH
	.globl _TXPORT
	.globl _TXPORTH
	.globl _TXPORTL
	.globl _TXIP
	.globl _TXIP3
	.globl _TXIP2
	.globl _TXIP1
	.globl _TXIP0
	.globl _TMR
	.globl _TMRH
	.globl _TMRL
	.globl _TMRCON
	.globl _IFLAG
	.globl _EXTCON
	.globl _I2CSTAT
	.globl _I2CRXLEN
	.globl _I2CTXLEN
	.globl _I2CFREQ
	.globl _SLVADDR
	.globl _I2CCON
	.globl _IE2
	.globl _B
	.globl _ACC
	.globl _PSW
	.globl _DPH
	.globl _DPL
	.globl _SP
	.globl _NETRXBUF
	.globl _NETTXBUF
	.globl _I2CRXBUF
	.globl _I2CTXBUF
	.globl _mb_device_init
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_IE2	=	0x00c0
_I2CCON	=	0x00c1
_SLVADDR	=	0x00c2
_I2CFREQ	=	0x00c3
_I2CTXLEN	=	0x00c4
_I2CRXLEN	=	0x00c5
_I2CSTAT	=	0x00c6
_EXTCON	=	0x00c7
_IFLAG	=	0x00c8
_TMRCON	=	0x00c9
_TMRL	=	0x00ca
_TMRH	=	0x00cb
_TMR	=	0xcbca
_TXIP0	=	0x00a9
_TXIP1	=	0x00aa
_TXIP2	=	0x00ab
_TXIP3	=	0x00ac
_TXIP	=	0xacabaaa9
_TXPORTL	=	0x00ad
_TXPORTH	=	0x00ae
_TXPORT	=	0xaead
_TXCH	=	0x00af
_RXIP0	=	0x00b1
_RXIP1	=	0x00b2
_RXIP2	=	0x00b3
_RXIP3	=	0x00b4
_RXIP	=	0xb4b3b2b1
_RXPORTL	=	0x00b5
_RXPORTH	=	0x00b6
_RXPORT	=	0xb6b5
_RXCH	=	0x00b7
_NETCON	=	0x00b9
_NETTXLEN	=	0x00ba
_NETRXLEN	=	0x00bb
_NETSTAT	=	0x00bc
_NETTOUT	=	0x00bd
;--------------------------------------------------------
; special function bits
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_ENET	=	0x00c0
_ETMR	=	0x00c1
_EEXT	=	0x00c2
_FNET	=	0x00c8
_FTMR	=	0x00c9
_FEXT	=	0x00ca
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
_mb_read_holding_registers_sloc0_1_0:
	.ds 2
_mb_read_input_registers_sloc0_1_0:
	.ds 2
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; absolute internal ram data
;--------------------------------------------------------
	.area IABS    (ABS,DATA)
	.area IABS    (ABS,DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; paged external ram data
;--------------------------------------------------------
	.area PSEG    (PAG,XDATA)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_I2CTXBUF	=	0x0800
_I2CRXBUF	=	0x0900
_NETTXBUF	=	0x0a00
_NETRXBUF	=	0x0b00
_u16swap_val_65536_42:
	.ds 2
_mb_read_coils_value_65536_51:
	.ds 1
_mb_read_coils_ret_65536_51:
	.ds 1
_mb_read_coils_mask_65536_51:
	.ds 1
_mb_read_coils_val_196608_56:
	.ds 2
_mb_read_coils_val_196608_59:
	.ds 2
_mb_write_single_coil_ret_65536_62:
	.ds 1
_mb_write_single_coil_value_65536_62:
	.ds 1
_mb_write_single_coil_val_196608_69:
	.ds 2
_mb_write_single_coil_val_196608_72:
	.ds 2
_mb_write_single_register_ret_65536_75:
	.ds 1
_mb_write_single_register_val_196608_85:
	.ds 2
_mb_write_single_register_val_196608_88:
	.ds 2
_mb_write_multiple_coils_ret_65536_91:
	.ds 1
_mb_write_multiple_coils_value_65536_91:
	.ds 1
_mb_write_multiple_coils_mask_65536_91:
	.ds 1
_mb_write_multiple_coils_val_196608_99:
	.ds 2
_mb_write_multiple_coils_val_196608_102:
	.ds 2
_mb_mask_write_register_ret_65536_105:
	.ds 1
_mb_mask_write_register_value_65536_105:
	.ds 1
_mb_mask_write_register_val_196608_111:
	.ds 2
_mb_mask_write_register_val_196608_114:
	.ds 2
_mb_mask_write_register_val_196608_117:
	.ds 2
_mb_read_holding_registers_ret_65536_120:
	.ds 1
_mb_read_holding_registers_len_65536_120:
	.ds 2
_mb_read_holding_registers_u8value_65536_120:
	.ds 1
_mb_read_holding_registers_u16value_65536_120:
	.ds 2
_mb_read_holding_registers_val_196608_128:
	.ds 2
_mb_read_holding_registers_val_196608_131:
	.ds 2
_mb_read_holding_registers_val_458752_134:
	.ds 2
_mb_read_holding_registers_val_458752_137:
	.ds 2
_mb_read_holding_registers_val_458752_140:
	.ds 2
_mb_read_input_registers_ret_65536_143:
	.ds 1
_mb_read_input_registers_len_65536_143:
	.ds 2
_mb_read_input_registers_u8value_65536_143:
	.ds 1
_mb_read_input_registers_u16value_65536_143:
	.ds 2
_mb_read_input_registers_temp_65536_143:
	.ds 4
_mb_read_input_registers_last_result_65536_143:
	.ds 1
_mb_read_input_registers_val_196608_154:
	.ds 2
_mb_read_input_registers_val_196608_157:
	.ds 2
_mb_read_input_registers_val_458752_160:
	.ds 2
_mb_read_input_registers_val_458752_163:
	.ds 2
_mb_read_input_registers_val_458752_166:
	.ds 2
_mb_read_input_registers_val_458752_169:
	.ds 2
_mb_read_input_registers_val_458752_172:
	.ds 2
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area XABS    (ABS,XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
	.area HOME    (CODE)
	.area GSINIT0 (CODE)
	.area GSINIT1 (CODE)
	.area GSINIT2 (CODE)
	.area GSINIT3 (CODE)
	.area GSINIT4 (CODE)
	.area GSINIT5 (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME    (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_input_registers'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_read_input_registers_sloc0_1_0'
;__1310720076              Allocated with name '_mb_read_input_registers___1310720076_131072_143'
;__1310720073              Allocated with name '_mb_read_input_registers___1310720073_131072_143'
;ret                       Allocated with name '_mb_read_input_registers_ret_65536_143'
;addr                      Allocated with name '_mb_read_input_registers_addr_65536_143'
;numregs                   Allocated with name '_mb_read_input_registers_numregs_65536_143'
;len                       Allocated with name '_mb_read_input_registers_len_65536_143'
;i                         Allocated with name '_mb_read_input_registers_i_65536_143'
;u8value                   Allocated with name '_mb_read_input_registers_u8value_65536_143'
;u16value                  Allocated with name '_mb_read_input_registers_u16value_65536_143'
;temp                      Allocated with name '_mb_read_input_registers_temp_65536_143'
;last_result               Allocated with name '_mb_read_input_registers_last_result_65536_143'
;__1310720074              Allocated with name '_mb_read_input_registers___1310720074_131072_153'
;val                       Allocated with name '_mb_read_input_registers_val_196608_154'
;__1310720077              Allocated with name '_mb_read_input_registers___1310720077_131072_156'
;val                       Allocated with name '_mb_read_input_registers_val_196608_157'
;__3932160079              Allocated with name '_mb_read_input_registers___3932160079_393216_148'
;__3932160080              Allocated with name '_mb_read_input_registers___3932160080_393216_159'
;val                       Allocated with name '_mb_read_input_registers_val_458752_160'
;__3932160082              Allocated with name '_mb_read_input_registers___3932160082_393216_149'
;__3932160083              Allocated with name '_mb_read_input_registers___3932160083_393216_162'
;val                       Allocated with name '_mb_read_input_registers_val_458752_163'
;__3932160085              Allocated with name '_mb_read_input_registers___3932160085_393216_150'
;__3932160086              Allocated with name '_mb_read_input_registers___3932160086_393216_165'
;val                       Allocated with name '_mb_read_input_registers_val_458752_166'
;__3932160088              Allocated with name '_mb_read_input_registers___3932160088_393216_151'
;__3932160089              Allocated with name '_mb_read_input_registers___3932160089_393216_168'
;val                       Allocated with name '_mb_read_input_registers_val_458752_169'
;__3932160091              Allocated with name '_mb_read_input_registers___3932160091_393216_152'
;__3932160092              Allocated with name '_mb_read_input_registers___3932160092_393216_171'
;val                       Allocated with name '_mb_read_input_registers_val_458752_172'
;------------------------------------------------------------
;	mb_ds1621_if.c:332: static uint8_t last_result = 0;
	mov	dptr,#_mb_read_input_registers_last_result_65536_143
	clr	a
	movx	@dptr,a
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area HOME    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'u16swap'
;------------------------------------------------------------
;val                       Allocated with name '_u16swap_val_65536_42'
;------------------------------------------------------------
;	../VM_Inc/mb.h:263: static inline uint16_t u16swap(uint16_t val)
;	-----------------------------------------
;	 function u16swap
;	-----------------------------------------
_u16swap:
	ar7 = 0x07
	ar6 = 0x06
	ar5 = 0x05
	ar4 = 0x04
	ar3 = 0x03
	ar2 = 0x02
	ar1 = 0x01
	ar0 = 0x00
	mov	r7,dph
	mov	a,dpl
	mov	dptr,#_u16swap_val_65536_42
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	../VM_Inc/mb.h:265: return ((val >> 8) & 0x00FF) | ((val << 8) & 0xFF00);
	mov	dptr,#_u16swap_val_65536_42
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
	mov	dpl,r6
	mov	dph,r7
;	../VM_Inc/mb.h:266: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_coils'
;------------------------------------------------------------
;__1310720028              Allocated with name '_mb_read_coils___1310720028_131072_51'
;__1310720025              Allocated with name '_mb_read_coils___1310720025_131072_51'
;value                     Allocated with name '_mb_read_coils_value_65536_51'
;ret                       Allocated with name '_mb_read_coils_ret_65536_51'
;mask                      Allocated with name '_mb_read_coils_mask_65536_51'
;i                         Allocated with name '_mb_read_coils_i_65536_51'
;startaddr                 Allocated with name '_mb_read_coils_startaddr_65536_51'
;numcoils                  Allocated with name '_mb_read_coils_numcoils_65536_51'
;__1310720026              Allocated with name '_mb_read_coils___1310720026_131072_55'
;val                       Allocated with name '_mb_read_coils_val_196608_56'
;__1310720029              Allocated with name '_mb_read_coils___1310720029_131072_58'
;val                       Allocated with name '_mb_read_coils_val_196608_59'
;------------------------------------------------------------
;	mb_ds1621_if.c:39: uint8_t mb_read_coils(void)
;	-----------------------------------------
;	 function mb_read_coils
;	-----------------------------------------
_mb_read_coils:
;	mb_ds1621_if.c:43: uint8_t mask = 0;
	mov	dptr,#_mb_read_coils_mask_65536_51
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:48: startaddr = u16swap(modbus.request.u.RdCoils.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ds1621_if.c:49: numcoils = u16swap(modbus.request.u.RdCoils.NumCoils);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ds1621_if.c:54: if ((numcoils < MB_RD_MIN_NUM_COILS) || (numcoils >MB_RD_MAX_NUM_COILS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0xd0
	subb	a,r2
	mov	a,#0x07
	subb	a,r3
	jnc	00102$
00101$:
;	mb_ds1621_if.c:55: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ds1621_if.c:57: if ((startaddr > (DS1621_MAX_COILS-1)) || (numcoils > (DS1621_MAX_COILS - startaddr)))
	clr	c
	mov	a,#0x07
	subb	a,r6
	clr	a
	subb	a,r7
	jc	00104$
	mov	a,#0x08
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00105$
00104$:
;	mb_ds1621_if.c:58: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_ds1621_if.c:60: if (ds1621_get_config(DS1621_ADDR, &value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_read_coils_value_65536_51
	movx	@dptr,a
	mov	a,#(_mb_read_coils_value_65536_51 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	lcall	_ds1621_get_config
	mov	a,dpl
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jz	00109$
;	mb_ds1621_if.c:61: value >>= startaddr;
	mov	dptr,#_mb_read_coils_value_65536_51
	movx	a,@dptr
	mov	b,r6
	inc	b
	sjmp	00145$
00144$:
	clr	c
	rrc	a
00145$:
	djnz	b,00144$
	mov	dptr,#_mb_read_coils_value_65536_51
	movx	@dptr,a
;	mb_ds1621_if.c:62: for(i=0;i<numcoils;i++){
	mov	r7,#0x00
00114$:
	mov	ar3,r7
	mov	r6,#0x00
	clr	c
	mov	a,r3
	subb	a,r4
	mov	a,r6
	subb	a,r5
	jnc	00107$
;	mb_ds1621_if.c:63: mask += (1<<i);
	mov	ar6,r7
	mov	b,r6
	inc	b
	mov	a,#0x01
	sjmp	00149$
00147$:
	add	a,acc
00149$:
	djnz	b,00147$
	mov	r6,a
	mov	dptr,#_mb_read_coils_mask_65536_51
	movx	a,@dptr
	mov	r3,a
	add	a,r6
	movx	@dptr,a
;	mb_ds1621_if.c:62: for(i=0;i<numcoils;i++){
	inc	r7
	sjmp	00114$
00107$:
;	mb_ds1621_if.c:65: value &= mask;
	mov	dptr,#_mb_read_coils_value_65536_51
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_mb_read_coils_mask_65536_51
	movx	a,@dptr
	mov	dptr,#_mb_read_coils_value_65536_51
	anl	a,r7
	movx	@dptr,a
;	mb_ds1621_if.c:66: modbus.response.u.RdCoils.Count = 1;            // "Byte Count" -> 8Bits config value, therefore only a max/min of one byte
	mov	dptr,#(_modbus + 0x0130)
	mov	a,#0x01
	movx	@dptr,a
;	mb_ds1621_if.c:67: modbus.response.u.RdCoils.Status[0] = value;    // "Coil Status"
	mov	dptr,#_mb_read_coils_value_65536_51
	movx	a,@dptr
	mov	dptr,#(_modbus + 0x0131)
	movx	@dptr,a
;	mb_ds1621_if.c:68: mb_set_data_length(2);                          // 2 bytes: 1x "Byte Count" and 1x "Config"
	mov	dptr,#0x0002
	lcall	_mb_set_data_length
;	mb_ds1621_if.c:69: ret = MB_OK;
	mov	dptr,#_mb_read_coils_ret_65536_51
	clr	a
	movx	@dptr,a
	sjmp	00110$
00109$:
;	mb_ds1621_if.c:70: } else ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_read_coils_ret_65536_51
	mov	a,#0x04
	movx	@dptr,a
00110$:
;	mb_ds1621_if.c:71: return(ret);
	mov	dptr,#_mb_read_coils_ret_65536_51
	movx	a,@dptr
;	mb_ds1621_if.c:72: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_single_coil'
;------------------------------------------------------------
;__1310720034              Allocated with name '_mb_write_single_coil___1310720034_131072_62'
;__1310720031              Allocated with name '_mb_write_single_coil___1310720031_131072_62'
;ret                       Allocated with name '_mb_write_single_coil_ret_65536_62'
;addr                      Allocated with name '_mb_write_single_coil_addr_65536_62'
;coilvalue                 Allocated with name '_mb_write_single_coil_coilvalue_65536_62'
;value                     Allocated with name '_mb_write_single_coil_value_65536_62'
;__1310720032              Allocated with name '_mb_write_single_coil___1310720032_131072_68'
;val                       Allocated with name '_mb_write_single_coil_val_196608_69'
;__1310720035              Allocated with name '_mb_write_single_coil___1310720035_131072_71'
;val                       Allocated with name '_mb_write_single_coil_val_196608_72'
;------------------------------------------------------------
;	mb_ds1621_if.c:74: uint8_t mb_write_single_coil(void)
;	-----------------------------------------
;	 function mb_write_single_coil
;	-----------------------------------------
_mb_write_single_coil:
;	mb_ds1621_if.c:81: addr = u16swap(modbus.request.u.WrSingleCoil.Addr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ds1621_if.c:82: coilvalue = u16swap(modbus.request.u.WrSingleCoil.Value);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ds1621_if.c:90: if (!((coilvalue == MB_COIL_LOW) || (coilvalue == MB_COIL_HIGH))){
	mov	a,r4
	orl	a,r5
	jz	00102$
	mov	ar2,r4
	mov	ar3,r5
	cjne	r2,#0x00,00142$
	cjne	r3,#0xff,00142$
	sjmp	00102$
00142$:
;	mb_ds1621_if.c:91: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ds1621_if.c:94: if (addr > (DS1621_MAX_COILS-1))
	clr	c
	mov	a,#0x07
	subb	a,r6
	clr	a
	subb	a,r7
	jnc	00105$
;	mb_ds1621_if.c:95: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_ds1621_if.c:97: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_coil_ret_65536_62
	mov	a,#0x04
	movx	@dptr,a
;	mb_ds1621_if.c:98: if (ds1621_get_config(DS1621_ADDR, &value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_write_single_coil_value_65536_62
	movx	@dptr,a
	mov	a,#(_mb_write_single_coil_value_65536_62 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	lcall	_ds1621_get_config
	mov	a,dpl
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jz	00112$
;	mb_ds1621_if.c:100: if (coilvalue == MB_COIL_HIGH) {
	cjne	r4,#0x00,00107$
	cjne	r5,#0xff,00107$
;	mb_ds1621_if.c:101: value |= (1 << ((uint8_t)(addr & 0x07)));
	mov	ar5,r6
	anl	ar5,#0x07
	mov	b,r5
	inc	b
	mov	a,#0x01
	sjmp	00149$
00147$:
	add	a,acc
00149$:
	djnz	b,00147$
	mov	r5,a
	mov	dptr,#_mb_write_single_coil_value_65536_62
	movx	a,@dptr
	orl	a,r5
	movx	@dptr,a
	sjmp	00108$
00107$:
;	mb_ds1621_if.c:103: value &= ~(1 << ((uint8_t)(addr & 0x07)));
	anl	ar6,#0x07
	mov	b,r6
	inc	b
	mov	a,#0x01
	sjmp	00152$
00150$:
	add	a,acc
00152$:
	djnz	b,00150$
	cpl	a
	mov	r6,a
	mov	dptr,#_mb_write_single_coil_value_65536_62
	movx	a,@dptr
	anl	a,r6
	movx	@dptr,a
00108$:
;	mb_ds1621_if.c:106: if (ds1621_set_config(DS1621_ADDR, value)) {
	mov	dptr,#_mb_write_single_coil_value_65536_62
	movx	a,@dptr
	mov	dptr,#_ds1621_set_config_PARM_2
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_config
	mov	a,dpl
	jz	00112$
;	mb_ds1621_if.c:107: modbus.response.u.WrSingleCoil.Addr = modbus.request.u.WrSingleCoil.Addr;
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:108: modbus.response.u.WrSingleCoil.Value = modbus.request.u.WrSingleCoil.Value;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:109: mb_set_data_length(4);
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_ds1621_if.c:110: ret = MB_OK;
	mov	dptr,#_mb_write_single_coil_ret_65536_62
	clr	a
	movx	@dptr,a
00112$:
;	mb_ds1621_if.c:113: return(ret);
	mov	dptr,#_mb_write_single_coil_ret_65536_62
	movx	a,@dptr
;	mb_ds1621_if.c:114: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_single_register'
;------------------------------------------------------------
;__1310720040              Allocated with name '_mb_write_single_register___1310720040_131072_75'
;__1310720037              Allocated with name '_mb_write_single_register___1310720037_131072_75'
;ret                       Allocated with name '_mb_write_single_register_ret_65536_75'
;addr                      Allocated with name '_mb_write_single_register_addr_65536_75'
;value                     Allocated with name '_mb_write_single_register_value_65536_75'
;__1310720038              Allocated with name '_mb_write_single_register___1310720038_131072_84'
;val                       Allocated with name '_mb_write_single_register_val_196608_85'
;__1310720041              Allocated with name '_mb_write_single_register___1310720041_131072_87'
;val                       Allocated with name '_mb_write_single_register_val_196608_88'
;------------------------------------------------------------
;	mb_ds1621_if.c:116: uint8_t mb_write_single_register(void)
;	-----------------------------------------
;	 function mb_write_single_register
;	-----------------------------------------
_mb_write_single_register:
;	mb_ds1621_if.c:122: addr = u16swap(modbus.request.u.WrSingleReg.Addr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r7,a
	mov	r5,a
	mov	ar4,r6
	clr	a
	mov	r3,a
	mov	r2,a
	mov	a,r5
	orl	ar3,a
	mov	a,r2
	orl	ar4,a
;	mb_ds1621_if.c:123: value = u16swap(modbus.request.u.WrSingleReg.Value);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r2,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r1,a
	mov	ar5,r2
	mov	r2,#0x00
	mov	ar0,r1
	mov	r1,#0x00
	mov	a,r0
	orl	ar2,a
	mov	a,r1
	orl	ar5,a
;	mb_ds1621_if.c:130: modbus.response.u.WrSingleReg.Addr = modbus.request.u.WrSingleReg.Addr;
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:131: modbus.response.u.WrSingleReg.Value = modbus.request.u.WrSingleReg.Value;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:132: mb_set_data_length(4);
	mov	dptr,#0x0004
	push	ar5
	push	ar4
	push	ar3
	push	ar2
	lcall	_mb_set_data_length
	pop	ar2
	pop	ar3
	pop	ar4
	pop	ar5
;	mb_ds1621_if.c:133: ret = MB_OK;
	mov	dptr,#_mb_write_single_register_ret_65536_75
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:135: switch(addr) {
	mov	ar6,r3
	mov	ar7,r4
	clr	c
	mov	a,#0x03
	subb	a,r3
	clr	a
	subb	a,r4
	jnc	00152$
	ljmp	00118$
00152$:
	mov	a,r6
	add	a,r6
;	mb_ds1621_if.c:136: case 0x00:
	mov	dptr,#00153$
	jmp	@a+dptr
00153$:
	sjmp	00101$
	sjmp	00104$
	sjmp	00107$
	sjmp	00110$
00101$:
;	mb_ds1621_if.c:137: if (!ds1621_set_config(DS1621_ADDR, (uint8_t)(value & 0x00FF))) {
	mov	dptr,#_ds1621_set_config_PARM_2
	mov	a,r2
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_config
	mov	a,dpl
	jnz	00119$
;	mb_ds1621_if.c:138: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_75
	mov	a,#0x04
	movx	@dptr,a
;	mb_ds1621_if.c:140: break;
;	mb_ds1621_if.c:141: case 0x01:
	sjmp	00119$
00104$:
;	mb_ds1621_if.c:142: if (!ds1621_set_TH(DS1621_ADDR, value)) {
	mov	dptr,#_ds1621_set_TH_PARM_2
	mov	a,r2
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_TH
	mov	a,dpl
	jnz	00119$
;	mb_ds1621_if.c:143: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_75
	mov	a,#0x04
	movx	@dptr,a
;	mb_ds1621_if.c:145: break;
;	mb_ds1621_if.c:146: case 0x02:
	sjmp	00119$
00107$:
;	mb_ds1621_if.c:147: if (!ds1621_set_TL(DS1621_ADDR, value)) {
	mov	dptr,#_ds1621_set_TL_PARM_2
	mov	a,r2
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_TL
	mov	a,dpl
	jnz	00119$
;	mb_ds1621_if.c:148: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_75
	mov	a,#0x04
	movx	@dptr,a
;	mb_ds1621_if.c:150: break;
;	mb_ds1621_if.c:151: case 0x03: // write-only register
	sjmp	00119$
00110$:
;	mb_ds1621_if.c:152: if (value == 0xFFFF) {
	cjne	r2,#0xff,00116$
	cjne	r5,#0xff,00116$
;	mb_ds1621_if.c:153: if (!ds1621_start_convert(DS1621_ADDR)) {
	mov	dpl,#0x92
	lcall	_ds1621_start_convert
	mov	a,dpl
	jnz	00119$
;	mb_ds1621_if.c:154: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_75
	mov	a,#0x04
	movx	@dptr,a
	sjmp	00119$
00116$:
;	mb_ds1621_if.c:157: if (!ds1621_stop_convert(DS1621_ADDR)) {
	mov	dpl,#0x92
	lcall	_ds1621_stop_convert
	mov	a,dpl
	jnz	00119$
;	mb_ds1621_if.c:158: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_75
	mov	a,#0x04
	movx	@dptr,a
;	mb_ds1621_if.c:161: break;
;	mb_ds1621_if.c:162: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00119$
00118$:
	mov	dptr,#_mb_write_single_register_ret_65536_75
	mov	a,#0x02
	movx	@dptr,a
;	mb_ds1621_if.c:164: }
00119$:
;	mb_ds1621_if.c:165: return(ret);
	mov	dptr,#_mb_write_single_register_ret_65536_75
	movx	a,@dptr
;	mb_ds1621_if.c:166: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_multiple_coils'
;------------------------------------------------------------
;__1310720046              Allocated with name '_mb_write_multiple_coils___1310720046_131072_91'
;__1310720043              Allocated with name '_mb_write_multiple_coils___1310720043_131072_91'
;ret                       Allocated with name '_mb_write_multiple_coils_ret_65536_91'
;startaddr                 Allocated with name '_mb_write_multiple_coils_startaddr_65536_91'
;numcoils                  Allocated with name '_mb_write_multiple_coils_numcoils_65536_91'
;coils_state               Allocated with name '_mb_write_multiple_coils_coils_state_65536_91'
;value                     Allocated with name '_mb_write_multiple_coils_value_65536_91'
;mask                      Allocated with name '_mb_write_multiple_coils_mask_65536_91'
;i                         Allocated with name '_mb_write_multiple_coils_i_65536_91'
;__1310720044              Allocated with name '_mb_write_multiple_coils___1310720044_131072_98'
;val                       Allocated with name '_mb_write_multiple_coils_val_196608_99'
;__1310720047              Allocated with name '_mb_write_multiple_coils___1310720047_131072_101'
;val                       Allocated with name '_mb_write_multiple_coils_val_196608_102'
;------------------------------------------------------------
;	mb_ds1621_if.c:168: uint8_t mb_write_multiple_coils(void)
;	-----------------------------------------
;	 function mb_write_multiple_coils
;	-----------------------------------------
_mb_write_multiple_coils:
;	mb_ds1621_if.c:175: uint8_t mask = 0;
	mov	dptr,#_mb_write_multiple_coils_mask_65536_91
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:178: startaddr = u16swap(modbus.request.u.WrMultCoils.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ds1621_if.c:179: numcoils = u16swap(modbus.request.u.WrMultCoils.NumCoils);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ds1621_if.c:186: if ((numcoils < MB_WR_MIN_NUM_COILS) || (numcoils > MB_WR_MAX_NUM_COILS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0xb0
	subb	a,r2
	mov	a,#0x07
	subb	a,r3
	jnc	00102$
00101$:
;	mb_ds1621_if.c:187: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ds1621_if.c:189: if (modbus.src_socket.rxlen < MB_WRITE_MIN_PACKET_SIZE)
	mov	dptr,#(_modbus + 0x000b)
	movx	a,@dptr
	mov	r3,a
	cjne	r3,#0x0e,00160$
00160$:
	jnc	00105$
;	mb_ds1621_if.c:190: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00105$:
;	mb_ds1621_if.c:192: if (modbus.request.u.WrMultCoils.Count != (modbus.src_socket.rxlen - (MB_WRITE_MIN_PACKET_SIZE-1)))
	mov	dptr,#(_modbus + 0x0034)
	movx	a,@dptr
	mov	r2,a
	mov	ar1,r3
	mov	r3,#0x00
	mov	a,r1
	add	a,#0xf3
	mov	r1,a
	mov	a,r3
	addc	a,#0xff
	mov	r3,a
	mov	ar0,r2
	mov	r2,#0x00
	mov	a,r0
	cjne	a,ar1,00162$
	mov	a,r2
	cjne	a,ar3,00162$
	sjmp	00107$
00162$:
;	mb_ds1621_if.c:193: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00107$:
;	mb_ds1621_if.c:195: if ((startaddr > (DS1621_MAX_COILS-1)) || (numcoils > (DS1621_MAX_COILS - startaddr)))
	clr	c
	mov	a,#0x07
	subb	a,r6
	clr	a
	subb	a,r7
	jc	00108$
	mov	a,#0x08
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00109$
00108$:
;	mb_ds1621_if.c:196: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00109$:
;	mb_ds1621_if.c:198: coils_state = modbus.request.u.WrMultCoils.Value[0];
	mov	dptr,#(_modbus + 0x0035)
	movx	a,@dptr
	mov	r3,a
;	mb_ds1621_if.c:200: if (ds1621_get_config(DS1621_ADDR, &value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_write_multiple_coils_value_65536_91
	movx	@dptr,a
	mov	a,#(_mb_write_multiple_coils_value_65536_91 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_ds1621_get_config
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00165$
	ljmp	00116$
00165$:
;	mb_ds1621_if.c:201: for(i=0;i<numcoils;i++){
	mov	r2,#0x00
00121$:
	mov	ar0,r2
	mov	r1,#0x00
	clr	c
	mov	a,r0
	subb	a,r4
	mov	a,r1
	subb	a,r5
	jnc	00111$
;	mb_ds1621_if.c:202: mask += (1<<i);
	mov	ar1,r2
	mov	b,r1
	inc	b
	mov	a,#0x01
	sjmp	00169$
00167$:
	add	a,acc
00169$:
	djnz	b,00167$
	mov	r1,a
	mov	dptr,#_mb_write_multiple_coils_mask_65536_91
	movx	a,@dptr
	mov	r0,a
	add	a,r1
	movx	@dptr,a
;	mb_ds1621_if.c:201: for(i=0;i<numcoils;i++){
	inc	r2
	sjmp	00121$
00111$:
;	mb_ds1621_if.c:204: mask <<= startaddr;
	mov	dptr,#_mb_write_multiple_coils_mask_65536_91
	movx	a,@dptr
	mov	r5,a
	mov	b,r6
	inc	b
	mov	a,r5
	sjmp	00172$
00170$:
	add	a,acc
00172$:
	djnz	b,00170$
	mov	dptr,#_mb_write_multiple_coils_mask_65536_91
	movx	@dptr,a
;	mb_ds1621_if.c:205: value &= ~mask;
	movx	a,@dptr
	mov	r7,a
	cpl	a
	mov	r5,a
	mov	dptr,#_mb_write_multiple_coils_value_65536_91
	movx	a,@dptr
	anl	a,r5
	movx	@dptr,a
;	mb_ds1621_if.c:206: coils_state <<= startaddr;
	mov	b,r6
	inc	b
	mov	a,r3
	sjmp	00175$
00173$:
	add	a,acc
00175$:
	djnz	b,00173$
;	mb_ds1621_if.c:207: coils_state &= mask;
	anl	ar7,a
;	mb_ds1621_if.c:208: value |= coils_state;
	mov	dptr,#_mb_write_multiple_coils_value_65536_91
	movx	a,@dptr
	orl	a,r7
	movx	@dptr,a
;	mb_ds1621_if.c:210: if (ds1621_set_config(DS1621_ADDR, value)) {
	movx	a,@dptr
	mov	dptr,#_ds1621_set_config_PARM_2
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_config
	mov	a,dpl
	jz	00113$
;	mb_ds1621_if.c:211: modbus.response.u.WrMultCoils.StartAddr = modbus.request.u.WrMultCoils.StartAddr;
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:212: modbus.response.u.WrMultCoils.NumCoils = modbus.request.u.WrMultCoils.NumCoils;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:213: mb_set_data_length(4);
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_ds1621_if.c:214: ret = MB_OK;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_91
	clr	a
	movx	@dptr,a
	sjmp	00117$
00113$:
;	mb_ds1621_if.c:216: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_91
	mov	a,#0x04
	movx	@dptr,a
	sjmp	00117$
00116$:
;	mb_ds1621_if.c:219: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_91
	mov	a,#0x04
	movx	@dptr,a
00117$:
;	mb_ds1621_if.c:221: return(ret);
	mov	dptr,#_mb_write_multiple_coils_ret_65536_91
	movx	a,@dptr
;	mb_ds1621_if.c:222: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_mask_write_register'
;------------------------------------------------------------
;__1310720055              Allocated with name '_mb_mask_write_register___1310720055_131072_105'
;__1310720052              Allocated with name '_mb_mask_write_register___1310720052_131072_105'
;__1310720049              Allocated with name '_mb_mask_write_register___1310720049_131072_105'
;ret                       Allocated with name '_mb_mask_write_register_ret_65536_105'
;value                     Allocated with name '_mb_mask_write_register_value_65536_105'
;addr                      Allocated with name '_mb_mask_write_register_addr_65536_105'
;andmask                   Allocated with name '_mb_mask_write_register_andmask_65536_105'
;ormask                    Allocated with name '_mb_mask_write_register_ormask_65536_105'
;__1310720050              Allocated with name '_mb_mask_write_register___1310720050_131072_110'
;val                       Allocated with name '_mb_mask_write_register_val_196608_111'
;__1310720053              Allocated with name '_mb_mask_write_register___1310720053_131072_113'
;val                       Allocated with name '_mb_mask_write_register_val_196608_114'
;__1310720056              Allocated with name '_mb_mask_write_register___1310720056_131072_116'
;val                       Allocated with name '_mb_mask_write_register_val_196608_117'
;------------------------------------------------------------
;	mb_ds1621_if.c:224: uint8_t mb_mask_write_register(void)
;	-----------------------------------------
;	 function mb_mask_write_register
;	-----------------------------------------
_mb_mask_write_register:
;	mb_ds1621_if.c:232: addr = u16swap(modbus.request.u.MaskWrReg.Addr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ds1621_if.c:233: andmask = u16swap(modbus.request.u.MaskWrReg.AndMask);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r3,a
	clr	a
	orl	a,r3
	mov	r5,a
;	mb_ds1621_if.c:234: ormask = u16swap(modbus.request.u.MaskWrReg.OrMask);
	mov	dptr,#(_modbus + 0x0034)
	movx	a,@dptr
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r2,a
	clr	a
	orl	a,r2
	mov	r4,a
;	mb_ds1621_if.c:240: if (addr != 0) //only to be used with register 0 // CONFIG Regsiter
	mov	a,r6
	orl	a,r7
	jz	00102$
;	mb_ds1621_if.c:241: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00102$:
;	mb_ds1621_if.c:243: if (ds1621_get_config(DS1621_ADDR, &value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_mask_write_register_value_65536_105
	movx	@dptr,a
	mov	a,#(_mb_mask_write_register_value_65536_105 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar5
	push	ar4
	lcall	_ds1621_get_config
	mov	a,dpl
	pop	ar4
	pop	ar5
	jz	00107$
;	mb_ds1621_if.c:244: value = (value & andmask) | (ormask & (~andmask));
	mov	dptr,#_mb_mask_write_register_value_65536_105
	movx	a,@dptr
	mov	r7,a
	mov	a,r5
	anl	ar7,a
	mov	a,r5
	cpl	a
	mov	r5,a
	mov	a,r4
	anl	a,r5
	mov	dptr,#_mb_mask_write_register_value_65536_105
	orl	a,r7
	movx	@dptr,a
;	mb_ds1621_if.c:245: if (ds1621_set_config(DS1621_ADDR, value)) {
	movx	a,@dptr
	mov	dptr,#_ds1621_set_config_PARM_2
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_config
	mov	a,dpl
	jz	00104$
;	mb_ds1621_if.c:246: modbus.response.u.MaskWrReg.Addr = modbus.request.u.MaskWrReg.Addr;
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:247: modbus.response.u.MaskWrReg.AndMask = modbus.request.u.MaskWrReg.AndMask;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:248: modbus.response.u.MaskWrReg.OrMask = modbus.request.u.MaskWrReg.OrMask;
	mov	dptr,#(_modbus + 0x0034)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0134)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:249: mb_set_data_length(6);
	mov	dptr,#0x0006
	lcall	_mb_set_data_length
;	mb_ds1621_if.c:250: ret = MB_OK;
	mov	dptr,#_mb_mask_write_register_ret_65536_105
	clr	a
	movx	@dptr,a
	sjmp	00108$
00104$:
;	mb_ds1621_if.c:252: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_mask_write_register_ret_65536_105
	mov	a,#0x04
	movx	@dptr,a
	sjmp	00108$
00107$:
;	mb_ds1621_if.c:255: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_mask_write_register_ret_65536_105
	mov	a,#0x04
	movx	@dptr,a
00108$:
;	mb_ds1621_if.c:257: return(ret);
	mov	dptr,#_mb_mask_write_register_ret_65536_105
	movx	a,@dptr
;	mb_ds1621_if.c:258: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_holding_registers'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_read_holding_registers_sloc0_1_0'
;__1310720061              Allocated with name '_mb_read_holding_registers___1310720061_131072_120'
;__1310720058              Allocated with name '_mb_read_holding_registers___1310720058_131072_120'
;ret                       Allocated with name '_mb_read_holding_registers_ret_65536_120'
;addr                      Allocated with name '_mb_read_holding_registers_addr_65536_120'
;numregs                   Allocated with name '_mb_read_holding_registers_numregs_65536_120'
;len                       Allocated with name '_mb_read_holding_registers_len_65536_120'
;i                         Allocated with name '_mb_read_holding_registers_i_65536_120'
;u8value                   Allocated with name '_mb_read_holding_registers_u8value_65536_120'
;u16value                  Allocated with name '_mb_read_holding_registers_u16value_65536_120'
;__1310720059              Allocated with name '_mb_read_holding_registers___1310720059_131072_127'
;val                       Allocated with name '_mb_read_holding_registers_val_196608_128'
;__1310720062              Allocated with name '_mb_read_holding_registers___1310720062_131072_130'
;val                       Allocated with name '_mb_read_holding_registers_val_196608_131'
;__3932160064              Allocated with name '_mb_read_holding_registers___3932160064_393216_124'
;__3932160065              Allocated with name '_mb_read_holding_registers___3932160065_393216_133'
;val                       Allocated with name '_mb_read_holding_registers_val_458752_134'
;__3932160067              Allocated with name '_mb_read_holding_registers___3932160067_393216_125'
;__3932160068              Allocated with name '_mb_read_holding_registers___3932160068_393216_136'
;val                       Allocated with name '_mb_read_holding_registers_val_458752_137'
;__3932160070              Allocated with name '_mb_read_holding_registers___3932160070_393216_126'
;__3932160071              Allocated with name '_mb_read_holding_registers___3932160071_393216_139'
;val                       Allocated with name '_mb_read_holding_registers_val_458752_140'
;------------------------------------------------------------
;	mb_ds1621_if.c:260: uint8_t mb_read_holding_registers(void)
;	-----------------------------------------
;	 function mb_read_holding_registers
;	-----------------------------------------
_mb_read_holding_registers:
;	mb_ds1621_if.c:270: addr = u16swap(modbus.request.u.RdHoldingRegs.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ds1621_if.c:271: numregs = u16swap(modbus.request.u.RdHoldingRegs.NumRegisters);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ds1621_if.c:276: if ((numregs < MB_RD_MIN_NUM_REGS) || (numregs > MB_RD_MAX_NUM_REGS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0x7d
	subb	a,r2
	clr	a
	subb	a,r3
	jnc	00102$
00101$:
;	mb_ds1621_if.c:277: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ds1621_if.c:279: if ((addr > DS1621_END_HOLD_REG) || (numregs > ((DS1621_END_HOLD_REG+1) - addr)))
	mov	ar2,r6
	mov	ar3,r7
	clr	c
	mov	a,#0x02
	subb	a,r2
	clr	a
	subb	a,r3
	jc	00104$
	mov	a,#0x03
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00105$
00104$:
;	mb_ds1621_if.c:280: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_ds1621_if.c:282: modbus.response.u.RdHoldingRegs.Count = (uint8_t)(numregs * 2);
	mov	ar3,r4
	mov	a,r3
	add	a,r3
	mov	dptr,#(_modbus + 0x0130)
	movx	@dptr,a
;	mb_ds1621_if.c:283: len = 1;
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	mov	a,#0x01
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:284: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_read_holding_registers_ret_65536_120
	mov	a,#0x04
	movx	@dptr,a
;	mb_ds1621_if.c:285: for (i = addr; i<(addr + numregs); i++) {
	mov	ar3,r6
	mov	a,r4
	add	a,r6
	mov	r4,a
	mov	a,r5
	addc	a,r7
	mov	r5,a
00127$:
	mov	ar1,r3
	mov	r2,#0x00
	clr	c
	mov	a,r1
	subb	a,r4
	mov	a,r2
	subb	a,r5
	jc	00180$
	ljmp	00120$
00180$:
;	mb_ds1621_if.c:286: switch(i) {
	cjne	r3,#0x00,00181$
	sjmp	00107$
00181$:
	cjne	r3,#0x01,00182$
	ljmp	00110$
00182$:
	cjne	r3,#0x02,00183$
	ljmp	00113$
00183$:
	ljmp	00116$
;	mb_ds1621_if.c:287: case 0x00:
00107$:
;	mb_ds1621_if.c:288: if (ds1621_get_config(DS1621_ADDR, &u8value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_read_holding_registers_u8value_65536_120
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers_u8value_65536_120 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_ds1621_get_config
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00184$
	ljmp	00117$
00184$:
;	mb_ds1621_if.c:289: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_mb_read_holding_registers_u8value_65536_120
	movx	a,@dptr
	mov	r0,a
	mov	r5,#0x00
;	mb_ds1621_if.c:265: uint16_t len;
	mov	ar4,r5
	mov	ar5,r0
;	1-genFromRTrack replaced	mov	_mb_read_holding_registers_sloc0_1_0,#0x00
	mov	_mb_read_holding_registers_sloc0_1_0,r4
	mov	(_mb_read_holding_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_holding_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_holding_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_ds1621_if.c:289: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:290: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:291: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ds1621_if.c:292: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_120
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:294: break;
	pop	ar5
	pop	ar4
	ljmp	00117$
;	mb_ds1621_if.c:295: case 0x01:
00110$:
;	mb_ds1621_if.c:296: if (ds1621_get_TH(DS1621_ADDR, &u16value)) {
	mov	dptr,#_ds1621_get_TH_PARM_2
	mov	a,#_mb_read_holding_registers_u16value_65536_120
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers_u16value_65536_120 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_ds1621_get_TH
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00185$
	ljmp	00117$
00185$:
;	mb_ds1621_if.c:297: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_mb_read_holding_registers_u16value_65536_120
	movx	a,@dptr
	mov	r0,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r4,a
	mov	ar5,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_read_holding_registers_sloc0_1_0,#0x00
	mov	_mb_read_holding_registers_sloc0_1_0,r0
	mov	(_mb_read_holding_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_holding_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_holding_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_ds1621_if.c:297: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:298: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:299: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ds1621_if.c:300: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_120
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:302: break;
	pop	ar5
	pop	ar4
	ljmp	00117$
;	mb_ds1621_if.c:303: case 0x02:
00113$:
;	mb_ds1621_if.c:304: if (ds1621_get_TL(DS1621_ADDR, &u16value)) {
	mov	dptr,#_ds1621_get_TL_PARM_2
	mov	a,#_mb_read_holding_registers_u16value_65536_120
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers_u16value_65536_120 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_ds1621_get_TL
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00186$
	ljmp	00117$
00186$:
;	mb_ds1621_if.c:305: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_mb_read_holding_registers_u16value_65536_120
	movx	a,@dptr
	mov	r0,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r4,a
	mov	ar5,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_read_holding_registers_sloc0_1_0,#0x00
	mov	_mb_read_holding_registers_sloc0_1_0,r0
	mov	(_mb_read_holding_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_holding_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_holding_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_ds1621_if.c:305: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:306: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:307: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_120
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ds1621_if.c:308: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_120
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:310: break;
	pop	ar5
	pop	ar4
;	mb_ds1621_if.c:311: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00117$
00116$:
	mov	dptr,#_mb_read_holding_registers_ret_65536_120
	mov	a,#0x02
	movx	@dptr,a
;	mb_ds1621_if.c:313: }
00117$:
;	mb_ds1621_if.c:314: if(ret != MB_OK)
	mov	dptr,#_mb_read_holding_registers_ret_65536_120
	movx	a,@dptr
	jnz	00120$
;	mb_ds1621_if.c:285: for (i = addr; i<(addr + numregs); i++) {
	inc	r3
	ljmp	00127$
00120$:
;	mb_ds1621_if.c:317: return(ret);
	mov	dptr,#_mb_read_holding_registers_ret_65536_120
	movx	a,@dptr
;	mb_ds1621_if.c:318: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_input_registers'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_read_input_registers_sloc0_1_0'
;__1310720076              Allocated with name '_mb_read_input_registers___1310720076_131072_143'
;__1310720073              Allocated with name '_mb_read_input_registers___1310720073_131072_143'
;ret                       Allocated with name '_mb_read_input_registers_ret_65536_143'
;addr                      Allocated with name '_mb_read_input_registers_addr_65536_143'
;numregs                   Allocated with name '_mb_read_input_registers_numregs_65536_143'
;len                       Allocated with name '_mb_read_input_registers_len_65536_143'
;i                         Allocated with name '_mb_read_input_registers_i_65536_143'
;u8value                   Allocated with name '_mb_read_input_registers_u8value_65536_143'
;u16value                  Allocated with name '_mb_read_input_registers_u16value_65536_143'
;temp                      Allocated with name '_mb_read_input_registers_temp_65536_143'
;last_result               Allocated with name '_mb_read_input_registers_last_result_65536_143'
;__1310720074              Allocated with name '_mb_read_input_registers___1310720074_131072_153'
;val                       Allocated with name '_mb_read_input_registers_val_196608_154'
;__1310720077              Allocated with name '_mb_read_input_registers___1310720077_131072_156'
;val                       Allocated with name '_mb_read_input_registers_val_196608_157'
;__3932160079              Allocated with name '_mb_read_input_registers___3932160079_393216_148'
;__3932160080              Allocated with name '_mb_read_input_registers___3932160080_393216_159'
;val                       Allocated with name '_mb_read_input_registers_val_458752_160'
;__3932160082              Allocated with name '_mb_read_input_registers___3932160082_393216_149'
;__3932160083              Allocated with name '_mb_read_input_registers___3932160083_393216_162'
;val                       Allocated with name '_mb_read_input_registers_val_458752_163'
;__3932160085              Allocated with name '_mb_read_input_registers___3932160085_393216_150'
;__3932160086              Allocated with name '_mb_read_input_registers___3932160086_393216_165'
;val                       Allocated with name '_mb_read_input_registers_val_458752_166'
;__3932160088              Allocated with name '_mb_read_input_registers___3932160088_393216_151'
;__3932160089              Allocated with name '_mb_read_input_registers___3932160089_393216_168'
;val                       Allocated with name '_mb_read_input_registers_val_458752_169'
;__3932160091              Allocated with name '_mb_read_input_registers___3932160091_393216_152'
;__3932160092              Allocated with name '_mb_read_input_registers___3932160092_393216_171'
;val                       Allocated with name '_mb_read_input_registers_val_458752_172'
;------------------------------------------------------------
;	mb_ds1621_if.c:320: uint8_t mb_read_input_registers(void)
;	-----------------------------------------
;	 function mb_read_input_registers
;	-----------------------------------------
_mb_read_input_registers:
;	mb_ds1621_if.c:334: addr = u16swap(modbus.request.u.RdInputRegs.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ds1621_if.c:335: numregs = u16swap(modbus.request.u.RdInputRegs.NumRegisters);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ds1621_if.c:340: if ((numregs < MB_RD_MIN_NUM_REGS) || (numregs > MB_RD_MAX_NUM_REGS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0x7d
	subb	a,r2
	clr	a
	subb	a,r3
	jnc	00102$
00101$:
;	mb_ds1621_if.c:341: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ds1621_if.c:343: if ((addr < DS1621_START_INPUT_REG) || (addr > DS1621_END_INPUT_REG)) {
	mov	ar0,r6
	mov	ar1,r7
	clr	c
	mov	a,r0
	subb	a,#0x04
	mov	a,r1
	subb	a,#0x00
	jc	00104$
	mov	a,#0x08
	subb	a,r0
	clr	a
	subb	a,r1
	jnc	00105$
00104$:
;	mb_ds1621_if.c:344: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_ds1621_if.c:347: if (numregs > ((DS1621_END_INPUT_REG - DS1621_START_INPUT_REG + 1) - (addr - DS1621_START_INPUT_REG)))
	mov	a,r0
	add	a,#0xfc
	mov	r0,a
	mov	a,r1
	addc	a,#0xff
	mov	r1,a
	mov	a,#0x05
	clr	c
	subb	a,r0
	mov	r0,a
	clr	a
	subb	a,r1
	mov	r1,a
	clr	c
	mov	a,r0
	subb	a,r2
	mov	a,r1
	subb	a,r3
	jnc	00108$
;	mb_ds1621_if.c:348: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00108$:
;	mb_ds1621_if.c:350: modbus.response.u.RdInputRegs.Count = (uint8_t)(numregs * 2);
	mov	ar3,r4
	mov	a,r3
	add	a,r3
	mov	dptr,#(_modbus + 0x0130)
	movx	@dptr,a
;	mb_ds1621_if.c:351: len = 1;
	mov	dptr,#_mb_read_input_registers_len_65536_143
	mov	a,#0x01
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:352: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	mov	a,#0x04
	movx	@dptr,a
;	mb_ds1621_if.c:353: for (i = addr; i<(addr + numregs); i++) {
	mov	ar3,r6
	mov	a,r4
	add	a,r6
	mov	r4,a
	mov	a,r5
	addc	a,r7
	mov	r5,a
00137$:
	mov	ar1,r3
	mov	r2,#0x00
	clr	c
	mov	a,r1
	subb	a,r4
	mov	a,r2
	subb	a,r5
	jc	00211$
	ljmp	00128$
00211$:
;	mb_ds1621_if.c:354: switch(i) {
	cjne	r3,#0x04,00212$
	sjmp	00109$
00212$:
	cjne	r3,#0x05,00213$
	ljmp	00112$
00213$:
	cjne	r3,#0x06,00214$
	ljmp	00115$
00214$:
	cjne	r3,#0x07,00215$
	ljmp	00118$
00215$:
	cjne	r3,#0x08,00216$
	ljmp	00121$
00216$:
	ljmp	00124$
;	mb_ds1621_if.c:355: case 0x04:
00109$:
;	mb_ds1621_if.c:356: if (ds1621_read_temp(DS1621_ADDR, &u16value)) {
	mov	dptr,#_ds1621_read_temp_PARM_2
	mov	a,#_mb_read_input_registers_u16value_65536_143
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers_u16value_65536_143 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_ds1621_read_temp
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00217$
	ljmp	00125$
00217$:
;	mb_ds1621_if.c:357: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap(u16value);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_mb_read_input_registers_u16value_65536_143
	movx	a,@dptr
	mov	r0,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r4,a
	mov	ar5,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_read_input_registers_sloc0_1_0,#0x00
	mov	_mb_read_input_registers_sloc0_1_0,r0
	mov	(_mb_read_input_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_input_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_input_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_ds1621_if.c:357: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap(u16value);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:358: len += 2;
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_input_registers_len_65536_143
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:359: mb_set_data_length(len);
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ds1621_if.c:360: ret = MB_OK;
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:362: break;
	pop	ar5
	pop	ar4
	ljmp	00125$
;	mb_ds1621_if.c:363: case 0x05:
00112$:
;	mb_ds1621_if.c:364: if (ds1621_read_counter(DS1621_ADDR, &u8value)) {
	mov	dptr,#_ds1621_read_counter_PARM_2
	mov	a,#_mb_read_input_registers_u8value_65536_143
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers_u8value_65536_143 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_ds1621_read_counter
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00218$
	ljmp	00125$
00218$:
;	mb_ds1621_if.c:365: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_mb_read_input_registers_u8value_65536_143
	movx	a,@dptr
	mov	r0,a
	mov	r5,#0x00
;	mb_ds1621_if.c:265: uint16_t len;
	mov	ar4,r5
	mov	ar5,r0
;	1-genFromRTrack replaced	mov	_mb_read_input_registers_sloc0_1_0,#0x00
	mov	_mb_read_input_registers_sloc0_1_0,r4
	mov	(_mb_read_input_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_input_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_input_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_ds1621_if.c:365: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:366: len += 2;
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_input_registers_len_65536_143
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:367: mb_set_data_length(len);
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ds1621_if.c:368: ret = MB_OK;
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:370: break;
	pop	ar5
	pop	ar4
	ljmp	00125$
;	mb_ds1621_if.c:371: case 0x06:
00115$:
;	mb_ds1621_if.c:372: if (ds1621_read_slope(DS1621_ADDR, &u8value)) {
	mov	dptr,#_ds1621_read_slope_PARM_2
	mov	a,#_mb_read_input_registers_u8value_65536_143
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers_u8value_65536_143 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_ds1621_read_slope
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00219$
	ljmp	00125$
00219$:
;	mb_ds1621_if.c:373: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_mb_read_input_registers_u8value_65536_143
	movx	a,@dptr
	mov	r0,a
	mov	r5,#0x00
;	mb_ds1621_if.c:265: uint16_t len;
	mov	ar4,r5
	mov	ar5,r0
;	1-genFromRTrack replaced	mov	_mb_read_input_registers_sloc0_1_0,#0x00
	mov	_mb_read_input_registers_sloc0_1_0,r4
	mov	(_mb_read_input_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_input_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_input_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_ds1621_if.c:373: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:374: len += 2;
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_input_registers_len_65536_143
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:375: mb_set_data_length(len);
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ds1621_if.c:376: ret = MB_OK;
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:378: break;
	pop	ar5
	pop	ar4
	ljmp	00125$
;	mb_ds1621_if.c:379: case 0x07:
00118$:
;	mb_ds1621_if.c:380: last_result = ds1621_read_hrtemp(DS1621_ADDR, &temp.fl);
	mov	dptr,#_ds1621_read_hrtemp_PARM_2
	mov	a,#_mb_read_input_registers_temp_65536_143
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers_temp_65536_143 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_ds1621_read_hrtemp
	mov	r2,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	mov	dptr,#_mb_read_input_registers_last_result_65536_143
	mov	a,r2
	movx	@dptr,a
;	mb_ds1621_if.c:381: if (last_result) {
	mov	a,r2
	jnz	00220$
	ljmp	00125$
00220$:
;	mb_ds1621_if.c:382: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap(temp.u16[1]);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#(_mb_read_input_registers_temp_65536_143 + 0x0002)
	movx	a,@dptr
	mov	r0,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r4,a
	mov	ar5,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_read_input_registers_sloc0_1_0,#0x00
	mov	_mb_read_input_registers_sloc0_1_0,r0
	mov	(_mb_read_input_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_input_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_input_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_ds1621_if.c:382: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap(temp.u16[1]);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:383: len += 2;
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_input_registers_len_65536_143
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:384: mb_set_data_length(len);
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ds1621_if.c:385: ret = MB_OK;
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:387: break;
	pop	ar5
	pop	ar4
	ljmp	00125$
;	mb_ds1621_if.c:388: case 0x08:
00121$:
;	mb_ds1621_if.c:389: if (last_result) {
	mov	dptr,#_mb_read_input_registers_last_result_65536_143
	movx	a,@dptr
	jnz	00221$
	ljmp	00125$
00221$:
;	mb_ds1621_if.c:390: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap(temp.u16[0]);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_mb_read_input_registers_temp_65536_143
	movx	a,@dptr
	mov	r0,a
	inc	dptr
	movx	a,@dptr
;	mb_ds1621_if.c:265: uint16_t len;
	mov	r4,a
	mov	ar5,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_read_input_registers_sloc0_1_0,#0x00
	mov	_mb_read_input_registers_sloc0_1_0,r0
	mov	(_mb_read_input_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_input_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_input_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_ds1621_if.c:390: modbus.response.u.RdInputRegs.Value[i - addr] = u16swap(temp.u16[0]);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:391: len += 2;
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_input_registers_len_65536_143
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ds1621_if.c:392: mb_set_data_length(len);
	mov	dptr,#_mb_read_input_registers_len_65536_143
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ds1621_if.c:393: ret = MB_OK;
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	clr	a
	movx	@dptr,a
;	mb_ds1621_if.c:395: break;
	pop	ar5
	pop	ar4
;	mb_ds1621_if.c:396: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00125$
00124$:
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	mov	a,#0x02
	movx	@dptr,a
;	mb_ds1621_if.c:398: }
00125$:
;	mb_ds1621_if.c:399: if (ret != MB_OK)
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	movx	a,@dptr
	jnz	00128$
;	mb_ds1621_if.c:353: for (i = addr; i<(addr + numregs); i++) {
	inc	r3
	ljmp	00137$
00128$:
;	mb_ds1621_if.c:402: return(ret);
	mov	dptr,#_mb_read_input_registers_ret_65536_143
	movx	a,@dptr
;	mb_ds1621_if.c:403: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_device_init'
;------------------------------------------------------------
;	mb_ds1621_if.c:405: void mb_device_init(void)
;	-----------------------------------------
;	 function mb_device_init
;	-----------------------------------------
_mb_device_init:
;	mb_ds1621_if.c:407: mb_init(BasicDeviceObjects, sizeof(BasicDeviceObjects), CH_VMTCP);
	mov	dptr,#_mb_init_PARM_2
	mov	a,#0x21
	movx	@dptr,a
	mov	dptr,#_mb_init_PARM_3
	mov	a,#0x03
	movx	@dptr,a
	mov	dptr,#_BasicDeviceObjects
	mov	b,#0x80
	lcall	_mb_init
;	mb_ds1621_if.c:409: mb_register_function(MB_CMD_READ_COILS, mb_read_coils);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_read_coils
	movx	@dptr,a
	mov	a,#(_mb_read_coils >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x01
	lcall	_mb_register_function
;	mb_ds1621_if.c:411: mb_register_function(MB_CMD_READ_HOLDING_REGISTERS, mb_read_holding_registers);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_read_holding_registers
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x03
	lcall	_mb_register_function
;	mb_ds1621_if.c:412: mb_register_function(MB_CMD_READ_INPUT_REGISTERS, mb_read_input_registers);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_read_input_registers
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x04
	lcall	_mb_register_function
;	mb_ds1621_if.c:413: mb_register_function(MB_CMD_WRITE_SINGLE_COIL, mb_write_single_coil);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_single_coil
	movx	@dptr,a
	mov	a,#(_mb_write_single_coil >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x05
	lcall	_mb_register_function
;	mb_ds1621_if.c:414: mb_register_function(MB_CMD_WRITE_SINGLE_REGISTER, mb_write_single_register);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_single_register
	movx	@dptr,a
	mov	a,#(_mb_write_single_register >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x06
	lcall	_mb_register_function
;	mb_ds1621_if.c:415: mb_register_function(MB_CMD_WRITE_MULTIPLE_COILS, mb_write_multiple_coils);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_multiple_coils
	movx	@dptr,a
	mov	a,#(_mb_write_multiple_coils >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x0f
	lcall	_mb_register_function
;	mb_ds1621_if.c:417: mb_register_function(MB_CMD_WRITE_MASK_REGISTER, mb_mask_write_register);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_mask_write_register
	movx	@dptr,a
	mov	a,#(_mb_mask_write_register >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x16
;	mb_ds1621_if.c:419: }
	ljmp	_mb_register_function
	.area CSEG    (CODE)
	.area CONST   (CODE)
_BasicDeviceObjects:
	.db #0x00	; 0
	.db #0x0d	; 13
	.db #0x43	; 67	'C'
	.db #0x6f	; 111	'o'
	.db #0x70	; 112	'p'
	.db #0x74	; 116	't'
	.db #0x6f	; 111	'o'
	.db #0x6e	; 110	'n'
	.db #0x69	; 105	'i'
	.db #0x78	; 120	'x'
	.db #0x20	; 32
	.db #0x47	; 71	'G'
	.db #0x6d	; 109	'm'
	.db #0x62	; 98	'b'
	.db #0x48	; 72	'H'
	.db #0x01	; 1
	.db #0x09	; 9
	.db #0x4d	; 77	'M'
	.db #0x42	; 66	'B'
	.db #0x20	; 32
	.db #0x44	; 68	'D'
	.db #0x53	; 83	'S'
	.db #0x31	; 49	'1'
	.db #0x36	; 54	'6'
	.db #0x32	; 50	'2'
	.db #0x31	; 49	'1'
	.db #0x02	; 2
	.db #0x05	; 5
	.db #0x56	; 86	'V'
	.db #0x31	; 49	'1'
	.db #0x2e	; 46
	.db #0x30	; 48	'0'
	.db #0x30	; 48	'0'
	.area XINIT   (CODE)
	.area CABS    (ABS,CODE)
