;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.12 #12748 (MINGW64)
;--------------------------------------------------------
	.module mb_functions
	.optsdcc -mmcs51 --model-large
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _mb_set_data_length
	.globl _mb_init
	.globl _register_mb_function
	.globl _ds1621_set_config
	.globl _ds1621_get_config
	.globl _ds1621_read_slope
	.globl _ds1621_read_counter
	.globl _ds1621_get_TL
	.globl _ds1621_get_TH
	.globl _ds1621_set_TL
	.globl _ds1621_set_TH
	.globl _ds1621_read_temp
	.globl _ds1621_stop_convert
	.globl _ds1621_start_convert
	.globl _CY
	.globl _AC
	.globl _F0
	.globl _RS1
	.globl _RS0
	.globl _OV
	.globl _F1
	.globl _P
	.globl _FEXT
	.globl _FTMR
	.globl _FNET
	.globl _EEXT
	.globl _ETMR
	.globl _ENET
	.globl _NETTOUT
	.globl _NETSTAT
	.globl _NETRXLEN
	.globl _NETTXLEN
	.globl _NETCON
	.globl _RXCH
	.globl _RXPORT
	.globl _RXPORTH
	.globl _RXPORTL
	.globl _RXIP
	.globl _RXIP3
	.globl _RXIP2
	.globl _RXIP1
	.globl _RXIP0
	.globl _TXCH
	.globl _TXPORT
	.globl _TXPORTH
	.globl _TXPORTL
	.globl _TXIP
	.globl _TXIP3
	.globl _TXIP2
	.globl _TXIP1
	.globl _TXIP0
	.globl _TMR
	.globl _TMRH
	.globl _TMRL
	.globl _TMRCON
	.globl _IFLAG
	.globl _EXTCON
	.globl _I2CSTAT
	.globl _I2CRXLEN
	.globl _I2CTXLEN
	.globl _I2CFREQ
	.globl _SLVADDR
	.globl _I2CCON
	.globl _IE2
	.globl _B
	.globl _ACC
	.globl _PSW
	.globl _DPH
	.globl _DPL
	.globl _SP
	.globl _NETRXBUF
	.globl _NETTXBUF
	.globl _I2CRXBUF
	.globl _I2CTXBUF
	.globl _mb_device_init
	.globl _mb_read_coils
	.globl _mb_write_single_coil
	.globl _mb_write_single_register
	.globl _mb_write_multiple_coils
	.globl _mb_mask_write_register
	.globl _mb_read_holding_registers
	.globl _mb_read_input_registers
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_IE2	=	0x00c0
_I2CCON	=	0x00c1
_SLVADDR	=	0x00c2
_I2CFREQ	=	0x00c3
_I2CTXLEN	=	0x00c4
_I2CRXLEN	=	0x00c5
_I2CSTAT	=	0x00c6
_EXTCON	=	0x00c7
_IFLAG	=	0x00c8
_TMRCON	=	0x00c9
_TMRL	=	0x00ca
_TMRH	=	0x00cb
_TMR	=	0xcbca
_TXIP0	=	0x00a9
_TXIP1	=	0x00aa
_TXIP2	=	0x00ab
_TXIP3	=	0x00ac
_TXIP	=	0xacabaaa9
_TXPORTL	=	0x00ad
_TXPORTH	=	0x00ae
_TXPORT	=	0xaead
_TXCH	=	0x00af
_RXIP0	=	0x00b1
_RXIP1	=	0x00b2
_RXIP2	=	0x00b3
_RXIP3	=	0x00b4
_RXIP	=	0xb4b3b2b1
_RXPORTL	=	0x00b5
_RXPORTH	=	0x00b6
_RXPORT	=	0xb6b5
_RXCH	=	0x00b7
_NETCON	=	0x00b9
_NETTXLEN	=	0x00ba
_NETRXLEN	=	0x00bb
_NETSTAT	=	0x00bc
_NETTOUT	=	0x00bd
;--------------------------------------------------------
; special function bits
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_ENET	=	0x00c0
_ETMR	=	0x00c1
_EEXT	=	0x00c2
_FNET	=	0x00c8
_FTMR	=	0x00c9
_FEXT	=	0x00ca
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
_mb_write_single_register_sloc0_1_0:
	.ds 2
_mb_write_multiple_coils_sloc0_1_0:
	.ds 2
_mb_mask_write_register_sloc0_1_0:
	.ds 2
_mb_read_holding_registers_sloc0_1_0:
	.ds 2
_mb_read_input_registers_sloc0_1_0:
	.ds 2
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; absolute internal ram data
;--------------------------------------------------------
	.area IABS    (ABS,DATA)
	.area IABS    (ABS,DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; paged external ram data
;--------------------------------------------------------
	.area PSEG    (PAG,XDATA)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_I2CTXBUF	=	0x0800
_I2CRXBUF	=	0x0900
_NETTXBUF	=	0x0a00
_NETRXBUF	=	0x0b00
_u16swap_val_65536_33:
	.ds 2
_mb_read_coils_value_65536_63:
	.ds 1
_mb_read_coils_ret_65536_63:
	.ds 1
_mb_read_coils_mask_65536_63:
	.ds 1
_mb_read_coils_startaddr_65536_63:
	.ds 2
_mb_read_coils_numcoils_65536_63:
	.ds 2
_mb_read_coils_val_196608_68:
	.ds 2
_mb_read_coils_val_196608_71:
	.ds 2
_mb_write_single_coil_ret_65536_74:
	.ds 1
_mb_write_single_coil_addr_65536_74:
	.ds 2
_mb_write_single_coil_coilvalue_65536_74:
	.ds 2
_mb_write_single_coil_value_65536_74:
	.ds 1
_mb_write_single_coil_val_196608_81:
	.ds 2
_mb_write_single_coil_val_196608_84:
	.ds 2
_mb_write_single_register_ret_65536_87:
	.ds 1
_mb_write_single_register_addr_65536_87:
	.ds 2
_mb_write_single_register_value_65536_87:
	.ds 2
_mb_write_single_register_val_196608_97:
	.ds 2
_mb_write_single_register_val_196608_100:
	.ds 2
_mb_write_multiple_coils_ret_65536_103:
	.ds 1
_mb_write_multiple_coils_startaddr_65536_103:
	.ds 2
_mb_write_multiple_coils_numcoils_65536_103:
	.ds 2
_mb_write_multiple_coils_coils_state_65536_103:
	.ds 1
_mb_write_multiple_coils_value_65536_103:
	.ds 1
_mb_write_multiple_coils_mask_65536_103:
	.ds 1
_mb_write_multiple_coils_val_196608_111:
	.ds 2
_mb_write_multiple_coils_val_196608_114:
	.ds 2
_mb_mask_write_register_ret_65536_117:
	.ds 1
_mb_mask_write_register_value_65536_117:
	.ds 1
_mb_mask_write_register_andmask_65536_117:
	.ds 2
_mb_mask_write_register_ormask_65536_117:
	.ds 2
_mb_mask_write_register_val_196608_123:
	.ds 2
_mb_mask_write_register_val_196608_126:
	.ds 2
_mb_mask_write_register_val_196608_129:
	.ds 2
_mb_read_holding_registers_ret_65536_132:
	.ds 1
_mb_read_holding_registers_addr_65536_132:
	.ds 2
_mb_read_holding_registers_numregs_65536_132:
	.ds 2
_mb_read_holding_registers_len_65536_132:
	.ds 2
_mb_read_holding_registers_u8value_65536_132:
	.ds 1
_mb_read_holding_registers_u16value_65536_132:
	.ds 2
_mb_read_holding_registers_val_196608_140:
	.ds 2
_mb_read_holding_registers_val_196608_143:
	.ds 2
_mb_read_holding_registers_val_458752_146:
	.ds 2
_mb_read_holding_registers_val_458752_149:
	.ds 2
_mb_read_holding_registers_val_458752_152:
	.ds 2
_mb_read_input_registers_ret_65536_155:
	.ds 1
_mb_read_input_registers_addr_65536_155:
	.ds 2
_mb_read_input_registers_numregs_65536_155:
	.ds 2
_mb_read_input_registers_len_65536_155:
	.ds 2
_mb_read_input_registers_u8value_65536_155:
	.ds 1
_mb_read_input_registers_u16value_65536_155:
	.ds 2
_mb_read_input_registers_val_196608_164:
	.ds 2
_mb_read_input_registers_val_196608_167:
	.ds 2
_mb_read_input_registers_val_458752_170:
	.ds 2
_mb_read_input_registers_val_458752_173:
	.ds 2
_mb_read_input_registers_val_458752_176:
	.ds 2
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area XABS    (ABS,XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
	.area HOME    (CODE)
	.area GSINIT0 (CODE)
	.area GSINIT1 (CODE)
	.area GSINIT2 (CODE)
	.area GSINIT3 (CODE)
	.area GSINIT4 (CODE)
	.area GSINIT5 (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME    (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area HOME    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'u16swap'
;------------------------------------------------------------
;val                       Allocated with name '_u16swap_val_65536_33'
;------------------------------------------------------------
;	mb.h:75: static inline uint16_t u16swap(uint16_t val)
;	-----------------------------------------
;	 function u16swap
;	-----------------------------------------
_u16swap:
	ar7 = 0x07
	ar6 = 0x06
	ar5 = 0x05
	ar4 = 0x04
	ar3 = 0x03
	ar2 = 0x02
	ar1 = 0x01
	ar0 = 0x00
	mov	r7,dph
	mov	a,dpl
	mov	dptr,#_u16swap_val_65536_33
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb.h:77: return ((val >> 8) & 0x00FF) | ((val << 8) & 0xFF00);
	mov	dptr,#_u16swap_val_65536_33
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
	mov	dpl,r6
	mov	dph,r7
;	mb.h:78: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_device_init'
;------------------------------------------------------------
;	mb_functions.c:11: void mb_device_init(void)
;	-----------------------------------------
;	 function mb_device_init
;	-----------------------------------------
_mb_device_init:
;	mb_functions.c:13: mb_init();
	lcall	_mb_init
;	mb_functions.c:15: register_mb_function(MB_CMD_READ_COILS, mb_read_coils);
	mov	dptr,#_register_mb_function_PARM_2
	mov	a,#_mb_read_coils
	movx	@dptr,a
	mov	a,#(_mb_read_coils >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x01
	lcall	_register_mb_function
;	mb_functions.c:17: register_mb_function(MB_CMD_READ_HOLDING_REGISTERS, mb_read_holding_registers);
	mov	dptr,#_register_mb_function_PARM_2
	mov	a,#_mb_read_holding_registers
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x03
	lcall	_register_mb_function
;	mb_functions.c:18: register_mb_function(MB_CMD_READ_INPUT_REGISTERS, mb_read_input_registers);
	mov	dptr,#_register_mb_function_PARM_2
	mov	a,#_mb_read_input_registers
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x04
	lcall	_register_mb_function
;	mb_functions.c:19: register_mb_function(MB_CMD_WRITE_SINGLE_COIL, mb_write_single_coil);
	mov	dptr,#_register_mb_function_PARM_2
	mov	a,#_mb_write_single_coil
	movx	@dptr,a
	mov	a,#(_mb_write_single_coil >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x05
	lcall	_register_mb_function
;	mb_functions.c:20: register_mb_function(MB_CMD_WRITE_SINGLE_REGISTER, mb_write_single_register);
	mov	dptr,#_register_mb_function_PARM_2
	mov	a,#_mb_write_single_register
	movx	@dptr,a
	mov	a,#(_mb_write_single_register >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x06
	lcall	_register_mb_function
;	mb_functions.c:21: register_mb_function(MB_CMD_WRITE_MULTIPLE_COILS, mb_write_multiple_coils);
	mov	dptr,#_register_mb_function_PARM_2
	mov	a,#_mb_write_multiple_coils
	movx	@dptr,a
	mov	a,#(_mb_write_multiple_coils >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x0f
	lcall	_register_mb_function
;	mb_functions.c:23: register_mb_function(MB_CMD_WRITE_MASK_REGISTER, mb_mask_write_register);
	mov	dptr,#_register_mb_function_PARM_2
	mov	a,#_mb_mask_write_register
	movx	@dptr,a
	mov	a,#(_mb_mask_write_register >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x16
;	mb_functions.c:25: }
	ljmp	_register_mb_function
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_coils'
;------------------------------------------------------------
;__1310720022              Allocated with name '_mb_read_coils___1310720022_131072_63'
;__1310720019              Allocated with name '_mb_read_coils___1310720019_131072_63'
;value                     Allocated with name '_mb_read_coils_value_65536_63'
;ret                       Allocated with name '_mb_read_coils_ret_65536_63'
;mask                      Allocated with name '_mb_read_coils_mask_65536_63'
;i                         Allocated with name '_mb_read_coils_i_65536_63'
;startaddr                 Allocated with name '_mb_read_coils_startaddr_65536_63'
;numcoils                  Allocated with name '_mb_read_coils_numcoils_65536_63'
;__1310720020              Allocated with name '_mb_read_coils___1310720020_131072_67'
;val                       Allocated with name '_mb_read_coils_val_196608_68'
;__1310720023              Allocated with name '_mb_read_coils___1310720023_131072_70'
;val                       Allocated with name '_mb_read_coils_val_196608_71'
;------------------------------------------------------------
;	mb_functions.c:27: uint8_t mb_read_coils(void)
;	-----------------------------------------
;	 function mb_read_coils
;	-----------------------------------------
_mb_read_coils:
;	mb_functions.c:31: uint8_t mask = 0;
	mov	dptr,#_mb_read_coils_mask_65536_63
	clr	a
	movx	@dptr,a
;	mb_functions.c:36: startaddr = u16swap(pmb_request->u.RdCoils.StartAddr);
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r2,a
	clr	a
	addc	a,r6
	mov	r3,a
	mov	ar4,r7
	mov	dpl,r2
	mov	dph,r3
	mov	b,r4
	lcall	__gptrget
	mov	r2,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r4,a
	mov	ar3,r2
	mov	r2,#0x00
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,r1
	orl	ar2,a
	mov	a,r4
	orl	ar3,a
;	mb_functions.c:36: startaddr = u16swap(pmb_request->u.RdCoils.StartAddr);
	mov	dptr,#_mb_read_coils_startaddr_65536_63
	mov	a,r2
	movx	@dptr,a
	mov	a,r3
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:37: numcoils = u16swap(pmb_request->u.RdCoils.NumCoils);
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r7,a
	mov	ar6,r5
	clr	a
	mov	r5,a
	mov	r4,a
	mov	a,r7
	orl	ar5,a
	mov	a,r4
	orl	ar6,a
;	mb_functions.c:37: numcoils = u16swap(pmb_request->u.RdCoils.NumCoils);
	mov	dptr,#_mb_read_coils_numcoils_65536_63
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:42: if ((numcoils == 0) || (numcoils > 0x07D0))
	mov	a,r5
	orl	a,r6
	jz	00101$
	mov	ar4,r5
	mov	ar7,r6
	clr	c
	mov	a,#0xd0
	subb	a,r4
	mov	a,#0x07
	subb	a,r7
	jnc	00102$
00101$:
;	mb_functions.c:43: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_functions.c:45: if ((startaddr > 7) || (numcoils > ( 8 - startaddr)))
	mov	ar4,r2
	mov	ar7,r3
	clr	c
	mov	a,#0x07
	subb	a,r4
	clr	a
	subb	a,r7
	jc	00104$
	mov	a,#0x08
	clr	c
	subb	a,r2
	mov	r2,a
	clr	a
	subb	a,r3
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r5
	mov	a,r3
	subb	a,r6
	jnc	00105$
00104$:
;	mb_functions.c:46: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_functions.c:48: if (ds1621_get_config(DS1621_ADDR, &value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_read_coils_value_65536_63
	movx	@dptr,a
	mov	a,#(_mb_read_coils_value_65536_63 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_get_config
	mov	a,dpl
	jz	00109$
;	mb_functions.c:49: value >>= startaddr;
	mov	dptr,#_mb_read_coils_startaddr_65536_63
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	dptr,#_mb_read_coils_value_65536_63
	movx	a,@dptr
	mov	b,r6
	inc	b
	sjmp	00145$
00144$:
	clr	c
	rrc	a
00145$:
	djnz	b,00144$
	mov	dptr,#_mb_read_coils_value_65536_63
	movx	@dptr,a
;	mb_functions.c:50: for(i=0;i<numcoils;i++){
	mov	dptr,#_mb_read_coils_numcoils_65536_63
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	r5,#0x00
00114$:
	mov	ar3,r5
	mov	r4,#0x00
	clr	c
	mov	a,r3
	subb	a,r6
	mov	a,r4
	subb	a,r7
	jnc	00107$
;	mb_functions.c:51: mask += (1<<i);
	mov	ar4,r5
	mov	b,r4
	inc	b
	mov	a,#0x01
	sjmp	00149$
00147$:
	add	a,acc
00149$:
	djnz	b,00147$
	mov	r4,a
	mov	dptr,#_mb_read_coils_mask_65536_63
	movx	a,@dptr
	mov	r3,a
	add	a,r4
	movx	@dptr,a
;	mb_functions.c:50: for(i=0;i<numcoils;i++){
	inc	r5
	sjmp	00114$
00107$:
;	mb_functions.c:53: value &= mask;
	mov	dptr,#_mb_read_coils_value_65536_63
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_mb_read_coils_mask_65536_63
	movx	a,@dptr
	mov	dptr,#_mb_read_coils_value_65536_63
	anl	a,r7
	movx	@dptr,a
;	mb_functions.c:54: mb_response.u.RdCoils.Count = 1;            // "Byte Count" -> 8Bits config value, therefore only a max/min of one byte
	mov	dptr,#(_mb_response + 0x0009)
	mov	a,#0x01
	movx	@dptr,a
;	mb_functions.c:55: mb_response.u.RdCoils.Status[0] = value;    // "Coil Status"
	mov	dptr,#_mb_read_coils_value_65536_63
	movx	a,@dptr
	mov	dptr,#(_mb_response + 0x000a)
	movx	@dptr,a
;	mb_functions.c:56: mb_set_data_length(2);                      // 2 bytes: 1x "Byte Count" and 1x "Config"
	mov	dptr,#0x0002
	lcall	_mb_set_data_length
;	mb_functions.c:57: ret = MB_OK;
	mov	dptr,#_mb_read_coils_ret_65536_63
	clr	a
	movx	@dptr,a
	sjmp	00110$
00109$:
;	mb_functions.c:58: } else ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_read_coils_ret_65536_63
	mov	a,#0x04
	movx	@dptr,a
00110$:
;	mb_functions.c:59: return(ret);
	mov	dptr,#_mb_read_coils_ret_65536_63
	movx	a,@dptr
;	mb_functions.c:60: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_single_coil'
;------------------------------------------------------------
;__1310720028              Allocated with name '_mb_write_single_coil___1310720028_131072_74'
;__1310720025              Allocated with name '_mb_write_single_coil___1310720025_131072_74'
;ret                       Allocated with name '_mb_write_single_coil_ret_65536_74'
;addr                      Allocated with name '_mb_write_single_coil_addr_65536_74'
;coilvalue                 Allocated with name '_mb_write_single_coil_coilvalue_65536_74'
;value                     Allocated with name '_mb_write_single_coil_value_65536_74'
;__1310720026              Allocated with name '_mb_write_single_coil___1310720026_131072_80'
;val                       Allocated with name '_mb_write_single_coil_val_196608_81'
;__1310720029              Allocated with name '_mb_write_single_coil___1310720029_131072_83'
;val                       Allocated with name '_mb_write_single_coil_val_196608_84'
;------------------------------------------------------------
;	mb_functions.c:62: uint8_t mb_write_single_coil(void)
;	-----------------------------------------
;	 function mb_write_single_coil
;	-----------------------------------------
_mb_write_single_coil:
;	mb_functions.c:69: addr = u16swap(pmb_request->u.WrSingleCoil.Addr);
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r2,a
	clr	a
	addc	a,r6
	mov	r3,a
	mov	ar4,r7
	mov	dpl,r2
	mov	dph,r3
	mov	b,r4
	lcall	__gptrget
	mov	r2,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r4,a
	mov	ar3,r2
	mov	r2,#0x00
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,r1
	orl	ar2,a
	mov	a,r4
	orl	ar3,a
;	mb_functions.c:69: addr = u16swap(pmb_request->u.WrSingleCoil.Addr);
	mov	dptr,#_mb_write_single_coil_addr_65536_74
	mov	a,r2
	movx	@dptr,a
	mov	a,r3
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:70: coilvalue = u16swap(pmb_request->u.WrSingleCoil.Value);
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r7,a
	mov	ar6,r5
	clr	a
	mov	r5,a
	mov	r4,a
	mov	a,r7
	orl	ar5,a
	mov	a,r4
	orl	ar6,a
;	mb_functions.c:70: coilvalue = u16swap(pmb_request->u.WrSingleCoil.Value);
	mov	dptr,#_mb_write_single_coil_coilvalue_65536_74
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:78: if (!((coilvalue == 0x0000) || (coilvalue == 0xFF00))){
	mov	a,r5
	orl	a,r6
	jz	00102$
	cjne	r5,#0x00,00142$
	cjne	r6,#0xff,00142$
	sjmp	00102$
00142$:
;	mb_functions.c:79: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_functions.c:82: if (addr > 7)
	clr	c
	mov	a,#0x07
	subb	a,r2
	clr	a
	subb	a,r3
	jnc	00105$
;	mb_functions.c:83: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_functions.c:85: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_coil_ret_65536_74
	mov	a,#0x04
	movx	@dptr,a
;	mb_functions.c:86: if (ds1621_get_config(DS1621_ADDR, &value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_write_single_coil_value_65536_74
	movx	@dptr,a
	mov	a,#(_mb_write_single_coil_value_65536_74 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_get_config
	mov	a,dpl
	jnz	00144$
	ljmp	00112$
00144$:
;	mb_functions.c:88: if (coilvalue == 0xFF00) {
	mov	dptr,#_mb_write_single_coil_coilvalue_65536_74
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	cjne	r6,#0x00,00107$
	cjne	r7,#0xff,00107$
;	mb_functions.c:89: value |= (1 << ((uint8_t)(addr & 0x07)));
	mov	dptr,#_mb_write_single_coil_addr_65536_74
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	anl	ar6,#0x07
	mov	b,r6
	inc	b
	mov	a,#0x01
	sjmp	00149$
00147$:
	add	a,acc
00149$:
	djnz	b,00147$
	mov	r6,a
	mov	dptr,#_mb_write_single_coil_value_65536_74
	movx	a,@dptr
	orl	a,r6
	movx	@dptr,a
	sjmp	00108$
00107$:
;	mb_functions.c:91: value &= ~(1 << ((uint8_t)(addr & 0x07)));
	mov	dptr,#_mb_write_single_coil_addr_65536_74
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	anl	ar6,#0x07
	mov	b,r6
	inc	b
	mov	a,#0x01
	sjmp	00152$
00150$:
	add	a,acc
00152$:
	djnz	b,00150$
	cpl	a
	mov	r6,a
	mov	dptr,#_mb_write_single_coil_value_65536_74
	movx	a,@dptr
	anl	a,r6
	movx	@dptr,a
00108$:
;	mb_functions.c:94: if (ds1621_set_config(DS1621_ADDR, value)) {
	mov	dptr,#_mb_write_single_coil_value_65536_74
	movx	a,@dptr
	mov	dptr,#_ds1621_set_config_PARM_2
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_config
	mov	a,dpl
	jz	00112$
;	mb_functions.c:95: mb_response.u.WrSingleCoil.Addr = pmb_request->u.WrSingleCoil.Addr;
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
	mov	r6,a
	mov	dptr,#(_mb_response + 0x0009)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:96: mb_response.u.WrSingleCoil.Value = pmb_request->u.WrSingleCoil.Value;
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
	mov	r6,a
	mov	dptr,#(_mb_response + 0x000b)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:97: mb_set_data_length(4);
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_functions.c:98: ret = MB_OK;
	mov	dptr,#_mb_write_single_coil_ret_65536_74
	clr	a
	movx	@dptr,a
00112$:
;	mb_functions.c:101: return(ret);
	mov	dptr,#_mb_write_single_coil_ret_65536_74
	movx	a,@dptr
;	mb_functions.c:102: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_single_register'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_write_single_register_sloc0_1_0'
;__1310720034              Allocated with name '_mb_write_single_register___1310720034_131072_87'
;__1310720031              Allocated with name '_mb_write_single_register___1310720031_131072_87'
;ret                       Allocated with name '_mb_write_single_register_ret_65536_87'
;addr                      Allocated with name '_mb_write_single_register_addr_65536_87'
;value                     Allocated with name '_mb_write_single_register_value_65536_87'
;__1310720032              Allocated with name '_mb_write_single_register___1310720032_131072_96'
;val                       Allocated with name '_mb_write_single_register_val_196608_97'
;__1310720035              Allocated with name '_mb_write_single_register___1310720035_131072_99'
;val                       Allocated with name '_mb_write_single_register_val_196608_100'
;------------------------------------------------------------
;	mb_functions.c:104: uint8_t mb_write_single_register(void)
;	-----------------------------------------
;	 function mb_write_single_register
;	-----------------------------------------
_mb_write_single_register:
;	mb_functions.c:110: addr = u16swap(pmb_request->u.WrSingleReg.Addr);
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r2,a
	clr	a
	addc	a,r6
	mov	r3,a
	mov	ar4,r7
	mov	dpl,r2
	mov	dph,r3
	mov	b,r4
	lcall	__gptrget
	mov	r2,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r3,a
	mov	r4,a
	mov	ar1,r2
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_write_single_register_sloc0_1_0,#0x00
	mov	_mb_write_single_register_sloc0_1_0,r0
	mov	(_mb_write_single_register_sloc0_1_0 + 1),r1
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,_mb_write_single_register_sloc0_1_0
	orl	ar1,a
	mov	a,(_mb_write_single_register_sloc0_1_0 + 1)
	orl	ar4,a
	mov	dptr,#_mb_write_single_register_addr_65536_87
	mov	a,r1
	movx	@dptr,a
	mov	a,r4
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:111: value = u16swap(pmb_request->u.WrSingleReg.Value);
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r7,a
	mov	ar6,r5
	clr	a
	mov	r5,a
	mov	r4,a
	mov	a,r7
	orl	ar5,a
	mov	a,r4
	orl	ar6,a
	mov	dptr,#_mb_write_single_register_value_65536_87
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:118: mb_response.u.WrSingleReg.Addr = pmb_request->u.WrSingleReg.Addr;
	mov	dptr,#(_mb_response + 0x0009)
	mov	a,r2
	movx	@dptr,a
	mov	a,r3
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:119: mb_response.u.WrSingleReg.Value = pmb_request->u.WrSingleReg.Value;
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
	mov	r6,a
	mov	dptr,#(_mb_response + 0x000b)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:120: mb_set_data_length(4);
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_functions.c:121: ret = MB_OK;
	mov	dptr,#_mb_write_single_register_ret_65536_87
	clr	a
	movx	@dptr,a
;	mb_functions.c:123: switch(addr) {
	mov	dptr,#_mb_write_single_register_addr_65536_87
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	clr	c
	mov	a,#0x03
	subb	a,r6
	clr	a
	subb	a,r7
	jnc	00152$
	ljmp	00118$
00152$:
	mov	a,r6
	add	a,r6
;	mb_functions.c:124: case 0x00:
	mov	dptr,#00153$
	jmp	@a+dptr
00153$:
	sjmp	00101$
	sjmp	00104$
	sjmp	00107$
	sjmp	00110$
00101$:
;	mb_functions.c:125: if (!ds1621_set_config(DS1621_ADDR, (uint8_t)(value & 0x00FF))) {
	mov	dptr,#_mb_write_single_register_value_65536_87
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	dptr,#_ds1621_set_config_PARM_2
	mov	a,r6
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_config
	mov	a,dpl
	jz	00154$
	ljmp	00119$
00154$:
;	mb_functions.c:126: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_87
	mov	a,#0x04
	movx	@dptr,a
;	mb_functions.c:128: break;
;	mb_functions.c:129: case 0x01:
	sjmp	00119$
00104$:
;	mb_functions.c:130: if (!ds1621_set_TH(DS1621_ADDR, value)) {
	mov	dptr,#_mb_write_single_register_value_65536_87
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_ds1621_set_TH_PARM_2
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_TH
	mov	a,dpl
	jnz	00119$
;	mb_functions.c:131: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_87
	mov	a,#0x04
	movx	@dptr,a
;	mb_functions.c:133: break;
;	mb_functions.c:134: case 0x02:
	sjmp	00119$
00107$:
;	mb_functions.c:135: if (!ds1621_set_TL(DS1621_ADDR, value)) {
	mov	dptr,#_mb_write_single_register_value_65536_87
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_ds1621_set_TL_PARM_2
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_TL
	mov	a,dpl
	jnz	00119$
;	mb_functions.c:136: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_87
	mov	a,#0x04
	movx	@dptr,a
;	mb_functions.c:138: break;
;	mb_functions.c:139: case 0x03: // write-only register
	sjmp	00119$
00110$:
;	mb_functions.c:140: if (value == 0xFFFF) {
	mov	dptr,#_mb_write_single_register_value_65536_87
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	cjne	r6,#0xff,00116$
	cjne	r7,#0xff,00116$
;	mb_functions.c:141: if (!ds1621_start_convert(DS1621_ADDR)) {
	mov	dpl,#0x92
	lcall	_ds1621_start_convert
	mov	a,dpl
	jnz	00119$
;	mb_functions.c:142: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_87
	mov	a,#0x04
	movx	@dptr,a
	sjmp	00119$
00116$:
;	mb_functions.c:145: if (!ds1621_stop_convert(DS1621_ADDR)) {
	mov	dpl,#0x92
	lcall	_ds1621_stop_convert
	mov	a,dpl
	jnz	00119$
;	mb_functions.c:146: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_87
	mov	a,#0x04
	movx	@dptr,a
;	mb_functions.c:149: break;
;	mb_functions.c:150: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00119$
00118$:
	mov	dptr,#_mb_write_single_register_ret_65536_87
	mov	a,#0x02
	movx	@dptr,a
;	mb_functions.c:152: }
00119$:
;	mb_functions.c:153: return(ret);
	mov	dptr,#_mb_write_single_register_ret_65536_87
	movx	a,@dptr
;	mb_functions.c:154: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_multiple_coils'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_write_multiple_coils_sloc0_1_0'
;__1310720040              Allocated with name '_mb_write_multiple_coils___1310720040_131072_103'
;__1310720037              Allocated with name '_mb_write_multiple_coils___1310720037_131072_103'
;ret                       Allocated with name '_mb_write_multiple_coils_ret_65536_103'
;startaddr                 Allocated with name '_mb_write_multiple_coils_startaddr_65536_103'
;numcoils                  Allocated with name '_mb_write_multiple_coils_numcoils_65536_103'
;coils_state               Allocated with name '_mb_write_multiple_coils_coils_state_65536_103'
;value                     Allocated with name '_mb_write_multiple_coils_value_65536_103'
;mask                      Allocated with name '_mb_write_multiple_coils_mask_65536_103'
;i                         Allocated with name '_mb_write_multiple_coils_i_65536_103'
;__1310720038              Allocated with name '_mb_write_multiple_coils___1310720038_131072_110'
;val                       Allocated with name '_mb_write_multiple_coils_val_196608_111'
;__1310720041              Allocated with name '_mb_write_multiple_coils___1310720041_131072_113'
;val                       Allocated with name '_mb_write_multiple_coils_val_196608_114'
;------------------------------------------------------------
;	mb_functions.c:156: uint8_t mb_write_multiple_coils(void)
;	-----------------------------------------
;	 function mb_write_multiple_coils
;	-----------------------------------------
_mb_write_multiple_coils:
;	mb_functions.c:163: uint8_t mask = 0;
	mov	dptr,#_mb_write_multiple_coils_mask_65536_103
	clr	a
	movx	@dptr,a
;	mb_functions.c:166: startaddr = u16swap(pmb_request->u.WrMultCoils.StartAddr);
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r2,a
	clr	a
	addc	a,r6
	mov	r3,a
	mov	ar4,r7
	mov	dpl,r2
	mov	dph,r3
	mov	b,r4
	lcall	__gptrget
	mov	r2,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r4,a
	mov	ar3,r2
	mov	r2,#0x00
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,r1
	orl	ar2,a
	mov	a,r4
	orl	ar3,a
;	mb_functions.c:166: startaddr = u16swap(pmb_request->u.WrMultCoils.StartAddr);
	mov	dptr,#_mb_write_multiple_coils_startaddr_65536_103
	mov	a,r2
	movx	@dptr,a
	mov	a,r3
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:167: numcoils = u16swap(pmb_request->u.WrMultCoils.NumCoils);
	mov	a,#0x0a
	add	a,r5
	mov	r0,a
	clr	a
	addc	a,r6
	mov	r1,a
	mov	ar4,r7
	mov	dpl,r0
	mov	dph,r1
	mov	b,r4
	lcall	__gptrget
	mov	r0,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r4,a
	mov	ar1,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_write_multiple_coils_sloc0_1_0,#0x00
	mov	_mb_write_multiple_coils_sloc0_1_0,r0
	mov	(_mb_write_multiple_coils_sloc0_1_0 + 1),r1
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,_mb_write_multiple_coils_sloc0_1_0
	orl	ar1,a
	mov	a,(_mb_write_multiple_coils_sloc0_1_0 + 1)
	orl	ar4,a
;	mb_functions.c:167: numcoils = u16swap(pmb_request->u.WrMultCoils.NumCoils);
	mov	dptr,#_mb_write_multiple_coils_numcoils_65536_103
	mov	a,r1
	movx	@dptr,a
	mov	a,r4
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:174: if ((numcoils == 0) || (numcoils > 0x07B0))
	mov	a,r1
	orl	a,r4
	jz	00101$
	push	ar2
	push	ar3
	mov	ar0,r1
	mov	ar3,r4
	clr	c
	mov	a,#0xb0
	subb	a,r0
	mov	a,#0x07
	subb	a,r3
	pop	ar3
	pop	ar2
	jnc	00102$
00101$:
;	mb_functions.c:175: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_functions.c:177: if (client_msg.rxlen < 14)
	mov	dptr,#(_client_msg + 0x0007)
	movx	a,@dptr
	mov	_mb_write_multiple_coils_sloc0_1_0,a
	clr	c
	subb	a,#0x0e
	jnc	00105$
;	mb_functions.c:178: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00105$:
;	mb_functions.c:180: if (pmb_request->u.WrMultCoils.Count != (client_msg.rxlen - 13))
	push	ar2
	push	ar3
	mov	a,#0x0c
	add	a,r5
	mov	r0,a
	clr	a
	addc	a,r6
	mov	r2,a
	mov	ar3,r7
	mov	dpl,r0
	mov	dph,r2
	mov	b,r3
	lcall	__gptrget
	mov	r0,a
	mov	r2,_mb_write_multiple_coils_sloc0_1_0
	mov	r3,#0x00
	mov	a,r2
	add	a,#0xf3
	mov	_mb_write_multiple_coils_sloc0_1_0,a
	mov	a,r3
	addc	a,#0xff
	mov	(_mb_write_multiple_coils_sloc0_1_0 + 1),a
	mov	r3,#0x00
	mov	a,r0
	cjne	a,_mb_write_multiple_coils_sloc0_1_0,00161$
	mov	a,r3
	cjne	a,(_mb_write_multiple_coils_sloc0_1_0 + 1),00161$
	pop	ar3
	pop	ar2
	sjmp	00107$
00161$:
	pop	ar3
	pop	ar2
;	mb_functions.c:181: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00107$:
;	mb_functions.c:183: if ((startaddr > 7) || (numcoils > ( 8 - startaddr)))
	push	ar1
	push	ar4
	mov	ar0,r2
	mov	ar4,r3
	clr	c
	mov	a,#0x07
	subb	a,r0
	clr	a
	subb	a,r4
	pop	ar4
	pop	ar1
	jc	00108$
	mov	a,#0x08
	clr	c
	subb	a,r2
	mov	r2,a
	clr	a
	subb	a,r3
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r1
	mov	a,r3
	subb	a,r4
	jnc	00109$
00108$:
;	mb_functions.c:184: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00109$:
;	mb_functions.c:186: coils_state = pmb_request->u.WrMultCoils.Value[0];
	mov	a,#0x0d
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	dptr,#_mb_write_multiple_coils_coils_state_65536_103
	movx	@dptr,a
;	mb_functions.c:188: if (ds1621_get_config(DS1621_ADDR, &value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_write_multiple_coils_value_65536_103
	movx	@dptr,a
	mov	a,#(_mb_write_multiple_coils_value_65536_103 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_get_config
	mov	a,dpl
	jnz	00164$
	ljmp	00116$
00164$:
;	mb_functions.c:189: for(i=0;i<numcoils;i++){
	mov	dptr,#_mb_write_multiple_coils_numcoils_65536_103
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	r5,#0x00
00121$:
	mov	ar3,r5
	mov	r4,#0x00
	clr	c
	mov	a,r3
	subb	a,r6
	mov	a,r4
	subb	a,r7
	jnc	00111$
;	mb_functions.c:190: mask += (1<<i);
	mov	ar4,r5
	mov	b,r4
	inc	b
	mov	a,#0x01
	sjmp	00168$
00166$:
	add	a,acc
00168$:
	djnz	b,00166$
	mov	r4,a
	mov	dptr,#_mb_write_multiple_coils_mask_65536_103
	movx	a,@dptr
	mov	r3,a
	add	a,r4
	movx	@dptr,a
;	mb_functions.c:189: for(i=0;i<numcoils;i++){
	inc	r5
	sjmp	00121$
00111$:
;	mb_functions.c:192: mask <<= startaddr;
	mov	dptr,#_mb_write_multiple_coils_startaddr_65536_103
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	dptr,#_mb_write_multiple_coils_mask_65536_103
	movx	a,@dptr
	mov	r5,a
	mov	b,r6
	inc	b
	mov	a,r5
	sjmp	00171$
00169$:
	add	a,acc
00171$:
	djnz	b,00169$
	mov	dptr,#_mb_write_multiple_coils_mask_65536_103
	movx	@dptr,a
;	mb_functions.c:193: value &= ~mask;
	movx	a,@dptr
	mov	r7,a
	cpl	a
	mov	r5,a
	mov	dptr,#_mb_write_multiple_coils_value_65536_103
	movx	a,@dptr
	anl	a,r5
	movx	@dptr,a
;	mb_functions.c:194: coils_state <<= startaddr;
	mov	dptr,#_mb_write_multiple_coils_coils_state_65536_103
	movx	a,@dptr
	mov	b,r6
	inc	b
	sjmp	00174$
00172$:
	add	a,acc
00174$:
	djnz	b,00172$
	mov	dptr,#_mb_write_multiple_coils_coils_state_65536_103
	movx	@dptr,a
;	mb_functions.c:195: coils_state &= mask;
	movx	a,@dptr
	anl	a,r7
	movx	@dptr,a
;	mb_functions.c:196: value |= coils_state;
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_mb_write_multiple_coils_value_65536_103
	movx	a,@dptr
	orl	a,r7
	movx	@dptr,a
;	mb_functions.c:198: if (ds1621_set_config(DS1621_ADDR, value)) {
	movx	a,@dptr
	mov	dptr,#_ds1621_set_config_PARM_2
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_config
	mov	a,dpl
	jz	00113$
;	mb_functions.c:199: mb_response.u.WrMultCoils.StartAddr = pmb_request->u.WrMultCoils.StartAddr;
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
	mov	r6,a
	mov	dptr,#(_mb_response + 0x0009)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:200: mb_response.u.WrMultCoils.NumCoils = pmb_request->u.WrMultCoils.NumCoils;
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
	mov	r6,a
	mov	dptr,#(_mb_response + 0x000b)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:201: mb_set_data_length(4);
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_functions.c:202: ret = MB_OK;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_103
	clr	a
	movx	@dptr,a
	sjmp	00117$
00113$:
;	mb_functions.c:204: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_103
	mov	a,#0x04
	movx	@dptr,a
	sjmp	00117$
00116$:
;	mb_functions.c:207: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_103
	mov	a,#0x04
	movx	@dptr,a
00117$:
;	mb_functions.c:209: return(ret);
	mov	dptr,#_mb_write_multiple_coils_ret_65536_103
	movx	a,@dptr
;	mb_functions.c:210: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_mask_write_register'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_mask_write_register_sloc0_1_0'
;__1310720049              Allocated with name '_mb_mask_write_register___1310720049_131072_117'
;__1310720046              Allocated with name '_mb_mask_write_register___1310720046_131072_117'
;__1310720043              Allocated with name '_mb_mask_write_register___1310720043_131072_117'
;ret                       Allocated with name '_mb_mask_write_register_ret_65536_117'
;value                     Allocated with name '_mb_mask_write_register_value_65536_117'
;addr                      Allocated with name '_mb_mask_write_register_addr_65536_117'
;andmask                   Allocated with name '_mb_mask_write_register_andmask_65536_117'
;ormask                    Allocated with name '_mb_mask_write_register_ormask_65536_117'
;__1310720044              Allocated with name '_mb_mask_write_register___1310720044_131072_122'
;val                       Allocated with name '_mb_mask_write_register_val_196608_123'
;__1310720047              Allocated with name '_mb_mask_write_register___1310720047_131072_125'
;val                       Allocated with name '_mb_mask_write_register_val_196608_126'
;__1310720050              Allocated with name '_mb_mask_write_register___1310720050_131072_128'
;val                       Allocated with name '_mb_mask_write_register_val_196608_129'
;------------------------------------------------------------
;	mb_functions.c:212: uint8_t mb_mask_write_register(void)
;	-----------------------------------------
;	 function mb_mask_write_register
;	-----------------------------------------
_mb_mask_write_register:
;	mb_functions.c:220: addr = u16swap(pmb_request->u.MaskWrReg.Addr);
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r2,a
	clr	a
	addc	a,r6
	mov	r3,a
	mov	ar4,r7
	mov	dpl,r2
	mov	dph,r3
	mov	b,r4
	lcall	__gptrget
	mov	r2,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r4,a
	mov	ar3,r2
	mov	r2,#0x00
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,r1
	orl	ar2,a
	mov	a,r4
	orl	ar3,a
;	mb_functions.c:221: andmask = u16swap(pmb_request->u.MaskWrReg.AndMask);
	mov	a,#0x0a
	add	a,r5
	mov	r0,a
	clr	a
	addc	a,r6
	mov	r1,a
	mov	ar4,r7
	mov	dpl,r0
	mov	dph,r1
	mov	b,r4
	lcall	__gptrget
	mov	r0,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r4,a
	mov	ar1,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_mask_write_register_sloc0_1_0,#0x00
	mov	_mb_mask_write_register_sloc0_1_0,r0
	mov	(_mb_mask_write_register_sloc0_1_0 + 1),r1
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,_mb_mask_write_register_sloc0_1_0
	orl	ar1,a
	mov	a,(_mb_mask_write_register_sloc0_1_0 + 1)
	orl	ar4,a
	mov	dptr,#_mb_mask_write_register_andmask_65536_117
	mov	a,r1
	movx	@dptr,a
	mov	a,r4
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:222: ormask = u16swap(pmb_request->u.MaskWrReg.OrMask);
	mov	a,#0x0c
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r7,a
	mov	ar6,r5
	clr	a
	mov	r5,a
	mov	r4,a
	mov	a,r7
	orl	ar5,a
	mov	a,r4
	orl	ar6,a
	mov	dptr,#_mb_mask_write_register_ormask_65536_117
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:228: if (addr != 0) //only to be used with register 0 // CONFIG Regsiter
	mov	a,r2
	orl	a,r3
	jz	00102$
;	mb_functions.c:229: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00102$:
;	mb_functions.c:231: if (ds1621_get_config(DS1621_ADDR, &value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_mask_write_register_value_65536_117
	movx	@dptr,a
	mov	a,#(_mb_mask_write_register_value_65536_117 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_get_config
	mov	a,dpl
	jnz	00127$
	ljmp	00107$
00127$:
;	mb_functions.c:232: value = (value & andmask) | (ormask & (~andmask));
	mov	dptr,#_mb_mask_write_register_value_65536_117
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_mb_mask_write_register_andmask_65536_117
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	a,r5
	anl	ar7,a
	mov	a,r5
	cpl	a
	mov	r5,a
	mov	dptr,#_mb_mask_write_register_ormask_65536_117
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	a,r5
	anl	a,r4
	mov	dptr,#_mb_mask_write_register_value_65536_117
	orl	a,r7
	movx	@dptr,a
;	mb_functions.c:233: if (ds1621_set_config(DS1621_ADDR, value)) {
	movx	a,@dptr
	mov	dptr,#_ds1621_set_config_PARM_2
	movx	@dptr,a
	mov	dpl,#0x92
	lcall	_ds1621_set_config
	mov	a,dpl
	jnz	00128$
	ljmp	00104$
00128$:
;	mb_functions.c:234: mb_response.u.MaskWrReg.Addr = pmb_request->u.MaskWrReg.Addr;
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
	mov	r6,a
	mov	dptr,#(_mb_response + 0x0009)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:235: mb_response.u.MaskWrReg.AndMask = pmb_request->u.MaskWrReg.AndMask;
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
	mov	r6,a
	mov	dptr,#(_mb_response + 0x000b)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:236: mb_response.u.MaskWrReg.OrMask = pmb_request->u.MaskWrReg.OrMask;
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x0c
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
	mov	r6,a
	mov	dptr,#(_mb_response + 0x000d)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:237: mb_set_data_length(6);
	mov	dptr,#0x0006
	lcall	_mb_set_data_length
;	mb_functions.c:238: ret = MB_OK;
	mov	dptr,#_mb_mask_write_register_ret_65536_117
	clr	a
	movx	@dptr,a
	sjmp	00108$
00104$:
;	mb_functions.c:240: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_mask_write_register_ret_65536_117
	mov	a,#0x04
	movx	@dptr,a
	sjmp	00108$
00107$:
;	mb_functions.c:243: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_mask_write_register_ret_65536_117
	mov	a,#0x04
	movx	@dptr,a
00108$:
;	mb_functions.c:245: return(ret);
	mov	dptr,#_mb_mask_write_register_ret_65536_117
	movx	a,@dptr
;	mb_functions.c:246: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_holding_registers'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_read_holding_registers_sloc0_1_0'
;__1310720055              Allocated with name '_mb_read_holding_registers___1310720055_131072_132'
;__1310720052              Allocated with name '_mb_read_holding_registers___1310720052_131072_132'
;ret                       Allocated with name '_mb_read_holding_registers_ret_65536_132'
;addr                      Allocated with name '_mb_read_holding_registers_addr_65536_132'
;numregs                   Allocated with name '_mb_read_holding_registers_numregs_65536_132'
;len                       Allocated with name '_mb_read_holding_registers_len_65536_132'
;i                         Allocated with name '_mb_read_holding_registers_i_65536_132'
;u8value                   Allocated with name '_mb_read_holding_registers_u8value_65536_132'
;u16value                  Allocated with name '_mb_read_holding_registers_u16value_65536_132'
;__1310720053              Allocated with name '_mb_read_holding_registers___1310720053_131072_139'
;val                       Allocated with name '_mb_read_holding_registers_val_196608_140'
;__1310720056              Allocated with name '_mb_read_holding_registers___1310720056_131072_142'
;val                       Allocated with name '_mb_read_holding_registers_val_196608_143'
;__3932160058              Allocated with name '_mb_read_holding_registers___3932160058_393216_136'
;__3932160059              Allocated with name '_mb_read_holding_registers___3932160059_393216_145'
;val                       Allocated with name '_mb_read_holding_registers_val_458752_146'
;__3932160061              Allocated with name '_mb_read_holding_registers___3932160061_393216_137'
;__3932160062              Allocated with name '_mb_read_holding_registers___3932160062_393216_148'
;val                       Allocated with name '_mb_read_holding_registers_val_458752_149'
;__3932160064              Allocated with name '_mb_read_holding_registers___3932160064_393216_138'
;__3932160065              Allocated with name '_mb_read_holding_registers___3932160065_393216_151'
;val                       Allocated with name '_mb_read_holding_registers_val_458752_152'
;------------------------------------------------------------
;	mb_functions.c:248: uint8_t mb_read_holding_registers(void)
;	-----------------------------------------
;	 function mb_read_holding_registers
;	-----------------------------------------
_mb_read_holding_registers:
;	mb_functions.c:258: addr = u16swap(pmb_request->u.RdHoldingRegs.StartAddr);
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r2,a
	clr	a
	addc	a,r6
	mov	r3,a
	mov	ar4,r7
	mov	dpl,r2
	mov	dph,r3
	mov	b,r4
	lcall	__gptrget
	mov	r2,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r4,a
	mov	ar3,r2
	mov	r2,#0x00
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,r1
	orl	ar2,a
	mov	a,r4
	orl	ar3,a
;	mb_functions.c:258: addr = u16swap(pmb_request->u.RdHoldingRegs.StartAddr);
	mov	dptr,#_mb_read_holding_registers_addr_65536_132
	mov	a,r2
	movx	@dptr,a
	mov	a,r3
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:259: numregs = u16swap(pmb_request->u.RdHoldingRegs.NumRegisters);
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r7,a
	mov	ar6,r5
	clr	a
	mov	r5,a
	mov	r4,a
	mov	a,r7
	orl	ar5,a
	mov	a,r4
	orl	ar6,a
;	mb_functions.c:259: numregs = u16swap(pmb_request->u.RdHoldingRegs.NumRegisters);
	mov	dptr,#_mb_read_holding_registers_numregs_65536_132
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:264: if ((numregs == 0) || (numregs > 0x7D))
	mov	a,r5
	orl	a,r6
	jz	00101$
	mov	ar4,r5
	mov	ar7,r6
	clr	c
	mov	a,#0x7d
	subb	a,r4
	clr	a
	subb	a,r7
	jnc	00102$
00101$:
;	mb_functions.c:265: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_functions.c:267: if ((addr > 2) || (numregs > ( 3 - addr)))
	mov	ar4,r2
	mov	ar7,r3
	clr	c
	mov	a,#0x02
	subb	a,r4
	clr	a
	subb	a,r7
	jc	00104$
	mov	a,#0x03
	clr	c
	subb	a,r2
	mov	r2,a
	clr	a
	subb	a,r3
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r5
	mov	a,r3
	subb	a,r6
	jnc	00105$
00104$:
;	mb_functions.c:268: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_functions.c:270: mb_response.u.RdHoldingRegs.Count = (uint8_t)(numregs * 2);
	mov	a,r5
	add	a,r5
	mov	dptr,#(_mb_response + 0x0009)
	movx	@dptr,a
;	mb_functions.c:271: len = 1;
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	mov	a,#0x01
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:272: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_read_holding_registers_ret_65536_132
	mov	a,#0x04
	movx	@dptr,a
;	mb_functions.c:273: for (i = addr; i<(addr + numregs); i++) {
	mov	dptr,#_mb_read_holding_registers_addr_65536_132
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	ar5,r6
	mov	dptr,#_mb_read_holding_registers_numregs_65536_132
	movx	a,@dptr
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	mov	r4,a
	mov	ar1,r6
	mov	ar2,r7
	mov	a,r3
	add	a,r6
	mov	r6,a
	mov	a,r4
	addc	a,r7
	mov	r7,a
00125$:
	mov	ar3,r5
	mov	r4,#0x00
	clr	c
	mov	a,r3
	subb	a,r6
	mov	a,r4
	subb	a,r7
	jc	00173$
	ljmp	00118$
00173$:
;	mb_functions.c:274: switch(i) {
	cjne	r5,#0x00,00174$
	sjmp	00107$
00174$:
	cjne	r5,#0x01,00175$
	ljmp	00110$
00175$:
	cjne	r5,#0x02,00176$
	ljmp	00113$
00176$:
	ljmp	00116$
;	mb_functions.c:275: case 0x00:
00107$:
;	mb_functions.c:276: if (ds1621_get_config(DS1621_ADDR, &u8value)) {
	mov	dptr,#_ds1621_get_config_PARM_2
	mov	a,#_mb_read_holding_registers_u8value_65536_132
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers_u8value_65536_132 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_ds1621_get_config
	mov	a,dpl
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00177$
	ljmp	00126$
00177$:
;	mb_functions.c:277: mb_response.u.RdHoldingRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	push	ar6
	push	ar7
	mov	ar3,r5
	mov	r4,#0x00
	mov	a,r3
	clr	c
	subb	a,r1
	mov	r3,a
	mov	a,r4
	subb	a,r2
	mov	r4,a
	mov	a,r3
	add	a,r3
	mov	r3,a
	mov	a,r4
	rlc	a
	mov	r4,a
	mov	a,r3
	add	a,#(_mb_response + 0x000a)
	mov	r3,a
	mov	a,r4
	addc	a,#((_mb_response + 0x000a) >> 8)
	mov	r4,a
	mov	dptr,#_mb_read_holding_registers_u8value_65536_132
	movx	a,@dptr
	mov	r0,a
	mov	r7,#0x00
;	mb_functions.c:77: 
	mov	ar6,r7
	mov	ar7,r0
;	1-genFromRTrack replaced	mov	_mb_read_holding_registers_sloc0_1_0,#0x00
	mov	_mb_read_holding_registers_sloc0_1_0,r6
	mov	(_mb_read_holding_registers_sloc0_1_0 + 1),r7
	mov	r7,#0x00
	mov	a,_mb_read_holding_registers_sloc0_1_0
	orl	ar6,a
	mov	a,(_mb_read_holding_registers_sloc0_1_0 + 1)
	orl	ar7,a
;	mb_functions.c:277: mb_response.u.RdHoldingRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	mov	dpl,r3
	mov	dph,r4
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:278: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x02
	add	a,r6
	mov	r6,a
	clr	a
	addc	a,r7
	mov	r7,a
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:279: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dpl,r6
	mov	dph,r7
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_mb_set_data_length
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_functions.c:280: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_132
	clr	a
	movx	@dptr,a
;	mb_functions.c:282: break;
	pop	ar7
	pop	ar6
	ljmp	00126$
;	mb_functions.c:283: case 0x01:
00110$:
;	mb_functions.c:284: if (ds1621_get_TH(DS1621_ADDR, &u16value)) {
	mov	dptr,#_ds1621_get_TH_PARM_2
	mov	a,#_mb_read_holding_registers_u16value_65536_132
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers_u16value_65536_132 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_ds1621_get_TH
	mov	a,dpl
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00178$
	ljmp	00126$
00178$:
;	mb_functions.c:285: mb_response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	push	ar6
	push	ar7
	mov	ar3,r5
	mov	r4,#0x00
	mov	a,r3
	clr	c
	subb	a,r1
	mov	r3,a
	mov	a,r4
	subb	a,r2
	mov	r4,a
	mov	a,r3
	add	a,r3
	mov	r3,a
	mov	a,r4
	rlc	a
	mov	r4,a
	mov	a,r3
	add	a,#(_mb_response + 0x000a)
	mov	r3,a
	mov	a,r4
	addc	a,#((_mb_response + 0x000a) >> 8)
	mov	r4,a
	mov	dptr,#_mb_read_holding_registers_u16value_65536_132
	movx	a,@dptr
	mov	r0,a
	inc	dptr
	movx	a,@dptr
;	mb_functions.c:77: 
	mov	r6,a
	mov	ar7,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_read_holding_registers_sloc0_1_0,#0x00
	mov	_mb_read_holding_registers_sloc0_1_0,r0
	mov	(_mb_read_holding_registers_sloc0_1_0 + 1),r7
	mov	r7,#0x00
	mov	a,_mb_read_holding_registers_sloc0_1_0
	orl	ar6,a
	mov	a,(_mb_read_holding_registers_sloc0_1_0 + 1)
	orl	ar7,a
;	mb_functions.c:285: mb_response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	mov	dpl,r3
	mov	dph,r4
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:286: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x02
	add	a,r6
	mov	r6,a
	clr	a
	addc	a,r7
	mov	r7,a
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:287: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dpl,r6
	mov	dph,r7
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_mb_set_data_length
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_functions.c:288: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_132
	clr	a
	movx	@dptr,a
;	mb_functions.c:290: break;
	pop	ar7
	pop	ar6
	ljmp	00126$
;	mb_functions.c:291: case 0x02:
00113$:
;	mb_functions.c:292: if (ds1621_get_TL(DS1621_ADDR, &u16value)) {
	mov	dptr,#_ds1621_get_TL_PARM_2
	mov	a,#_mb_read_holding_registers_u16value_65536_132
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers_u16value_65536_132 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_ds1621_get_TL
	mov	a,dpl
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00179$
	ljmp	00126$
00179$:
;	mb_functions.c:293: mb_response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	push	ar6
	push	ar7
	mov	ar3,r5
	mov	r4,#0x00
	mov	a,r3
	clr	c
	subb	a,r1
	mov	r3,a
	mov	a,r4
	subb	a,r2
	mov	r4,a
	mov	a,r3
	add	a,r3
	mov	r3,a
	mov	a,r4
	rlc	a
	mov	r4,a
	mov	a,r3
	add	a,#(_mb_response + 0x000a)
	mov	r3,a
	mov	a,r4
	addc	a,#((_mb_response + 0x000a) >> 8)
	mov	r4,a
	mov	dptr,#_mb_read_holding_registers_u16value_65536_132
	movx	a,@dptr
	mov	r0,a
	inc	dptr
	movx	a,@dptr
;	mb_functions.c:77: 
	mov	r6,a
	mov	ar7,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_read_holding_registers_sloc0_1_0,#0x00
	mov	_mb_read_holding_registers_sloc0_1_0,r0
	mov	(_mb_read_holding_registers_sloc0_1_0 + 1),r7
	mov	r7,#0x00
	mov	a,_mb_read_holding_registers_sloc0_1_0
	orl	ar6,a
	mov	a,(_mb_read_holding_registers_sloc0_1_0 + 1)
	orl	ar7,a
;	mb_functions.c:293: mb_response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	mov	dpl,r3
	mov	dph,r4
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:294: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x02
	add	a,r6
	mov	r6,a
	clr	a
	addc	a,r7
	mov	r7,a
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:295: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_132
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dpl,r6
	mov	dph,r7
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_mb_set_data_length
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_functions.c:296: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_132
	clr	a
	movx	@dptr,a
;	mb_functions.c:298: break;
	pop	ar7
	pop	ar6
;	mb_functions.c:299: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00126$
00116$:
;	mb_functions.c:300: return(ret);
	mov	dpl,#0x02
;	mb_functions.c:302: }
	ret
00126$:
;	mb_functions.c:273: for (i = addr; i<(addr + numregs); i++) {
	inc	r5
	ljmp	00125$
00118$:
;	mb_functions.c:304: return(ret);
	mov	dptr,#_mb_read_holding_registers_ret_65536_132
	movx	a,@dptr
;	mb_functions.c:305: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_input_registers'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_read_input_registers_sloc0_1_0'
;__1310720070              Allocated with name '_mb_read_input_registers___1310720070_131072_155'
;__1310720067              Allocated with name '_mb_read_input_registers___1310720067_131072_155'
;ret                       Allocated with name '_mb_read_input_registers_ret_65536_155'
;addr                      Allocated with name '_mb_read_input_registers_addr_65536_155'
;numregs                   Allocated with name '_mb_read_input_registers_numregs_65536_155'
;len                       Allocated with name '_mb_read_input_registers_len_65536_155'
;i                         Allocated with name '_mb_read_input_registers_i_65536_155'
;u8value                   Allocated with name '_mb_read_input_registers_u8value_65536_155'
;u16value                  Allocated with name '_mb_read_input_registers_u16value_65536_155'
;__1310720068              Allocated with name '_mb_read_input_registers___1310720068_131072_163'
;val                       Allocated with name '_mb_read_input_registers_val_196608_164'
;__1310720071              Allocated with name '_mb_read_input_registers___1310720071_131072_166'
;val                       Allocated with name '_mb_read_input_registers_val_196608_167'
;__3932160073              Allocated with name '_mb_read_input_registers___3932160073_393216_160'
;__3932160074              Allocated with name '_mb_read_input_registers___3932160074_393216_169'
;val                       Allocated with name '_mb_read_input_registers_val_458752_170'
;__3932160076              Allocated with name '_mb_read_input_registers___3932160076_393216_161'
;__3932160077              Allocated with name '_mb_read_input_registers___3932160077_393216_172'
;val                       Allocated with name '_mb_read_input_registers_val_458752_173'
;__3932160079              Allocated with name '_mb_read_input_registers___3932160079_393216_162'
;__3932160080              Allocated with name '_mb_read_input_registers___3932160080_393216_175'
;val                       Allocated with name '_mb_read_input_registers_val_458752_176'
;------------------------------------------------------------
;	mb_functions.c:307: uint8_t mb_read_input_registers(void)
;	-----------------------------------------
;	 function mb_read_input_registers
;	-----------------------------------------
_mb_read_input_registers:
;	mb_functions.c:317: addr = u16swap(pmb_request->u.RdInputRegs.StartAddr);
	mov	dptr,#_pmb_request
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x08
	add	a,r5
	mov	r2,a
	clr	a
	addc	a,r6
	mov	r3,a
	mov	ar4,r7
	mov	dpl,r2
	mov	dph,r3
	mov	b,r4
	lcall	__gptrget
	mov	r2,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r4,a
	mov	ar3,r2
	mov	r2,#0x00
	mov	ar1,r4
	mov	r4,#0x00
	mov	a,r1
	orl	ar2,a
	mov	a,r4
	orl	ar3,a
;	mb_functions.c:317: addr = u16swap(pmb_request->u.RdInputRegs.StartAddr);
	mov	dptr,#_mb_read_input_registers_addr_65536_155
	mov	a,r2
	movx	@dptr,a
	mov	a,r3
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:318: numregs = u16swap(pmb_request->u.RdInputRegs.NumRegisters);
	mov	a,#0x0a
	add	a,r5
	mov	r5,a
	clr	a
	addc	a,r6
	mov	r6,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrget
	mov	r5,a
	inc	dptr
	lcall	__gptrget
;	mb_functions.c:77: 
	mov	r7,a
	mov	ar6,r5
	clr	a
	mov	r5,a
	mov	r4,a
	mov	a,r7
	orl	ar5,a
	mov	a,r4
	orl	ar6,a
;	mb_functions.c:318: numregs = u16swap(pmb_request->u.RdInputRegs.NumRegisters);
	mov	dptr,#_mb_read_input_registers_numregs_65536_155
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:323: if ((numregs == 0) || (numregs > 0x7D))
	mov	a,r5
	orl	a,r6
	jz	00101$
	mov	ar4,r5
	mov	ar7,r6
	clr	c
	mov	a,#0x7d
	subb	a,r4
	clr	a
	subb	a,r7
	jnc	00102$
00101$:
;	mb_functions.c:324: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_functions.c:326: if ((addr < 4) || (addr > 6)) {
	clr	c
	mov	a,r2
	subb	a,#0x04
	mov	a,r3
	subb	a,#0x00
	jc	00104$
	mov	a,#0x06
	subb	a,r2
	clr	a
	subb	a,r3
	jnc	00105$
00104$:
;	mb_functions.c:327: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_functions.c:330: if (numregs > ( 3 - (addr - 4)))
	mov	a,r2
	add	a,#0xfc
	mov	r2,a
	mov	a,r3
	addc	a,#0xff
	mov	r3,a
	mov	a,#0x03
	clr	c
	subb	a,r2
	mov	r2,a
	clr	a
	subb	a,r3
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r7
	jnc	00108$
;	mb_functions.c:331: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00108$:
;	mb_functions.c:333: mb_response.u.RdInputRegs.Count = (uint8_t)(numregs * 2);
	mov	a,r5
	add	a,r5
	mov	dptr,#(_mb_response + 0x0009)
	movx	@dptr,a
;	mb_functions.c:334: len = 1;
	mov	dptr,#_mb_read_input_registers_len_65536_155
	mov	a,#0x01
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:335: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_read_input_registers_ret_65536_155
	mov	a,#0x04
	movx	@dptr,a
;	mb_functions.c:336: for (i = addr; i<(addr + numregs); i++) {
	mov	dptr,#_mb_read_input_registers_addr_65536_155
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	ar5,r6
	mov	dptr,#_mb_read_input_registers_numregs_65536_155
	movx	a,@dptr
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	mov	r4,a
	mov	ar1,r6
	mov	ar2,r7
	mov	a,r3
	add	a,r6
	mov	r6,a
	mov	a,r4
	addc	a,r7
	mov	r7,a
00127$:
	mov	ar3,r5
	mov	r4,#0x00
	clr	c
	mov	a,r3
	subb	a,r6
	mov	a,r4
	subb	a,r7
	jc	00180$
	ljmp	00120$
00180$:
;	mb_functions.c:337: switch(i) {
	cjne	r5,#0x04,00181$
	sjmp	00109$
00181$:
	cjne	r5,#0x05,00182$
	ljmp	00112$
00182$:
	cjne	r5,#0x06,00183$
	ljmp	00115$
00183$:
	ljmp	00118$
;	mb_functions.c:338: case 0x04:
00109$:
;	mb_functions.c:339: if (ds1621_read_temp(DS1621_ADDR, &u16value)) {
	mov	dptr,#_ds1621_read_temp_PARM_2
	mov	a,#_mb_read_input_registers_u16value_65536_155
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers_u16value_65536_155 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_ds1621_read_temp
	mov	a,dpl
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00184$
	ljmp	00128$
00184$:
;	mb_functions.c:340: mb_response.u.RdInputRegs.Value[i - addr] = u16swap(u16value);
	push	ar6
	push	ar7
	mov	ar3,r5
	mov	r4,#0x00
	mov	a,r3
	clr	c
	subb	a,r1
	mov	r3,a
	mov	a,r4
	subb	a,r2
	mov	r4,a
	mov	a,r3
	add	a,r3
	mov	r3,a
	mov	a,r4
	rlc	a
	mov	r4,a
	mov	a,r3
	add	a,#(_mb_response + 0x000a)
	mov	r3,a
	mov	a,r4
	addc	a,#((_mb_response + 0x000a) >> 8)
	mov	r4,a
	mov	dptr,#_mb_read_input_registers_u16value_65536_155
	movx	a,@dptr
	mov	r0,a
	inc	dptr
	movx	a,@dptr
;	mb_functions.c:77: 
	mov	r6,a
	mov	ar7,r0
	mov	r0,#0x00
;	1-genFromRTrack replaced	mov	_mb_read_input_registers_sloc0_1_0,#0x00
	mov	_mb_read_input_registers_sloc0_1_0,r0
	mov	(_mb_read_input_registers_sloc0_1_0 + 1),r7
	mov	r7,#0x00
	mov	a,_mb_read_input_registers_sloc0_1_0
	orl	ar6,a
	mov	a,(_mb_read_input_registers_sloc0_1_0 + 1)
	orl	ar7,a
;	mb_functions.c:340: mb_response.u.RdInputRegs.Value[i - addr] = u16swap(u16value);
	mov	dpl,r3
	mov	dph,r4
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:341: len += 2;
	mov	dptr,#_mb_read_input_registers_len_65536_155
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x02
	add	a,r6
	mov	r6,a
	clr	a
	addc	a,r7
	mov	r7,a
	mov	dptr,#_mb_read_input_registers_len_65536_155
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:342: mb_set_data_length(len);
	mov	dptr,#_mb_read_input_registers_len_65536_155
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dpl,r6
	mov	dph,r7
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_mb_set_data_length
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_functions.c:343: ret = MB_OK;
	mov	dptr,#_mb_read_input_registers_ret_65536_155
	clr	a
	movx	@dptr,a
;	mb_functions.c:345: break;
	pop	ar7
	pop	ar6
	ljmp	00128$
;	mb_functions.c:346: case 0x05:
00112$:
;	mb_functions.c:347: if (ds1621_read_counter(DS1621_ADDR, &u8value)) {
	mov	dptr,#_ds1621_read_counter_PARM_2
	mov	a,#_mb_read_input_registers_u8value_65536_155
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers_u8value_65536_155 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_ds1621_read_counter
	mov	a,dpl
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00185$
	ljmp	00128$
00185$:
;	mb_functions.c:348: mb_response.u.RdInputRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	push	ar6
	push	ar7
	mov	ar3,r5
	mov	r4,#0x00
	mov	a,r3
	clr	c
	subb	a,r1
	mov	r3,a
	mov	a,r4
	subb	a,r2
	mov	r4,a
	mov	a,r3
	add	a,r3
	mov	r3,a
	mov	a,r4
	rlc	a
	mov	r4,a
	mov	a,r3
	add	a,#(_mb_response + 0x000a)
	mov	r3,a
	mov	a,r4
	addc	a,#((_mb_response + 0x000a) >> 8)
	mov	r4,a
	mov	dptr,#_mb_read_input_registers_u8value_65536_155
	movx	a,@dptr
	mov	r0,a
	mov	r7,#0x00
;	mb_functions.c:77: 
	mov	ar6,r7
	mov	ar7,r0
;	1-genFromRTrack replaced	mov	_mb_read_input_registers_sloc0_1_0,#0x00
	mov	_mb_read_input_registers_sloc0_1_0,r6
	mov	(_mb_read_input_registers_sloc0_1_0 + 1),r7
	mov	r7,#0x00
	mov	a,_mb_read_input_registers_sloc0_1_0
	orl	ar6,a
	mov	a,(_mb_read_input_registers_sloc0_1_0 + 1)
	orl	ar7,a
;	mb_functions.c:348: mb_response.u.RdInputRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	mov	dpl,r3
	mov	dph,r4
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:349: len += 2;
	mov	dptr,#_mb_read_input_registers_len_65536_155
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x02
	add	a,r6
	mov	r6,a
	clr	a
	addc	a,r7
	mov	r7,a
	mov	dptr,#_mb_read_input_registers_len_65536_155
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:350: mb_set_data_length(len);
	mov	dptr,#_mb_read_input_registers_len_65536_155
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dpl,r6
	mov	dph,r7
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_mb_set_data_length
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_functions.c:351: ret = MB_OK;
	mov	dptr,#_mb_read_input_registers_ret_65536_155
	clr	a
	movx	@dptr,a
;	mb_functions.c:353: break;
	pop	ar7
	pop	ar6
	ljmp	00128$
;	mb_functions.c:354: case 0x06:
00115$:
;	mb_functions.c:355: if (ds1621_read_slope(DS1621_ADDR, &u8value)) {
	mov	dptr,#_ds1621_read_slope_PARM_2
	mov	a,#_mb_read_input_registers_u8value_65536_155
	movx	@dptr,a
	mov	a,#(_mb_read_input_registers_u8value_65536_155 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x92
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_ds1621_read_slope
	mov	a,dpl
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00186$
	ljmp	00128$
00186$:
;	mb_functions.c:356: mb_response.u.RdInputRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	push	ar6
	push	ar7
	mov	ar3,r5
	mov	r4,#0x00
	mov	a,r3
	clr	c
	subb	a,r1
	mov	r3,a
	mov	a,r4
	subb	a,r2
	mov	r4,a
	mov	a,r3
	add	a,r3
	mov	r3,a
	mov	a,r4
	rlc	a
	mov	r4,a
	mov	a,r3
	add	a,#(_mb_response + 0x000a)
	mov	r3,a
	mov	a,r4
	addc	a,#((_mb_response + 0x000a) >> 8)
	mov	r4,a
	mov	dptr,#_mb_read_input_registers_u8value_65536_155
	movx	a,@dptr
	mov	r0,a
	mov	r7,#0x00
;	mb_functions.c:77: 
	mov	ar6,r7
	mov	ar7,r0
;	1-genFromRTrack replaced	mov	_mb_read_input_registers_sloc0_1_0,#0x00
	mov	_mb_read_input_registers_sloc0_1_0,r6
	mov	(_mb_read_input_registers_sloc0_1_0 + 1),r7
	mov	r7,#0x00
	mov	a,_mb_read_input_registers_sloc0_1_0
	orl	ar6,a
	mov	a,(_mb_read_input_registers_sloc0_1_0 + 1)
	orl	ar7,a
;	mb_functions.c:356: mb_response.u.RdInputRegs.Value[i - addr] = u16swap((uint16_t)u8value);
	mov	dpl,r3
	mov	dph,r4
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:357: len += 2;
	mov	dptr,#_mb_read_input_registers_len_65536_155
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x02
	add	a,r6
	mov	r6,a
	clr	a
	addc	a,r7
	mov	r7,a
	mov	dptr,#_mb_read_input_registers_len_65536_155
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_functions.c:358: mb_set_data_length(len);
	mov	dptr,#_mb_read_input_registers_len_65536_155
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dpl,r6
	mov	dph,r7
	push	ar7
	push	ar6
	push	ar5
	push	ar2
	push	ar1
	lcall	_mb_set_data_length
	pop	ar1
	pop	ar2
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_functions.c:359: ret = MB_OK;
	mov	dptr,#_mb_read_input_registers_ret_65536_155
	clr	a
	movx	@dptr,a
;	mb_functions.c:361: break;
	pop	ar7
	pop	ar6
;	mb_functions.c:362: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00128$
00118$:
;	mb_functions.c:363: return(ret);
	mov	dpl,#0x02
;	mb_functions.c:365: }
	ret
00128$:
;	mb_functions.c:336: for (i = addr; i<(addr + numregs); i++) {
	inc	r5
	ljmp	00127$
00120$:
;	mb_functions.c:367: return(ret);
	mov	dptr,#_mb_read_input_registers_ret_65536_155
	movx	a,@dptr
;	mb_functions.c:368: }
	mov	dpl,a
	ret
	.area CSEG    (CODE)
	.area CONST   (CODE)
	.area XINIT   (CODE)
	.area CABS    (ABS,CODE)
