#include "vmdevice.h"
#include <stdint.h>
#include <stdio.h>
#include "net.h"
#include "i2c.h"
#include "mb.h"
#include "mb_pcf8574_if.h"

void main(void)
{

	SET_I2CFREQ(100);   // set I2C SCL frequency to 100kHz
	NETTOUT = 10;       // network transmitt timeout 10 * 10 = 100ms

	mb_device_init();
	while(1)
	{
	    if (FNET) {
            //Modbus is listening to socket 3 (VM TCP/IP)
            if (RXCH == CH_VMTCP) {
                //process modbus requests
                mb_handler();
            } else {
                //clear the flag to allow reception of new data
                FNET = 0;
            }
	    }
    }
}
