;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.12 #12748 (MINGW64)
;--------------------------------------------------------
	.module mb_pcf8574_if
	.optsdcc -mmcs51 --model-large
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _BasicDeviceObjects
	.globl _mb_read_holding_registers
	.globl _mb_mask_write_register
	.globl _mb_write_multiple_coils
	.globl _mb_write_single_register
	.globl _mb_write_single_coil
	.globl _mb_read_coils
	.globl _mb_set_data_length
	.globl _mb_init
	.globl _mb_register_function
	.globl _io_setpinstate
	.globl _io_writeport
	.globl _io_readport
	.globl _CY
	.globl _AC
	.globl _F0
	.globl _RS1
	.globl _RS0
	.globl _OV
	.globl _F1
	.globl _P
	.globl _FEXT
	.globl _FTMR
	.globl _FNET
	.globl _EEXT
	.globl _ETMR
	.globl _ENET
	.globl _NETTOUT
	.globl _NETSTAT
	.globl _NETRXLEN
	.globl _NETTXLEN
	.globl _NETCON
	.globl _RXCH
	.globl _RXPORT
	.globl _RXPORTH
	.globl _RXPORTL
	.globl _RXIP
	.globl _RXIP3
	.globl _RXIP2
	.globl _RXIP1
	.globl _RXIP0
	.globl _TXCH
	.globl _TXPORT
	.globl _TXPORTH
	.globl _TXPORTL
	.globl _TXIP
	.globl _TXIP3
	.globl _TXIP2
	.globl _TXIP1
	.globl _TXIP0
	.globl _TMR
	.globl _TMRH
	.globl _TMRL
	.globl _TMRCON
	.globl _IFLAG
	.globl _EXTCON
	.globl _I2CSTAT
	.globl _I2CRXLEN
	.globl _I2CTXLEN
	.globl _I2CFREQ
	.globl _SLVADDR
	.globl _I2CCON
	.globl _IE2
	.globl _B
	.globl _ACC
	.globl _PSW
	.globl _DPH
	.globl _DPL
	.globl _SP
	.globl _NETRXBUF
	.globl _NETTXBUF
	.globl _I2CRXBUF
	.globl _I2CTXBUF
	.globl _mb_device_init
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_IE2	=	0x00c0
_I2CCON	=	0x00c1
_SLVADDR	=	0x00c2
_I2CFREQ	=	0x00c3
_I2CTXLEN	=	0x00c4
_I2CRXLEN	=	0x00c5
_I2CSTAT	=	0x00c6
_EXTCON	=	0x00c7
_IFLAG	=	0x00c8
_TMRCON	=	0x00c9
_TMRL	=	0x00ca
_TMRH	=	0x00cb
_TMR	=	0xcbca
_TXIP0	=	0x00a9
_TXIP1	=	0x00aa
_TXIP2	=	0x00ab
_TXIP3	=	0x00ac
_TXIP	=	0xacabaaa9
_TXPORTL	=	0x00ad
_TXPORTH	=	0x00ae
_TXPORT	=	0xaead
_TXCH	=	0x00af
_RXIP0	=	0x00b1
_RXIP1	=	0x00b2
_RXIP2	=	0x00b3
_RXIP3	=	0x00b4
_RXIP	=	0xb4b3b2b1
_RXPORTL	=	0x00b5
_RXPORTH	=	0x00b6
_RXPORT	=	0xb6b5
_RXCH	=	0x00b7
_NETCON	=	0x00b9
_NETTXLEN	=	0x00ba
_NETRXLEN	=	0x00bb
_NETSTAT	=	0x00bc
_NETTOUT	=	0x00bd
;--------------------------------------------------------
; special function bits
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_ENET	=	0x00c0
_ETMR	=	0x00c1
_EEXT	=	0x00c2
_FNET	=	0x00c8
_FTMR	=	0x00c9
_FEXT	=	0x00ca
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
_mb_read_holding_registers_sloc0_1_0:
	.ds 2
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; absolute internal ram data
;--------------------------------------------------------
	.area IABS    (ABS,DATA)
	.area IABS    (ABS,DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; paged external ram data
;--------------------------------------------------------
	.area PSEG    (PAG,XDATA)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_I2CTXBUF	=	0x0800
_I2CRXBUF	=	0x0900
_NETTXBUF	=	0x0a00
_NETRXBUF	=	0x0b00
_u16swap_val_65536_29:
	.ds 2
_io_slaveaddr:
	.ds 1
_mb_read_coils_value_65536_38:
	.ds 1
_mb_read_coils_ret_65536_38:
	.ds 1
_mb_read_coils_mask_65536_38:
	.ds 1
_mb_read_coils_val_196608_43:
	.ds 2
_mb_read_coils_val_196608_46:
	.ds 2
_mb_write_single_coil_ret_65536_49:
	.ds 1
_mb_write_single_coil_coilstate_65536_49:
	.ds 1
_mb_write_single_coil_val_196608_56:
	.ds 2
_mb_write_single_coil_val_196608_59:
	.ds 2
_mb_write_single_register_ret_65536_62:
	.ds 1
_mb_write_single_register_val_196608_66:
	.ds 2
_mb_write_single_register_val_196608_69:
	.ds 2
_mb_write_multiple_coils_ret_65536_72:
	.ds 1
_mb_write_multiple_coils_value_65536_72:
	.ds 1
_mb_write_multiple_coils_mask_65536_72:
	.ds 1
_mb_write_multiple_coils_val_196608_80:
	.ds 2
_mb_write_multiple_coils_val_196608_83:
	.ds 2
_mb_mask_write_register_ret_65536_86:
	.ds 1
_mb_mask_write_register_value_65536_86:
	.ds 1
_mb_mask_write_register_val_196608_92:
	.ds 2
_mb_mask_write_register_val_196608_95:
	.ds 2
_mb_mask_write_register_val_196608_98:
	.ds 2
_mb_read_holding_registers_ret_65536_101:
	.ds 1
_mb_read_holding_registers_len_65536_101:
	.ds 2
_mb_read_holding_registers_value_65536_101:
	.ds 1
_mb_read_holding_registers_val_196608_108:
	.ds 2
_mb_read_holding_registers_val_196608_111:
	.ds 2
_mb_read_holding_registers_val_393216_114:
	.ds 2
_mb_read_holding_registers_val_458752_117:
	.ds 2
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area XABS    (ABS,XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
	.area HOME    (CODE)
	.area GSINIT0 (CODE)
	.area GSINIT1 (CODE)
	.area GSINIT2 (CODE)
	.area GSINIT3 (CODE)
	.area GSINIT4 (CODE)
	.area GSINIT5 (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME    (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area HOME    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'u16swap'
;------------------------------------------------------------
;val                       Allocated with name '_u16swap_val_65536_29'
;------------------------------------------------------------
;	../VM_Inc/mb.h:263: static inline uint16_t u16swap(uint16_t val)
;	-----------------------------------------
;	 function u16swap
;	-----------------------------------------
_u16swap:
	ar7 = 0x07
	ar6 = 0x06
	ar5 = 0x05
	ar4 = 0x04
	ar3 = 0x03
	ar2 = 0x02
	ar1 = 0x01
	ar0 = 0x00
	mov	r7,dph
	mov	a,dpl
	mov	dptr,#_u16swap_val_65536_29
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	../VM_Inc/mb.h:265: return ((val >> 8) & 0x00FF) | ((val << 8) & 0xFF00);
	mov	dptr,#_u16swap_val_65536_29
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
	mov	dpl,r6
	mov	dph,r7
;	../VM_Inc/mb.h:266: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_coils'
;------------------------------------------------------------
;__1310720027              Allocated with name '_mb_read_coils___1310720027_131072_38'
;__1310720024              Allocated with name '_mb_read_coils___1310720024_131072_38'
;value                     Allocated with name '_mb_read_coils_value_65536_38'
;ret                       Allocated with name '_mb_read_coils_ret_65536_38'
;mask                      Allocated with name '_mb_read_coils_mask_65536_38'
;i                         Allocated with name '_mb_read_coils_i_65536_38'
;startaddr                 Allocated with name '_mb_read_coils_startaddr_65536_38'
;numcoils                  Allocated with name '_mb_read_coils_numcoils_65536_38'
;__1310720025              Allocated with name '_mb_read_coils___1310720025_131072_42'
;val                       Allocated with name '_mb_read_coils_val_196608_43'
;__1310720028              Allocated with name '_mb_read_coils___1310720028_131072_45'
;val                       Allocated with name '_mb_read_coils_val_196608_46'
;------------------------------------------------------------
;	mb_pcf8574_if.c:36: uint8_t mb_read_coils(void)
;	-----------------------------------------
;	 function mb_read_coils
;	-----------------------------------------
_mb_read_coils:
;	mb_pcf8574_if.c:40: uint8_t mask = 0;
	mov	dptr,#_mb_read_coils_mask_65536_38
	clr	a
	movx	@dptr,a
;	mb_pcf8574_if.c:46: startaddr = u16swap(modbus.request.u.RdCoils.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_pcf8574_if.c:47: numcoils = u16swap(modbus.request.u.RdCoils.NumCoils);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_pcf8574_if.c:54: if ((numcoils < MB_RD_MIN_NUM_COILS) || (numcoils > MB_RD_MAX_NUM_COILS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0xd0
	subb	a,r2
	mov	a,#0x07
	subb	a,r3
	jnc	00102$
00101$:
;	mb_pcf8574_if.c:55: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_pcf8574_if.c:57: if ((startaddr > (PCF8574_MAX_COILS-1)) || (numcoils > (PCF8574_MAX_COILS - startaddr)))
	clr	c
	mov	a,#0x07
	subb	a,r6
	clr	a
	subb	a,r7
	jc	00104$
	mov	a,#0x08
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00105$
00104$:
;	mb_pcf8574_if.c:58: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_pcf8574_if.c:60: if (io_readport(io_slaveaddr, &value)) {
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r3,a
	mov	dptr,#_io_readport_PARM_2
	mov	a,#_mb_read_coils_value_65536_38
	movx	@dptr,a
	mov	a,#(_mb_read_coils_value_65536_38 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,r3
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	lcall	_io_readport
	mov	a,dpl
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jz	00109$
;	mb_pcf8574_if.c:61: value >>= startaddr;
	mov	dptr,#_mb_read_coils_value_65536_38
	movx	a,@dptr
	mov	b,r6
	inc	b
	sjmp	00145$
00144$:
	clr	c
	rrc	a
00145$:
	djnz	b,00144$
	mov	dptr,#_mb_read_coils_value_65536_38
	movx	@dptr,a
;	mb_pcf8574_if.c:62: for(i=0;i<numcoils;i++){
	mov	r7,#0x00
00114$:
	mov	ar3,r7
	mov	r6,#0x00
	clr	c
	mov	a,r3
	subb	a,r4
	mov	a,r6
	subb	a,r5
	jnc	00107$
;	mb_pcf8574_if.c:63: mask += (1<<i);
	mov	ar6,r7
	mov	b,r6
	inc	b
	mov	a,#0x01
	sjmp	00149$
00147$:
	add	a,acc
00149$:
	djnz	b,00147$
	mov	r6,a
	mov	dptr,#_mb_read_coils_mask_65536_38
	movx	a,@dptr
	mov	r3,a
	add	a,r6
	movx	@dptr,a
;	mb_pcf8574_if.c:62: for(i=0;i<numcoils;i++){
	inc	r7
	sjmp	00114$
00107$:
;	mb_pcf8574_if.c:65: value &= mask;
	mov	dptr,#_mb_read_coils_value_65536_38
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_mb_read_coils_mask_65536_38
	movx	a,@dptr
	mov	dptr,#_mb_read_coils_value_65536_38
	anl	a,r7
	movx	@dptr,a
;	mb_pcf8574_if.c:66: modbus.response.u.RdCoils.Count = 1;            // 1 byte -> "Byte Count" -> 8Bits IO-Expander, therefore only one byte
	mov	dptr,#(_modbus + 0x0130)
	mov	a,#0x01
	movx	@dptr,a
;	mb_pcf8574_if.c:67: modbus.response.u.RdCoils.Status[0] = value;    // 1 byte -> "Coil Status"
	mov	dptr,#_mb_read_coils_value_65536_38
	movx	a,@dptr
	mov	dptr,#(_modbus + 0x0131)
	movx	@dptr,a
;	mb_pcf8574_if.c:68: mb_set_data_length(2);                          // 2 bytes: 1x "Byte Count" and 1x "Coil Status"
	mov	dptr,#0x0002
	lcall	_mb_set_data_length
;	mb_pcf8574_if.c:69: ret = MB_OK;
	mov	dptr,#_mb_read_coils_ret_65536_38
	clr	a
	movx	@dptr,a
	sjmp	00110$
00109$:
;	mb_pcf8574_if.c:70: } else ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_read_coils_ret_65536_38
	mov	a,#0x04
	movx	@dptr,a
00110$:
;	mb_pcf8574_if.c:71: return(ret);
	mov	dptr,#_mb_read_coils_ret_65536_38
	movx	a,@dptr
;	mb_pcf8574_if.c:72: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_single_coil'
;------------------------------------------------------------
;__1310720033              Allocated with name '_mb_write_single_coil___1310720033_131072_49'
;__1310720030              Allocated with name '_mb_write_single_coil___1310720030_131072_49'
;ret                       Allocated with name '_mb_write_single_coil_ret_65536_49'
;addr                      Allocated with name '_mb_write_single_coil_addr_65536_49'
;coilvalue                 Allocated with name '_mb_write_single_coil_coilvalue_65536_49'
;coilstate                 Allocated with name '_mb_write_single_coil_coilstate_65536_49'
;__1310720031              Allocated with name '_mb_write_single_coil___1310720031_131072_55'
;val                       Allocated with name '_mb_write_single_coil_val_196608_56'
;__1310720034              Allocated with name '_mb_write_single_coil___1310720034_131072_58'
;val                       Allocated with name '_mb_write_single_coil_val_196608_59'
;------------------------------------------------------------
;	mb_pcf8574_if.c:74: uint8_t mb_write_single_coil(void)
;	-----------------------------------------
;	 function mb_write_single_coil
;	-----------------------------------------
_mb_write_single_coil:
;	mb_pcf8574_if.c:82: addr = u16swap(modbus.request.u.WrSingleCoil.Addr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_pcf8574_if.c:83: coilvalue = u16swap(modbus.request.u.WrSingleCoil.Value);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_pcf8574_if.c:91: if (coilvalue == MB_COIL_LOW) {
	mov	a,r4
	orl	a,r5
	jnz	00105$
;	mb_pcf8574_if.c:92: coilstate = 0x00;
	mov	dptr,#_mb_write_single_coil_coilstate_65536_49
	clr	a
	movx	@dptr,a
	sjmp	00106$
00105$:
;	mb_pcf8574_if.c:93: } else if (coilvalue == MB_COIL_HIGH) {
	cjne	r4,#0x00,00102$
	cjne	r5,#0xff,00102$
;	mb_pcf8574_if.c:94: coilstate = 0x01;
	mov	dptr,#_mb_write_single_coil_coilstate_65536_49
	mov	a,#0x01
	movx	@dptr,a
	sjmp	00106$
00102$:
;	mb_pcf8574_if.c:96: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00106$:
;	mb_pcf8574_if.c:99: if (addr > (PCF8574_MAX_COILS-1))
	clr	c
	mov	a,#0x07
	subb	a,r6
	clr	a
	subb	a,r7
	jnc	00108$
;	mb_pcf8574_if.c:100: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00108$:
;	mb_pcf8574_if.c:102: if (io_setpinstate(io_slaveaddr, addr,coilstate)) {
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r5,a
	mov	dptr,#_mb_write_single_coil_coilstate_65536_49
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_io_setpinstate_PARM_2
	mov	a,r6
	movx	@dptr,a
	mov	dptr,#_io_setpinstate_PARM_3
	mov	a,r7
	movx	@dptr,a
	mov	dpl,r5
	lcall	_io_setpinstate
	mov	a,dpl
	jz	00110$
;	mb_pcf8574_if.c:104: modbus.response.u.WrSingleCoil.Addr = modbus.request.u.WrSingleCoil.Addr;   //2 bytes
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:105: modbus.response.u.WrSingleCoil.Value = modbus.request.u.WrSingleCoil.Value; //2 bytes
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:106: mb_set_data_length(4);                                                      //4 bytes total
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_pcf8574_if.c:107: ret = MB_OK;
	mov	dptr,#_mb_write_single_coil_ret_65536_49
	clr	a
	movx	@dptr,a
	sjmp	00111$
00110$:
;	mb_pcf8574_if.c:109: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_coil_ret_65536_49
	mov	a,#0x04
	movx	@dptr,a
00111$:
;	mb_pcf8574_if.c:111: return(ret);
	mov	dptr,#_mb_write_single_coil_ret_65536_49
	movx	a,@dptr
;	mb_pcf8574_if.c:112: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_single_register'
;------------------------------------------------------------
;__1310720039              Allocated with name '_mb_write_single_register___1310720039_131072_62'
;__1310720036              Allocated with name '_mb_write_single_register___1310720036_131072_62'
;ret                       Allocated with name '_mb_write_single_register_ret_65536_62'
;addr                      Allocated with name '_mb_write_single_register_addr_65536_62'
;value                     Allocated with name '_mb_write_single_register_value_65536_62'
;__1310720037              Allocated with name '_mb_write_single_register___1310720037_131072_65'
;val                       Allocated with name '_mb_write_single_register_val_196608_66'
;__1310720040              Allocated with name '_mb_write_single_register___1310720040_131072_68'
;val                       Allocated with name '_mb_write_single_register_val_196608_69'
;------------------------------------------------------------
;	mb_pcf8574_if.c:114: uint8_t mb_write_single_register(void)
;	-----------------------------------------
;	 function mb_write_single_register
;	-----------------------------------------
_mb_write_single_register:
;	mb_pcf8574_if.c:121: addr = u16swap(modbus.request.u.WrSingleReg.Addr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r7,a
	mov	r5,a
	mov	ar4,r6
	clr	a
	mov	r3,a
	mov	r2,a
	mov	a,r5
	orl	ar3,a
	mov	a,r2
	orl	ar4,a
;	mb_pcf8574_if.c:122: value = u16swap(modbus.request.u.WrSingleReg.Value);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r2,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r1,a
	mov	ar5,r2
	mov	r2,#0x00
	mov	ar0,r1
	mov	r1,#0x00
	mov	a,r0
	orl	ar2,a
	mov	a,r1
	orl	ar5,a
;	mb_pcf8574_if.c:128: modbus.response.u.WrSingleReg.Addr = modbus.request.u.WrSingleReg.Addr;
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:129: modbus.response.u.WrSingleReg.Value = modbus.request.u.WrSingleReg.Value;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:130: mb_set_data_length(4);
	mov	dptr,#0x0004
	push	ar5
	push	ar4
	push	ar3
	push	ar2
	lcall	_mb_set_data_length
	pop	ar2
	pop	ar3
	pop	ar4
	pop	ar5
;	mb_pcf8574_if.c:131: ret = MB_OK;
	mov	dptr,#_mb_write_single_register_ret_65536_62
	clr	a
	movx	@dptr,a
;	mb_pcf8574_if.c:132: switch(addr) {
	cjne	r3,#0x00,00123$
	cjne	r4,#0x00,00123$
	sjmp	00101$
00123$:
;	mb_pcf8574_if.c:133: case 0 :    io_slaveaddr = (uint8_t)(value & 0x00FE);
	cjne	r3,#0x01,00105$
	cjne	r4,#0x00,00105$
	sjmp	00102$
00101$:
	mov	ar7,r2
	mov	dptr,#_io_slaveaddr
	mov	a,#0xfe
	anl	a,r7
	movx	@dptr,a
;	mb_pcf8574_if.c:134: break;
;	mb_pcf8574_if.c:135: case 1 :    if (!io_writeport(io_slaveaddr, (uint8_t)(value & 0x00FF))) {
	sjmp	00106$
00102$:
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_io_writeport_PARM_2
	mov	a,r2
	movx	@dptr,a
	mov	dpl,r7
	lcall	_io_writeport
	mov	a,dpl
	jnz	00106$
;	mb_pcf8574_if.c:136: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_62
	mov	a,#0x04
	movx	@dptr,a
;	mb_pcf8574_if.c:138: break;
;	mb_pcf8574_if.c:139: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS; break;
	sjmp	00106$
00105$:
	mov	dptr,#_mb_write_single_register_ret_65536_62
	mov	a,#0x02
	movx	@dptr,a
;	mb_pcf8574_if.c:140: }
00106$:
;	mb_pcf8574_if.c:141: return(ret);
	mov	dptr,#_mb_write_single_register_ret_65536_62
	movx	a,@dptr
;	mb_pcf8574_if.c:142: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_multiple_coils'
;------------------------------------------------------------
;__1310720045              Allocated with name '_mb_write_multiple_coils___1310720045_131072_72'
;__1310720042              Allocated with name '_mb_write_multiple_coils___1310720042_131072_72'
;ret                       Allocated with name '_mb_write_multiple_coils_ret_65536_72'
;startaddr                 Allocated with name '_mb_write_multiple_coils_startaddr_65536_72'
;numcoils                  Allocated with name '_mb_write_multiple_coils_numcoils_65536_72'
;coils_state               Allocated with name '_mb_write_multiple_coils_coils_state_65536_72'
;value                     Allocated with name '_mb_write_multiple_coils_value_65536_72'
;mask                      Allocated with name '_mb_write_multiple_coils_mask_65536_72'
;i                         Allocated with name '_mb_write_multiple_coils_i_65536_72'
;__1310720043              Allocated with name '_mb_write_multiple_coils___1310720043_131072_79'
;val                       Allocated with name '_mb_write_multiple_coils_val_196608_80'
;__1310720046              Allocated with name '_mb_write_multiple_coils___1310720046_131072_82'
;val                       Allocated with name '_mb_write_multiple_coils_val_196608_83'
;------------------------------------------------------------
;	mb_pcf8574_if.c:144: uint8_t mb_write_multiple_coils(void)
;	-----------------------------------------
;	 function mb_write_multiple_coils
;	-----------------------------------------
_mb_write_multiple_coils:
;	mb_pcf8574_if.c:151: uint8_t mask = 0;
	mov	dptr,#_mb_write_multiple_coils_mask_65536_72
	clr	a
	movx	@dptr,a
;	mb_pcf8574_if.c:155: startaddr = u16swap(modbus.request.u.WrMultCoils.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_pcf8574_if.c:156: numcoils = u16swap(modbus.request.u.WrMultCoils.NumCoils);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_pcf8574_if.c:163: if ((numcoils < MB_WR_MIN_NUM_COILS) || (numcoils > MB_WR_MAX_NUM_COILS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0xb0
	subb	a,r2
	mov	a,#0x07
	subb	a,r3
	jnc	00102$
00101$:
;	mb_pcf8574_if.c:164: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_pcf8574_if.c:166: if (modbus.src_socket.rxlen < MB_WRITE_MIN_PACKET_SIZE)
	mov	dptr,#(_modbus + 0x000b)
	movx	a,@dptr
	mov	r3,a
	cjne	r3,#0x0e,00160$
00160$:
	jnc	00105$
;	mb_pcf8574_if.c:167: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00105$:
;	mb_pcf8574_if.c:169: if (modbus.request.u.WrMultCoils.Count != (modbus.src_socket.rxlen - (MB_WRITE_MIN_PACKET_SIZE-1)))
	mov	dptr,#(_modbus + 0x0034)
	movx	a,@dptr
	mov	r2,a
	mov	ar1,r3
	mov	r3,#0x00
	mov	a,r1
	add	a,#0xf3
	mov	r1,a
	mov	a,r3
	addc	a,#0xff
	mov	r3,a
	mov	ar0,r2
	mov	r2,#0x00
	mov	a,r0
	cjne	a,ar1,00162$
	mov	a,r2
	cjne	a,ar3,00162$
	sjmp	00107$
00162$:
;	mb_pcf8574_if.c:170: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00107$:
;	mb_pcf8574_if.c:172: if ((startaddr > (PCF8574_MAX_COILS-1)) || (numcoils > (PCF8574_MAX_COILS - startaddr)))
	clr	c
	mov	a,#0x07
	subb	a,r6
	clr	a
	subb	a,r7
	jc	00108$
	mov	a,#0x08
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00109$
00108$:
;	mb_pcf8574_if.c:173: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00109$:
;	mb_pcf8574_if.c:175: coils_state = modbus.request.u.WrMultCoils.Value[0];
	mov	dptr,#(_modbus + 0x0035)
	movx	a,@dptr
	mov	r3,a
;	mb_pcf8574_if.c:177: if (io_readport(io_slaveaddr, &value)) {
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r2,a
	mov	dptr,#_io_readport_PARM_2
	mov	a,#_mb_write_multiple_coils_value_65536_72
	movx	@dptr,a
	mov	a,#(_mb_write_multiple_coils_value_65536_72 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,r2
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_io_readport
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00165$
	ljmp	00116$
00165$:
;	mb_pcf8574_if.c:178: for(i=0;i<numcoils;i++){
	mov	r2,#0x00
00121$:
	mov	ar0,r2
	mov	r1,#0x00
	clr	c
	mov	a,r0
	subb	a,r4
	mov	a,r1
	subb	a,r5
	jnc	00111$
;	mb_pcf8574_if.c:179: mask += (1<<i);
	mov	ar1,r2
	mov	b,r1
	inc	b
	mov	a,#0x01
	sjmp	00169$
00167$:
	add	a,acc
00169$:
	djnz	b,00167$
	mov	r1,a
	mov	dptr,#_mb_write_multiple_coils_mask_65536_72
	movx	a,@dptr
	mov	r0,a
	add	a,r1
	movx	@dptr,a
;	mb_pcf8574_if.c:178: for(i=0;i<numcoils;i++){
	inc	r2
	sjmp	00121$
00111$:
;	mb_pcf8574_if.c:181: mask <<= startaddr;
	mov	dptr,#_mb_write_multiple_coils_mask_65536_72
	movx	a,@dptr
	mov	r5,a
	mov	b,r6
	inc	b
	mov	a,r5
	sjmp	00172$
00170$:
	add	a,acc
00172$:
	djnz	b,00170$
	mov	dptr,#_mb_write_multiple_coils_mask_65536_72
	movx	@dptr,a
;	mb_pcf8574_if.c:182: value &= ~mask;
	movx	a,@dptr
	mov	r7,a
	cpl	a
	mov	r5,a
	mov	dptr,#_mb_write_multiple_coils_value_65536_72
	movx	a,@dptr
	anl	a,r5
	movx	@dptr,a
;	mb_pcf8574_if.c:183: coils_state <<= startaddr;
	mov	b,r6
	inc	b
	mov	a,r3
	sjmp	00175$
00173$:
	add	a,acc
00175$:
	djnz	b,00173$
;	mb_pcf8574_if.c:184: coils_state &= mask;
	anl	ar7,a
;	mb_pcf8574_if.c:185: value |= coils_state;
	mov	dptr,#_mb_write_multiple_coils_value_65536_72
	movx	a,@dptr
	orl	a,r7
	movx	@dptr,a
;	mb_pcf8574_if.c:187: if (io_writeport(io_slaveaddr, value)) {
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_mb_write_multiple_coils_value_65536_72
	movx	a,@dptr
	mov	dptr,#_io_writeport_PARM_2
	movx	@dptr,a
	mov	dpl,r7
	lcall	_io_writeport
	mov	a,dpl
	jz	00113$
;	mb_pcf8574_if.c:188: modbus.response.u.WrMultCoils.StartAddr = modbus.request.u.WrMultCoils.StartAddr;
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:189: modbus.response.u.WrMultCoils.NumCoils = modbus.request.u.WrMultCoils.NumCoils;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:190: mb_set_data_length(4);
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_pcf8574_if.c:191: ret = MB_OK;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_72
	clr	a
	movx	@dptr,a
	sjmp	00117$
00113$:
;	mb_pcf8574_if.c:193: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_72
	mov	a,#0x04
	movx	@dptr,a
	sjmp	00117$
00116$:
;	mb_pcf8574_if.c:196: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_72
	mov	a,#0x04
	movx	@dptr,a
00117$:
;	mb_pcf8574_if.c:198: return(ret);
	mov	dptr,#_mb_write_multiple_coils_ret_65536_72
	movx	a,@dptr
;	mb_pcf8574_if.c:199: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_mask_write_register'
;------------------------------------------------------------
;__1310720054              Allocated with name '_mb_mask_write_register___1310720054_131072_86'
;__1310720051              Allocated with name '_mb_mask_write_register___1310720051_131072_86'
;__1310720048              Allocated with name '_mb_mask_write_register___1310720048_131072_86'
;ret                       Allocated with name '_mb_mask_write_register_ret_65536_86'
;value                     Allocated with name '_mb_mask_write_register_value_65536_86'
;addr                      Allocated with name '_mb_mask_write_register_addr_65536_86'
;andmask                   Allocated with name '_mb_mask_write_register_andmask_65536_86'
;ormask                    Allocated with name '_mb_mask_write_register_ormask_65536_86'
;__1310720049              Allocated with name '_mb_mask_write_register___1310720049_131072_91'
;val                       Allocated with name '_mb_mask_write_register_val_196608_92'
;__1310720052              Allocated with name '_mb_mask_write_register___1310720052_131072_94'
;val                       Allocated with name '_mb_mask_write_register_val_196608_95'
;__1310720055              Allocated with name '_mb_mask_write_register___1310720055_131072_97'
;val                       Allocated with name '_mb_mask_write_register_val_196608_98'
;------------------------------------------------------------
;	mb_pcf8574_if.c:201: uint8_t mb_mask_write_register(void)
;	-----------------------------------------
;	 function mb_mask_write_register
;	-----------------------------------------
_mb_mask_write_register:
;	mb_pcf8574_if.c:209: addr = u16swap(modbus.request.u.MaskWrReg.Addr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_pcf8574_if.c:210: andmask = u16swap(modbus.request.u.MaskWrReg.AndMask);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r3,a
	clr	a
	orl	a,r3
	mov	r5,a
;	mb_pcf8574_if.c:211: ormask = u16swap(modbus.request.u.MaskWrReg.OrMask);
	mov	dptr,#(_modbus + 0x0034)
	movx	a,@dptr
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r2,a
	clr	a
	mov	r3,a
	orl	a,r2
	mov	r4,a
;	mb_pcf8574_if.c:217: if (addr != 1) //only to be used with register 1 (Expander IO)
	cjne	r6,#0x01,00126$
	cjne	r7,#0x00,00126$
	sjmp	00102$
00126$:
;	mb_pcf8574_if.c:218: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00102$:
;	mb_pcf8574_if.c:220: if (io_readport(io_slaveaddr, &value)) {
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_io_readport_PARM_2
	mov	a,#_mb_mask_write_register_value_65536_86
	movx	@dptr,a
	mov	a,#(_mb_mask_write_register_value_65536_86 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,r7
	push	ar5
	push	ar4
	lcall	_io_readport
	mov	a,dpl
	pop	ar4
	pop	ar5
	jz	00107$
;	mb_pcf8574_if.c:221: value = (value & andmask) | (ormask & (~andmask));
	mov	dptr,#_mb_mask_write_register_value_65536_86
	movx	a,@dptr
	mov	r7,a
	mov	a,r5
	anl	ar7,a
	mov	a,r5
	cpl	a
	mov	r5,a
	mov	a,r4
	anl	a,r5
	mov	dptr,#_mb_mask_write_register_value_65536_86
	orl	a,r7
	movx	@dptr,a
;	mb_pcf8574_if.c:222: if (io_writeport(io_slaveaddr, value)) {
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_mb_mask_write_register_value_65536_86
	movx	a,@dptr
	mov	dptr,#_io_writeport_PARM_2
	movx	@dptr,a
	mov	dpl,r7
	lcall	_io_writeport
	mov	a,dpl
	jz	00104$
;	mb_pcf8574_if.c:223: modbus.response.u.MaskWrReg.Addr = modbus.request.u.MaskWrReg.Addr;
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:224: modbus.response.u.MaskWrReg.AndMask = modbus.request.u.MaskWrReg.AndMask;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:225: modbus.response.u.MaskWrReg.OrMask = modbus.request.u.MaskWrReg.OrMask;
	mov	dptr,#(_modbus + 0x0034)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0134)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:226: mb_set_data_length(6);
	mov	dptr,#0x0006
	lcall	_mb_set_data_length
;	mb_pcf8574_if.c:227: ret = MB_OK;
	mov	dptr,#_mb_mask_write_register_ret_65536_86
	clr	a
	movx	@dptr,a
	sjmp	00108$
00104$:
;	mb_pcf8574_if.c:229: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_mask_write_register_ret_65536_86
	mov	a,#0x04
	movx	@dptr,a
	sjmp	00108$
00107$:
;	mb_pcf8574_if.c:232: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_mask_write_register_ret_65536_86
	mov	a,#0x04
	movx	@dptr,a
00108$:
;	mb_pcf8574_if.c:234: return(ret);
	mov	dptr,#_mb_mask_write_register_ret_65536_86
	movx	a,@dptr
;	mb_pcf8574_if.c:235: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_holding_registers'
;------------------------------------------------------------
;sloc0                     Allocated with name '_mb_read_holding_registers_sloc0_1_0'
;__1310720060              Allocated with name '_mb_read_holding_registers___1310720060_131072_101'
;__1310720057              Allocated with name '_mb_read_holding_registers___1310720057_131072_101'
;ret                       Allocated with name '_mb_read_holding_registers_ret_65536_101'
;addr                      Allocated with name '_mb_read_holding_registers_addr_65536_101'
;numregs                   Allocated with name '_mb_read_holding_registers_numregs_65536_101'
;len                       Allocated with name '_mb_read_holding_registers_len_65536_101'
;i                         Allocated with name '_mb_read_holding_registers_i_65536_101'
;value                     Allocated with name '_mb_read_holding_registers_value_65536_101'
;__1310720058              Allocated with name '_mb_read_holding_registers___1310720058_131072_107'
;val                       Allocated with name '_mb_read_holding_registers_val_196608_108'
;__1310720061              Allocated with name '_mb_read_holding_registers___1310720061_131072_110'
;val                       Allocated with name '_mb_read_holding_registers_val_196608_111'
;__3276800063              Allocated with name '_mb_read_holding_registers___3276800063_327680_104'
;__3276800064              Allocated with name '_mb_read_holding_registers___3276800064_327680_113'
;val                       Allocated with name '_mb_read_holding_registers_val_393216_114'
;__3932160066              Allocated with name '_mb_read_holding_registers___3932160066_393216_105'
;__3932160067              Allocated with name '_mb_read_holding_registers___3932160067_393216_116'
;val                       Allocated with name '_mb_read_holding_registers_val_458752_117'
;------------------------------------------------------------
;	mb_pcf8574_if.c:237: uint8_t mb_read_holding_registers(void)
;	-----------------------------------------
;	 function mb_read_holding_registers
;	-----------------------------------------
_mb_read_holding_registers:
;	mb_pcf8574_if.c:239: uint8_t ret = MB_ERR_UNKNOWN;
	mov	dptr,#_mb_read_holding_registers_ret_65536_101
	mov	a,#0xff
	movx	@dptr,a
;	mb_pcf8574_if.c:246: addr = u16swap(modbus.request.u.RdHoldingRegs.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_pcf8574_if.c:247: numregs = u16swap(modbus.request.u.RdHoldingRegs.NumRegisters);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_pcf8574_if.c:252: if ((numregs < MB_RD_MIN_NUM_REGS) || (numregs > MB_RD_MAX_NUM_REGS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0x7d
	subb	a,r2
	clr	a
	subb	a,r3
	jnc	00102$
00101$:
;	mb_pcf8574_if.c:253: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_pcf8574_if.c:255: if ((addr > (PCF8574_MAX_REGS-1)) || (numregs > (PCF8574_MAX_REGS - addr)))
	clr	c
	mov	a,#0x01
	subb	a,r6
	clr	a
	subb	a,r7
	jc	00104$
	mov	a,#0x02
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00105$
00104$:
;	mb_pcf8574_if.c:256: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_pcf8574_if.c:258: modbus.response.u.RdHoldingRegs.Count = (uint8_t)(numregs * 2);
	mov	ar3,r4
	mov	a,r3
	add	a,r3
	mov	dptr,#(_modbus + 0x0130)
	movx	@dptr,a
;	mb_pcf8574_if.c:259: len = 1;
	mov	dptr,#_mb_read_holding_registers_len_65536_101
	mov	a,#0x01
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:260: for (i = addr; i<(addr + numregs); i++) {
	mov	ar3,r6
	mov	a,r4
	add	a,r6
	mov	r4,a
	mov	a,r5
	addc	a,r7
	mov	r5,a
00122$:
	mov	ar1,r3
	mov	r2,#0x00
	clr	c
	mov	a,r1
	subb	a,r4
	mov	a,r2
	subb	a,r5
	jc	00163$
	ljmp	00116$
00163$:
;	mb_pcf8574_if.c:261: switch(i) {
	cjne	r3,#0x00,00164$
	sjmp	00107$
00164$:
	cjne	r3,#0x01,00165$
	ljmp	00108$
00165$:
	ljmp	00112$
;	mb_pcf8574_if.c:262: case 0 :    modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap((uint16_t)io_slaveaddr);
00107$:
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r0,a
	mov	r5,#0x00
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	ar4,r5
	mov	ar5,r0
;	1-genFromRTrack replaced	mov	_mb_read_holding_registers_sloc0_1_0,#0x00
	mov	_mb_read_holding_registers_sloc0_1_0,r4
	mov	(_mb_read_holding_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_holding_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_holding_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_pcf8574_if.c:262: case 0 :    modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap((uint16_t)io_slaveaddr);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:263: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_101
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_holding_registers_len_65536_101
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:264: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_101
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_101
	clr	a
	movx	@dptr,a
;	mb_pcf8574_if.c:266: break;
	pop	ar5
	pop	ar4
	ljmp	00113$
;	mb_pcf8574_if.c:267: case 1 :    if (io_readport(io_slaveaddr, &value)) {
00108$:
	mov	dptr,#_io_slaveaddr
	movx	a,@dptr
	mov	r2,a
	mov	dptr,#_io_readport_PARM_2
	mov	a,#_mb_read_holding_registers_value_65536_101
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers_value_65536_101 >> 8)
	inc	dptr
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
	mov	dpl,r2
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_io_readport
	mov	a,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
	jnz	00166$
	ljmp	00110$
00166$:
;	mb_pcf8574_if.c:268: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap((uint16_t)value);
	push	ar4
	push	ar5
	mov	ar1,r3
	mov	r2,#0x00
	mov	a,r1
	clr	c
	subb	a,r6
	mov	r1,a
	mov	a,r2
	subb	a,r7
	mov	r2,a
	mov	a,r1
	add	a,r1
	mov	r1,a
	mov	a,r2
	rlc	a
	mov	r2,a
	mov	a,r1
	add	a,#(_modbus + 0x0131)
	mov	r1,a
	mov	a,r2
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	r2,a
	mov	dptr,#_mb_read_holding_registers_value_65536_101
	movx	a,@dptr
	mov	r0,a
	mov	r5,#0x00
;	mb_pcf8574_if.c:265: ret = MB_OK;
	mov	ar4,r5
	mov	ar5,r0
;	1-genFromRTrack replaced	mov	_mb_read_holding_registers_sloc0_1_0,#0x00
	mov	_mb_read_holding_registers_sloc0_1_0,r4
	mov	(_mb_read_holding_registers_sloc0_1_0 + 1),r5
	mov	r5,#0x00
	mov	a,_mb_read_holding_registers_sloc0_1_0
	orl	ar4,a
	mov	a,(_mb_read_holding_registers_sloc0_1_0 + 1)
	orl	ar5,a
;	mb_pcf8574_if.c:268: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap((uint16_t)value);
	mov	dpl,r1
	mov	dph,r2
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:269: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_101
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_holding_registers_len_65536_101
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_pcf8574_if.c:270: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_101
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_pcf8574_if.c:271: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_101
	clr	a
	movx	@dptr,a
	pop	ar5
	pop	ar4
	sjmp	00113$
00110$:
;	mb_pcf8574_if.c:273: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_read_holding_registers_ret_65536_101
	mov	a,#0x04
	movx	@dptr,a
;	mb_pcf8574_if.c:275: break;
;	mb_pcf8574_if.c:276: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00113$
00112$:
	mov	dptr,#_mb_read_holding_registers_ret_65536_101
	mov	a,#0x02
	movx	@dptr,a
;	mb_pcf8574_if.c:278: }
00113$:
;	mb_pcf8574_if.c:279: if (ret != MB_OK)
	mov	dptr,#_mb_read_holding_registers_ret_65536_101
	movx	a,@dptr
	jnz	00116$
;	mb_pcf8574_if.c:260: for (i = addr; i<(addr + numregs); i++) {
	inc	r3
	ljmp	00122$
00116$:
;	mb_pcf8574_if.c:283: return(ret);
	mov	dptr,#_mb_read_holding_registers_ret_65536_101
	movx	a,@dptr
;	mb_pcf8574_if.c:284: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_device_init'
;------------------------------------------------------------
;	mb_pcf8574_if.c:286: void mb_device_init(void)
;	-----------------------------------------
;	 function mb_device_init
;	-----------------------------------------
_mb_device_init:
;	mb_pcf8574_if.c:288: mb_init(BasicDeviceObjects, sizeof(BasicDeviceObjects), CH_VMTCP);
	mov	dptr,#_mb_init_PARM_2
	mov	a,#0x25
	movx	@dptr,a
	mov	dptr,#_mb_init_PARM_3
	mov	a,#0x03
	movx	@dptr,a
	mov	dptr,#_BasicDeviceObjects
	mov	b,#0x80
	lcall	_mb_init
;	mb_pcf8574_if.c:290: io_slaveaddr = 0x40;
	mov	dptr,#_io_slaveaddr
	mov	a,#0x40
	movx	@dptr,a
;	mb_pcf8574_if.c:292: mb_register_function(MB_CMD_READ_COILS, mb_read_coils);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_read_coils
	movx	@dptr,a
	mov	a,#(_mb_read_coils >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x01
	lcall	_mb_register_function
;	mb_pcf8574_if.c:294: mb_register_function(MB_CMD_READ_HOLDING_REGISTERS, mb_read_holding_registers);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_read_holding_registers
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x03
	lcall	_mb_register_function
;	mb_pcf8574_if.c:296: mb_register_function(MB_CMD_WRITE_SINGLE_COIL, mb_write_single_coil);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_single_coil
	movx	@dptr,a
	mov	a,#(_mb_write_single_coil >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x05
	lcall	_mb_register_function
;	mb_pcf8574_if.c:297: mb_register_function(MB_CMD_WRITE_SINGLE_REGISTER, mb_write_single_register);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_single_register
	movx	@dptr,a
	mov	a,#(_mb_write_single_register >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x06
	lcall	_mb_register_function
;	mb_pcf8574_if.c:298: mb_register_function(MB_CMD_WRITE_MULTIPLE_COILS, mb_write_multiple_coils);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_multiple_coils
	movx	@dptr,a
	mov	a,#(_mb_write_multiple_coils >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x0f
	lcall	_mb_register_function
;	mb_pcf8574_if.c:300: mb_register_function(MB_CMD_WRITE_MASK_REGISTER, mb_mask_write_register);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_mask_write_register
	movx	@dptr,a
	mov	a,#(_mb_mask_write_register >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x16
;	mb_pcf8574_if.c:302: }
	ljmp	_mb_register_function
	.area CSEG    (CODE)
	.area CONST   (CODE)
_BasicDeviceObjects:
	.db #0x00	; 0
	.db #0x0d	; 13
	.db #0x43	; 67	'C'
	.db #0x6f	; 111	'o'
	.db #0x70	; 112	'p'
	.db #0x74	; 116	't'
	.db #0x6f	; 111	'o'
	.db #0x6e	; 110	'n'
	.db #0x69	; 105	'i'
	.db #0x78	; 120	'x'
	.db #0x20	; 32
	.db #0x47	; 71	'G'
	.db #0x6d	; 109	'm'
	.db #0x62	; 98	'b'
	.db #0x48	; 72	'H'
	.db #0x01	; 1
	.db #0x0e	; 14
	.db #0x4d	; 77	'M'
	.db #0x42	; 66	'B'
	.db #0x20	; 32
	.db #0x49	; 73	'I'
	.db #0x4f	; 79	'O'
	.db #0x2d	; 45
	.db #0x45	; 69	'E'
	.db #0x50	; 80	'P'
	.db #0x41	; 65	'A'
	.db #0x4e	; 78	'N'
	.db #0x44	; 68	'D'
	.db #0x45	; 69	'E'
	.db #0x52	; 82	'R'
	.db #0x02	; 2
	.db #0x05	; 5
	.db #0x56	; 86	'V'
	.db #0x31	; 49	'1'
	.db #0x2e	; 46
	.db #0x30	; 48	'0'
	.db #0x30	; 48	'0'
	.area XINIT   (CODE)
	.area CABS    (ABS,CODE)
