#include "vm8051.h"

#ifndef VMDEVICE_H_INCLUDED
#define VMDEVICE_H_INCLUDED

/*
*   I2C Functions
*   Set to "1" to use the function
*
*/
#define USE_I2C_LIBRARY             1
#define USE_I2C_CHECK               0
#define USE_I2C_WRITE               0
#define USE_I2C_WRITE_8BIT          1
#define USE_I2C_WRITE_16BIT         0
#define USE_I2C_WRITE_32BIT         0
#define USE_I2C_READ                0
#define USE_I2C_READ_8BIT           1
#define USE_I2C_READ_16BIT          0
#define USE_I2C_READ_32BIT          0
#define USE_I2C_WR8_RD8             0
#define USE_I2C_WR8_RD16            0
#define USE_I2C_WR8_RD32            0
#define USE_I2C_WR16_RD8            0
#define USE_I2C_WR16_RD16           0
#define USE_I2C_WR16_RD32           0
#define USE_I2C_REG8_WR8            0
#define USE_I2C_REG8_WR16           0
#define USE_I2C_REG8_WR32           0
#define USE_I2C_REG16_WR8           0
#define USE_I2C_REG16_WR16          0
#define USE_I2C_REG16_WR32          0
#define USE_I2C_REG8_RD8            0
#define USE_I2C_REG8_RD16           0
#define USE_I2C_REG8_RD32           0
#define USE_I2C_REG16_RD8           0
#define USE_I2C_REG16_RD16          0
#define USE_I2C_REG16_RD32          0

#define USE_REPEATED_START          1
#define I2CWR_MSB_FIRST             1
#define I2CRD_MSB_FIRST             1

/**********************************************/

#define CH_TCP                      0x01
#define CH_UDP                      0x02
#define CH_VMTCP                    0x03
#define CH_VMUDP                    0x04

#define DEBUG_SOCKET_NUM            CH_VMUDP
#define DEBUG_IP                    0
#define DEBUG_PORT                  0
#define DEBUG_NO_HEADER             1

#define USE_PUTCHAR                 0
#define USE_PRINT_U8                0
#define USE_PRINT_U16               0
#define USE_PRINT_FLOAT             0

#if ((USE_PUTCHAR == 1) || (USE_PRINT_U8 == 1) || (USE_PRINT_U16 == 1) || (USE_PRINT_FLOAT == 1))
    #define DEBUG_PRINT
    #define USE_NET_SENDTXT         1
#endif

#ifndef USE_NET_SENDTXT
    #define USE_NET_SENDTXT         0
#endif
#define USE_NET_SENDTXT_TO          0
#define USE_NET_SENDBYTES           1
#define USE_NET_SENDBYTES_TO        0



#endif // VMDEVICE_H_INCLUDED
