#ifndef LTC1669_H_INCLUDED
#define LTC1669_H_INCLUDED

#define CMD_SY_BIT  0
#define CMD_SD_BIT  1
#define CMD_BG_BIT  2

extern uint16_t read_dac_value(void);
extern uint8_t read_dac_cmd(void);
extern uint8_t write_dac_value(uint8_t slvaddr, uint16_t value);
extern uint8_t write_dac_cmd(uint8_t slvaddr, uint8_t cmd);
extern uint8_t set_dac_cmd_bit(uint8_t slvaddr, uint8_t cmd_bit , uint8_t value);
extern uint8_t get_dac_cmd_bit(uint8_t cmd_bit);

#endif // LTC1669_H_INCLUDED
