;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.12 #12748 (MINGW64)
;--------------------------------------------------------
	.module i2c
	.optsdcc -mmcs51 --model-large
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _CY
	.globl _AC
	.globl _F0
	.globl _RS1
	.globl _RS0
	.globl _OV
	.globl _F1
	.globl _P
	.globl _FEXT
	.globl _FTMR
	.globl _FNET
	.globl _EEXT
	.globl _ETMR
	.globl _ENET
	.globl _NETTOUT
	.globl _NETSTAT
	.globl _NETRXLEN
	.globl _NETTXLEN
	.globl _NETCON
	.globl _RXCH
	.globl _RXPORT
	.globl _RXPORTH
	.globl _RXPORTL
	.globl _RXIP
	.globl _RXIP3
	.globl _RXIP2
	.globl _RXIP1
	.globl _RXIP0
	.globl _TXCH
	.globl _TXPORT
	.globl _TXPORTH
	.globl _TXPORTL
	.globl _TXIP
	.globl _TXIP3
	.globl _TXIP2
	.globl _TXIP1
	.globl _TXIP0
	.globl _TMR
	.globl _TMRH
	.globl _TMRL
	.globl _TMRCON
	.globl _IFLAG
	.globl _EXTCON
	.globl _I2CSTAT
	.globl _I2CRXLEN
	.globl _I2CTXLEN
	.globl _I2CFREQ
	.globl _SLVADDR
	.globl _I2CCON
	.globl _IE2
	.globl _B
	.globl _ACC
	.globl _PSW
	.globl _DPH
	.globl _DPL
	.globl _SP
	.globl _i2c_reg8_rd16_PARM_3
	.globl _i2c_reg8_rd16_PARM_2
	.globl _i2c_reg8_rd8_PARM_3
	.globl _i2c_reg8_rd8_PARM_2
	.globl _i2c_reg8_wr16_PARM_3
	.globl _i2c_reg8_wr16_PARM_2
	.globl _i2c_reg8_wr8_PARM_3
	.globl _i2c_reg8_wr8_PARM_2
	.globl _i2c_read_8bit_PARM_2
	.globl _i2c_write_8bit_PARM_2
	.globl _NETRXBUF
	.globl _NETTXBUF
	.globl _I2CRXBUF
	.globl _I2CTXBUF
	.globl _i2c_write_8bit
	.globl _i2c_read_8bit
	.globl _i2c_reg8_wr8
	.globl _i2c_reg8_wr16
	.globl _i2c_reg8_rd8
	.globl _i2c_reg8_rd16
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_IE2	=	0x00c0
_I2CCON	=	0x00c1
_SLVADDR	=	0x00c2
_I2CFREQ	=	0x00c3
_I2CTXLEN	=	0x00c4
_I2CRXLEN	=	0x00c5
_I2CSTAT	=	0x00c6
_EXTCON	=	0x00c7
_IFLAG	=	0x00c8
_TMRCON	=	0x00c9
_TMRL	=	0x00ca
_TMRH	=	0x00cb
_TMR	=	0xcbca
_TXIP0	=	0x00a9
_TXIP1	=	0x00aa
_TXIP2	=	0x00ab
_TXIP3	=	0x00ac
_TXIP	=	0xacabaaa9
_TXPORTL	=	0x00ad
_TXPORTH	=	0x00ae
_TXPORT	=	0xaead
_TXCH	=	0x00af
_RXIP0	=	0x00b1
_RXIP1	=	0x00b2
_RXIP2	=	0x00b3
_RXIP3	=	0x00b4
_RXIP	=	0xb4b3b2b1
_RXPORTL	=	0x00b5
_RXPORTH	=	0x00b6
_RXPORT	=	0xb6b5
_RXCH	=	0x00b7
_NETCON	=	0x00b9
_NETTXLEN	=	0x00ba
_NETRXLEN	=	0x00bb
_NETSTAT	=	0x00bc
_NETTOUT	=	0x00bd
;--------------------------------------------------------
; special function bits
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_ENET	=	0x00c0
_ETMR	=	0x00c1
_EEXT	=	0x00c2
_FNET	=	0x00c8
_FTMR	=	0x00c9
_FEXT	=	0x00ca
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; absolute internal ram data
;--------------------------------------------------------
	.area IABS    (ABS,DATA)
	.area IABS    (ABS,DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; paged external ram data
;--------------------------------------------------------
	.area PSEG    (PAG,XDATA)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_I2CTXBUF	=	0x0800
_I2CRXBUF	=	0x0900
_NETTXBUF	=	0x0a00
_NETRXBUF	=	0x0b00
_i2c_write_8bit_PARM_2:
	.ds 1
_i2c_write_8bit_slvaddr_65536_8:
	.ds 1
_i2c_read_8bit_PARM_2:
	.ds 3
_i2c_read_8bit_slvaddr_65536_10:
	.ds 1
_i2c_reg8_wr8_PARM_2:
	.ds 1
_i2c_reg8_wr8_PARM_3:
	.ds 1
_i2c_reg8_wr8_slvaddr_65536_13:
	.ds 1
_i2c_reg8_wr16_PARM_2:
	.ds 1
_i2c_reg8_wr16_PARM_3:
	.ds 2
_i2c_reg8_wr16_slvaddr_65536_15:
	.ds 1
_i2c_reg8_rd8_PARM_2:
	.ds 1
_i2c_reg8_rd8_PARM_3:
	.ds 3
_i2c_reg8_rd8_slvaddr_65536_17:
	.ds 1
_i2c_reg8_rd16_PARM_2:
	.ds 1
_i2c_reg8_rd16_PARM_3:
	.ds 3
_i2c_reg8_rd16_slvaddr_65536_20:
	.ds 1
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area XABS    (ABS,XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
	.area HOME    (CODE)
	.area GSINIT0 (CODE)
	.area GSINIT1 (CODE)
	.area GSINIT2 (CODE)
	.area GSINIT3 (CODE)
	.area GSINIT4 (CODE)
	.area GSINIT5 (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME    (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area HOME    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'i2c_write_8bit'
;------------------------------------------------------------
;dat                       Allocated with name '_i2c_write_8bit_PARM_2'
;slvaddr                   Allocated with name '_i2c_write_8bit_slvaddr_65536_8'
;------------------------------------------------------------
;	..\VM_Src\i2c.c:35: uint8_t i2c_write_8bit(uint8_t slvaddr, uint8_t dat)
;	-----------------------------------------
;	 function i2c_write_8bit
;	-----------------------------------------
_i2c_write_8bit:
	ar7 = 0x07
	ar6 = 0x06
	ar5 = 0x05
	ar4 = 0x04
	ar3 = 0x03
	ar2 = 0x02
	ar1 = 0x01
	ar0 = 0x00
	mov	a,dpl
	mov	dptr,#_i2c_write_8bit_slvaddr_65536_8
	movx	@dptr,a
;	..\VM_Src\i2c.c:37: SLVADDR     = slvaddr;  // load slave addr
	movx	a,@dptr
	mov	_SLVADDR,a
;	..\VM_Src\i2c.c:38: I2CTXBUF[0] = dat;      // load data byte
	mov	dptr,#_i2c_write_8bit_PARM_2
	movx	a,@dptr
	mov	dptr,#_I2CTXBUF
	movx	@dptr,a
;	..\VM_Src\i2c.c:39: I2CTXLEN    = 1;        // set number of bytes to transmit
	mov	_I2CTXLEN,#0x01
;	..\VM_Src\i2c.c:40: I2C_WRITE;              // start transmission, blocking function
	mov	_I2CCON,#0x01
;	..\VM_Src\i2c.c:41: return(I2CSTAT);        // 0x00 if successful, else error. See possible error codes
	mov	dpl,_I2CSTAT
;	..\VM_Src\i2c.c:42: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'i2c_read_8bit'
;------------------------------------------------------------
;dat                       Allocated with name '_i2c_read_8bit_PARM_2'
;slvaddr                   Allocated with name '_i2c_read_8bit_slvaddr_65536_10'
;------------------------------------------------------------
;	..\VM_Src\i2c.c:105: uint8_t i2c_read_8bit(uint8_t slvaddr, uint8_t * dat)
;	-----------------------------------------
;	 function i2c_read_8bit
;	-----------------------------------------
_i2c_read_8bit:
	mov	a,dpl
	mov	dptr,#_i2c_read_8bit_slvaddr_65536_10
	movx	@dptr,a
;	..\VM_Src\i2c.c:107: SLVADDR     = slvaddr;              // load slave addr
	movx	a,@dptr
	mov	_SLVADDR,a
;	..\VM_Src\i2c.c:108: I2CRXLEN    = 1;                    // set number of bytes to read
	mov	_I2CRXLEN,#0x01
;	..\VM_Src\i2c.c:109: I2C_READ;                           // start reading, blocking function
	mov	_I2CCON,#0x02
;	..\VM_Src\i2c.c:111: if (I2CSTAT == I2C_RESULT_OK)
	mov	a,_I2CSTAT
	jnz	00102$
;	..\VM_Src\i2c.c:113: *dat = I2CRXBUF[0];
	mov	dptr,#_i2c_read_8bit_PARM_2
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_I2CRXBUF
	movx	a,@dptr
	mov	r4,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrput
00102$:
;	..\VM_Src\i2c.c:115: return(I2CSTAT);
	mov	dpl,_I2CSTAT
;	..\VM_Src\i2c.c:116: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'i2c_reg8_wr8'
;------------------------------------------------------------
;reg                       Allocated with name '_i2c_reg8_wr8_PARM_2'
;dat                       Allocated with name '_i2c_reg8_wr8_PARM_3'
;slvaddr                   Allocated with name '_i2c_reg8_wr8_slvaddr_65536_13'
;------------------------------------------------------------
;	..\VM_Src\i2c.c:336: uint8_t i2c_reg8_wr8(uint8_t slvaddr, uint8_t reg, uint8_t dat)
;	-----------------------------------------
;	 function i2c_reg8_wr8
;	-----------------------------------------
_i2c_reg8_wr8:
	mov	a,dpl
	mov	dptr,#_i2c_reg8_wr8_slvaddr_65536_13
	movx	@dptr,a
;	..\VM_Src\i2c.c:338: SLVADDR     = slvaddr;  // load slave addr
	movx	a,@dptr
	mov	_SLVADDR,a
;	..\VM_Src\i2c.c:339: I2CTXBUF[0] = reg;      // load reg
	mov	dptr,#_i2c_reg8_wr8_PARM_2
	movx	a,@dptr
	mov	dptr,#_I2CTXBUF
	movx	@dptr,a
;	..\VM_Src\i2c.c:340: I2CTXBUF[1] = dat;      // load data byte
	mov	dptr,#_i2c_reg8_wr8_PARM_3
	movx	a,@dptr
	mov	dptr,#(_I2CTXBUF + 0x0001)
	movx	@dptr,a
;	..\VM_Src\i2c.c:341: I2CTXLEN    = 2;        // set number of bytes to transmit
	mov	_I2CTXLEN,#0x02
;	..\VM_Src\i2c.c:342: I2C_WRITE;              // start transmission, blocking function
	mov	_I2CCON,#0x01
;	..\VM_Src\i2c.c:343: return(I2CSTAT);        // 0x00 if successful, else error. See possible error codes
	mov	dpl,_I2CSTAT
;	..\VM_Src\i2c.c:344: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'i2c_reg8_wr16'
;------------------------------------------------------------
;reg                       Allocated with name '_i2c_reg8_wr16_PARM_2'
;dat                       Allocated with name '_i2c_reg8_wr16_PARM_3'
;slvaddr                   Allocated with name '_i2c_reg8_wr16_slvaddr_65536_15'
;------------------------------------------------------------
;	..\VM_Src\i2c.c:348: uint8_t i2c_reg8_wr16(uint8_t slvaddr, uint8_t reg, uint16_t dat)
;	-----------------------------------------
;	 function i2c_reg8_wr16
;	-----------------------------------------
_i2c_reg8_wr16:
	mov	a,dpl
	mov	dptr,#_i2c_reg8_wr16_slvaddr_65536_15
	movx	@dptr,a
;	..\VM_Src\i2c.c:350: SLVADDR     = slvaddr;              // load slave addr
	movx	a,@dptr
	mov	_SLVADDR,a
;	..\VM_Src\i2c.c:351: I2CTXBUF[0] = reg;                  // load reg
	mov	dptr,#_i2c_reg8_wr16_PARM_2
	movx	a,@dptr
	mov	dptr,#_I2CTXBUF
	movx	@dptr,a
;	..\VM_Src\i2c.c:353: I2CTXBUF[1] = (uint8_t) (dat >> 8); // load MSB
	mov	dptr,#_i2c_reg8_wr16_PARM_3
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dptr,#(_I2CTXBUF + 0x0001)
	mov	a,r5
	movx	@dptr,a
;	..\VM_Src\i2c.c:354: I2CTXBUF[2] = (uint8_t) dat;        // load LSB
	mov	dptr,#(_I2CTXBUF + 0x0002)
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\i2c.c:359: I2CTXLEN    = 3;                    // set number of bytes to transmit
	mov	_I2CTXLEN,#0x03
;	..\VM_Src\i2c.c:360: I2C_WRITE;                          // start transmission, blocking function
	mov	_I2CCON,#0x01
;	..\VM_Src\i2c.c:361: return(I2CSTAT);                    // 0x00 if successful, else error. See possible error codes
	mov	dpl,_I2CSTAT
;	..\VM_Src\i2c.c:362: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'i2c_reg8_rd8'
;------------------------------------------------------------
;reg                       Allocated with name '_i2c_reg8_rd8_PARM_2'
;rdat                      Allocated with name '_i2c_reg8_rd8_PARM_3'
;slvaddr                   Allocated with name '_i2c_reg8_rd8_slvaddr_65536_17'
;------------------------------------------------------------
;	..\VM_Src\i2c.c:452: uint8_t i2c_reg8_rd8(uint8_t slvaddr, uint8_t reg, uint8_t * rdat)
;	-----------------------------------------
;	 function i2c_reg8_rd8
;	-----------------------------------------
_i2c_reg8_rd8:
	mov	a,dpl
	mov	dptr,#_i2c_reg8_rd8_slvaddr_65536_17
	movx	@dptr,a
;	..\VM_Src\i2c.c:454: SLVADDR     = slvaddr;          // load slave addr
	movx	a,@dptr
	mov	_SLVADDR,a
;	..\VM_Src\i2c.c:455: I2CTXBUF[0] = reg;              // load register
	mov	dptr,#_i2c_reg8_rd8_PARM_2
	movx	a,@dptr
	mov	dptr,#_I2CTXBUF
	movx	@dptr,a
;	..\VM_Src\i2c.c:456: I2CTXLEN    = 1;                // set number of bytes to write
	mov	_I2CTXLEN,#0x01
;	..\VM_Src\i2c.c:457: I2CRXLEN    = 1;                // set number of bytes to read
	mov	_I2CRXLEN,#0x01
;	..\VM_Src\i2c.c:458: I2C_WRITE_READ(REPEATED_START); // start write/read, blocking function
	mov	_I2CCON,#0x07
;	..\VM_Src\i2c.c:459: if (I2CSTAT == I2C_RESULT_OK)
	mov	a,_I2CSTAT
	jnz	00102$
;	..\VM_Src\i2c.c:461: *rdat = I2CRXBUF[0];
	mov	dptr,#_i2c_reg8_rd8_PARM_3
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_I2CRXBUF
	movx	a,@dptr
	mov	r4,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	lcall	__gptrput
00102$:
;	..\VM_Src\i2c.c:463: return(I2CSTAT);                // 0x00 if successful, else error. See possible error codes
	mov	dpl,_I2CSTAT
;	..\VM_Src\i2c.c:464: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'i2c_reg8_rd16'
;------------------------------------------------------------
;reg                       Allocated with name '_i2c_reg8_rd16_PARM_2'
;rdat                      Allocated with name '_i2c_reg8_rd16_PARM_3'
;slvaddr                   Allocated with name '_i2c_reg8_rd16_slvaddr_65536_20'
;------------------------------------------------------------
;	..\VM_Src\i2c.c:468: uint8_t i2c_reg8_rd16(uint8_t slvaddr, uint8_t reg, uint16_t * rdat)
;	-----------------------------------------
;	 function i2c_reg8_rd16
;	-----------------------------------------
_i2c_reg8_rd16:
	mov	a,dpl
	mov	dptr,#_i2c_reg8_rd16_slvaddr_65536_20
	movx	@dptr,a
;	..\VM_Src\i2c.c:470: SLVADDR     = slvaddr;          // load slave addr
	movx	a,@dptr
	mov	_SLVADDR,a
;	..\VM_Src\i2c.c:471: I2CTXBUF[0] = reg;              // load register
	mov	dptr,#_i2c_reg8_rd16_PARM_2
	movx	a,@dptr
	mov	dptr,#_I2CTXBUF
	movx	@dptr,a
;	..\VM_Src\i2c.c:472: I2CTXLEN    = 1;                // set number of bytes to write
	mov	_I2CTXLEN,#0x01
;	..\VM_Src\i2c.c:473: I2CRXLEN    = 2;                // set number of bytes to read
	mov	_I2CRXLEN,#0x02
;	..\VM_Src\i2c.c:474: I2C_WRITE_READ(REPEATED_START); // start write/read, blocking function
	mov	_I2CCON,#0x07
;	..\VM_Src\i2c.c:475: if (I2CSTAT == I2C_RESULT_OK)
	mov	a,_I2CSTAT
	jnz	00102$
;	..\VM_Src\i2c.c:478: *rdat = I2CRXBUF[0];
	mov	dptr,#_i2c_reg8_rd16_PARM_3
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_I2CRXBUF
	movx	a,@dptr
	mov	r4,a
	mov	r3,#0x00
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	mov	a,r4
	lcall	__gptrput
	inc	dptr
	mov	a,r3
	lcall	__gptrput
;	..\VM_Src\i2c.c:479: *rdat = (*rdat << 8);
	mov	ar3,r4
	mov	r4,#0x00
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	mov	a,r4
	lcall	__gptrput
	inc	dptr
	mov	a,r3
	lcall	__gptrput
;	..\VM_Src\i2c.c:480: *rdat |= I2CRXBUF[1];
	mov	dptr,#(_I2CRXBUF + 0x0001)
	movx	a,@dptr
	mov	r1,a
	mov	r2,#0x00
	mov	a,r1
	orl	ar4,a
	mov	a,r2
	orl	ar3,a
	mov	dpl,r5
	mov	dph,r6
	mov	b,r7
	mov	a,r4
	lcall	__gptrput
	inc	dptr
	mov	a,r3
	lcall	__gptrput
00102$:
;	..\VM_Src\i2c.c:487: return(I2CSTAT);                // 0x00 if successful, else error. See possible error codes
	mov	dpl,_I2CSTAT
;	..\VM_Src\i2c.c:488: }
	ret
	.area CSEG    (CODE)
	.area CONST   (CODE)
	.area XINIT   (CODE)
	.area CABS    (ABS,CODE)
