;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.12 #12748 (MINGW64)
;--------------------------------------------------------
	.module mb
	.optsdcc -mmcs51 --model-large
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _mb_read_device_information
	.globl _mb_set_exception_code
	.globl _mb_copy_mbap
	.globl _mb_backup_request
	.globl _default_mb_function
	.globl _net_sendbytes
	.globl _CY
	.globl _AC
	.globl _F0
	.globl _RS1
	.globl _RS0
	.globl _OV
	.globl _F1
	.globl _P
	.globl _FEXT
	.globl _FTMR
	.globl _FNET
	.globl _EEXT
	.globl _ETMR
	.globl _ENET
	.globl _NETTOUT
	.globl _NETSTAT
	.globl _NETRXLEN
	.globl _NETTXLEN
	.globl _NETCON
	.globl _RXCH
	.globl _RXPORT
	.globl _RXPORTH
	.globl _RXPORTL
	.globl _RXIP
	.globl _RXIP3
	.globl _RXIP2
	.globl _RXIP1
	.globl _RXIP0
	.globl _TXCH
	.globl _TXPORT
	.globl _TXPORTH
	.globl _TXPORTL
	.globl _TXIP
	.globl _TXIP3
	.globl _TXIP2
	.globl _TXIP1
	.globl _TXIP0
	.globl _TMR
	.globl _TMRH
	.globl _TMRL
	.globl _TMRCON
	.globl _IFLAG
	.globl _EXTCON
	.globl _I2CSTAT
	.globl _I2CRXLEN
	.globl _I2CTXLEN
	.globl _I2CFREQ
	.globl _SLVADDR
	.globl _I2CCON
	.globl _IE2
	.globl _B
	.globl _ACC
	.globl _PSW
	.globl _DPH
	.globl _DPL
	.globl _SP
	.globl _mb_init_PARM_3
	.globl _mb_init_PARM_2
	.globl _mb_register_function_PARM_2
	.globl _modbus
	.globl _NETRXBUF
	.globl _NETTXBUF
	.globl _I2CRXBUF
	.globl _I2CTXBUF
	.globl _mb_register_function
	.globl _mb_init
	.globl _mb_set_data_length
	.globl _mb_handler
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_IE2	=	0x00c0
_I2CCON	=	0x00c1
_SLVADDR	=	0x00c2
_I2CFREQ	=	0x00c3
_I2CTXLEN	=	0x00c4
_I2CRXLEN	=	0x00c5
_I2CSTAT	=	0x00c6
_EXTCON	=	0x00c7
_IFLAG	=	0x00c8
_TMRCON	=	0x00c9
_TMRL	=	0x00ca
_TMRH	=	0x00cb
_TMR	=	0xcbca
_TXIP0	=	0x00a9
_TXIP1	=	0x00aa
_TXIP2	=	0x00ab
_TXIP3	=	0x00ac
_TXIP	=	0xacabaaa9
_TXPORTL	=	0x00ad
_TXPORTH	=	0x00ae
_TXPORT	=	0xaead
_TXCH	=	0x00af
_RXIP0	=	0x00b1
_RXIP1	=	0x00b2
_RXIP2	=	0x00b3
_RXIP3	=	0x00b4
_RXIP	=	0xb4b3b2b1
_RXPORTL	=	0x00b5
_RXPORTH	=	0x00b6
_RXPORT	=	0xb6b5
_RXCH	=	0x00b7
_NETCON	=	0x00b9
_NETTXLEN	=	0x00ba
_NETRXLEN	=	0x00bb
_NETSTAT	=	0x00bc
_NETTOUT	=	0x00bd
;--------------------------------------------------------
; special function bits
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_ENET	=	0x00c0
_ETMR	=	0x00c1
_EEXT	=	0x00c2
_FNET	=	0x00c8
_FTMR	=	0x00c9
_FEXT	=	0x00ca
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; absolute internal ram data
;--------------------------------------------------------
	.area IABS    (ABS,DATA)
	.area IABS    (ABS,DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; paged external ram data
;--------------------------------------------------------
	.area PSEG    (PAG,XDATA)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_I2CTXBUF	=	0x0800
_I2CRXBUF	=	0x0900
_NETTXBUF	=	0x0a00
_NETRXBUF	=	0x0b00
_u16swap_val_65536_25:
	.ds 2
_modbus::
	.ds 551
_mb_register_function_PARM_2:
	.ds 2
_mb_register_function_func_code_65536_34:
	.ds 1
_mb_register_function_pfunc_65536_36:
	.ds 2
_mb_init_PARM_2:
	.ds 1
_mb_init_PARM_3:
	.ds 1
_mb_init_mb_objects_65536_41:
	.ds 3
_mb_set_data_length_len_65536_49:
	.ds 2
_mb_set_data_length_val_196608_52:
	.ds 2
_mb_set_exception_code_err_code_65536_54:
	.ds 1
_mb_handler_ret_65536_61:
	.ds 1
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area XABS    (ABS,XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
	.area HOME    (CODE)
	.area GSINIT0 (CODE)
	.area GSINIT1 (CODE)
	.area GSINIT2 (CODE)
	.area GSINIT3 (CODE)
	.area GSINIT4 (CODE)
	.area GSINIT5 (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME    (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area HOME    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'u16swap'
;------------------------------------------------------------
;val                       Allocated with name '_u16swap_val_65536_25'
;------------------------------------------------------------
;	../VM_Inc/mb.h:263: static inline uint16_t u16swap(uint16_t val)
;	-----------------------------------------
;	 function u16swap
;	-----------------------------------------
_u16swap:
	ar7 = 0x07
	ar6 = 0x06
	ar5 = 0x05
	ar4 = 0x04
	ar3 = 0x03
	ar2 = 0x02
	ar1 = 0x01
	ar0 = 0x00
	mov	r7,dph
	mov	a,dpl
	mov	dptr,#_u16swap_val_65536_25
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	../VM_Inc/mb.h:265: return ((val >> 8) & 0x00FF) | ((val << 8) & 0xFF00);
	mov	dptr,#_u16swap_val_65536_25
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
	mov	dpl,r6
	mov	dph,r7
;	../VM_Inc/mb.h:266: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'default_mb_function'
;------------------------------------------------------------
;	..\VM_Src\mb.c:14: uint8_t default_mb_function(void) {
;	-----------------------------------------
;	 function default_mb_function
;	-----------------------------------------
_default_mb_function:
;	..\VM_Src\mb.c:15: return(MB_ERR_ILLEGAL_FUNCTION);
	mov	dpl,#0x01
;	..\VM_Src\mb.c:16: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_register_function'
;------------------------------------------------------------
;func                      Allocated with name '_mb_register_function_PARM_2'
;func_code                 Allocated with name '_mb_register_function_func_code_65536_34'
;pfunc                     Allocated with name '_mb_register_function_pfunc_65536_36'
;------------------------------------------------------------
;	..\VM_Src\mb.c:23: void mb_register_function(uint8_t func_code, uint8_t(*func)(void))
;	-----------------------------------------
;	 function mb_register_function
;	-----------------------------------------
_mb_register_function:
	mov	a,dpl
	mov	dptr,#_mb_register_function_func_code_65536_34
	movx	@dptr,a
;	..\VM_Src\mb.c:27: if(!func) {
	mov	dptr,#_mb_register_function_PARM_2
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_mb_register_function_PARM_2
	movx	a,@dptr
	mov	b,a
	inc	dptr
	movx	a,@dptr
	orl	a,b
	jnz	00102$
;	..\VM_Src\mb.c:28: pfunc = default_mb_function;
	mov	dptr,#_mb_register_function_pfunc_65536_36
	mov	a,#_default_mb_function
	movx	@dptr,a
	mov	a,#(_default_mb_function >> 8)
	inc	dptr
	movx	@dptr,a
	sjmp	00103$
00102$:
;	..\VM_Src\mb.c:30: pfunc = func;
	mov	dptr,#_mb_register_function_pfunc_65536_36
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
00103$:
;	..\VM_Src\mb.c:33: switch(func_code) {
	mov	dptr,#_mb_register_function_func_code_65536_34
	movx	a,@dptr
	mov	r7,a
	cjne	r7,#0x01,00162$
	sjmp	00104$
00162$:
	cjne	r7,#0x02,00163$
	sjmp	00105$
00163$:
	cjne	r7,#0x03,00164$
	sjmp	00106$
00164$:
	cjne	r7,#0x04,00165$
	sjmp	00107$
00165$:
	cjne	r7,#0x05,00166$
	sjmp	00108$
00166$:
	cjne	r7,#0x06,00167$
	sjmp	00109$
00167$:
	cjne	r7,#0x0f,00168$
	ljmp	00110$
00168$:
	cjne	r7,#0x10,00169$
	ljmp	00111$
00169$:
	cjne	r7,#0x16,00170$
	ljmp	00112$
00170$:
	cjne	r7,#0x17,00171$
	ljmp	00113$
00171$:
	ret
;	..\VM_Src\mb.c:34: case MB_CMD_READ_COILS:                     modbus.f.read_coils = pfunc; break;
00104$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0014)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
	ret
;	..\VM_Src\mb.c:35: case MB_CMD_READ_DISCRETE_INPUTS:           modbus.f.read_discrete_inputs = pfunc; break;
00105$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0016)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
	ret
;	..\VM_Src\mb.c:36: case MB_CMD_READ_HOLDING_REGISTERS:         modbus.f.read_holding_registers = pfunc; break;
00106$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0018)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
	ret
;	..\VM_Src\mb.c:37: case MB_CMD_READ_INPUT_REGISTERS:           modbus.f.read_input_registers = pfunc; break;
00107$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x001a)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:38: case MB_CMD_WRITE_SINGLE_COIL:              modbus.f.write_single_coil = pfunc; break;
	ret
00108$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x001c)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:39: case MB_CMD_WRITE_SINGLE_REGISTER:          modbus.f.write_single_register = pfunc; break;
	ret
00109$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x001e)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:40: case MB_CMD_WRITE_MULTIPLE_COILS:           modbus.f.write_multiple_coils = pfunc; break;
	ret
00110$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0020)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:41: case MB_CMD_WRITE_MULTIPLE_REGISTERS:       modbus.f.write_multiple_regsiters = pfunc; break;
	ret
00111$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0022)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:42: case MB_CMD_WRITE_MASK_REGISTER:            modbus.f.write_mask_register = pfunc; break;
	ret
00112$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0024)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:43: case MB_CMD_WRITE_READ_MULTIPLE_REGISTERS:  modbus.f.write_read_multiple_regsiters = pfunc; break;
	ret
00113$:
	mov	dptr,#_mb_register_function_pfunc_65536_36
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0026)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:44: }
;	..\VM_Src\mb.c:45: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_init'
;------------------------------------------------------------
;mb_objects_size           Allocated with name '_mb_init_PARM_2'
;socket                    Allocated with name '_mb_init_PARM_3'
;mb_objects                Allocated with name '_mb_init_mb_objects_65536_41'
;------------------------------------------------------------
;	..\VM_Src\mb.c:53: void mb_init(uint8_t * mb_objects, uint8_t mb_objects_size, uint8_t socket)
;	-----------------------------------------
;	 function mb_init
;	-----------------------------------------
_mb_init:
	mov	r7,b
	mov	r6,dph
	mov	a,dpl
	mov	dptr,#_mb_init_mb_objects_65536_41
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:57: if ((socket != 3) && (socket != 4)) socket = 3;
	mov	dptr,#_mb_init_PARM_3
	movx	a,@dptr
	mov	r7,a
	cjne	r7,#0x03,00114$
	sjmp	00102$
00114$:
	cjne	r7,#0x04,00115$
	sjmp	00102$
00115$:
	mov	dptr,#_mb_init_PARM_3
	mov	a,#0x03
	movx	@dptr,a
00102$:
;	..\VM_Src\mb.c:59: modbus.dst_socket.ch        = socket;
	mov	dptr,#_mb_init_PARM_3
	movx	a,@dptr
	mov	dptr,#(_modbus + 0x0012)
	movx	@dptr,a
;	..\VM_Src\mb.c:60: modbus.dst_socket.ip        = 0;
	mov	dptr,#(_modbus + 0x000c)
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:61: modbus.dst_socket.port      = 0;
	mov	dptr,#(_modbus + 0x0010)
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:62: modbus.dst_socket.noheader  = 1;
	mov	dptr,#(_modbus + 0x0013)
	inc	a
	movx	@dptr,a
;	..\VM_Src\mb.c:64: modbus.objects_size = mb_objects_size;
	mov	dptr,#_mb_init_PARM_2
	movx	a,@dptr
	mov	dptr,#_modbus
	movx	@dptr,a
;	..\VM_Src\mb.c:65: modbus.objects = mb_objects;
	mov	dptr,#_mb_init_mb_objects_65536_41
	movx	a,@dptr
	mov	r5,a
	inc	dptr
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0001)
	mov	a,r5
	movx	@dptr,a
	mov	a,r6
	inc	dptr
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:67: mb_register_function(MB_CMD_READ_COILS, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x01
	lcall	_mb_register_function
;	..\VM_Src\mb.c:68: mb_register_function(MB_CMD_READ_DISCRETE_INPUTS, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x02
	lcall	_mb_register_function
;	..\VM_Src\mb.c:69: mb_register_function(MB_CMD_READ_HOLDING_REGISTERS, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x03
	lcall	_mb_register_function
;	..\VM_Src\mb.c:70: mb_register_function(MB_CMD_READ_INPUT_REGISTERS, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x04
	lcall	_mb_register_function
;	..\VM_Src\mb.c:71: mb_register_function(MB_CMD_WRITE_SINGLE_COIL, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x05
	lcall	_mb_register_function
;	..\VM_Src\mb.c:72: mb_register_function(MB_CMD_WRITE_SINGLE_REGISTER, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x06
	lcall	_mb_register_function
;	..\VM_Src\mb.c:73: mb_register_function(MB_CMD_WRITE_MULTIPLE_COILS, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x0f
	lcall	_mb_register_function
;	..\VM_Src\mb.c:74: mb_register_function(MB_CMD_WRITE_MULTIPLE_REGISTERS, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x10
	lcall	_mb_register_function
;	..\VM_Src\mb.c:75: mb_register_function(MB_CMD_WRITE_MASK_REGISTER, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x16
	lcall	_mb_register_function
;	..\VM_Src\mb.c:76: mb_register_function(MB_CMD_WRITE_READ_MULTIPLE_REGISTERS, NULL);
	mov	dptr,#_mb_register_function_PARM_2
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x17
;	..\VM_Src\mb.c:77: }
	ljmp	_mb_register_function
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_backup_request'
;------------------------------------------------------------
;i                         Allocated with name '_mb_backup_request_i_65536_44'
;------------------------------------------------------------
;	..\VM_Src\mb.c:82: void mb_backup_request(void)
;	-----------------------------------------
;	 function mb_backup_request
;	-----------------------------------------
_mb_backup_request:
;	..\VM_Src\mb.c:86: modbus.src_socket.ip    = RXIP;
	mov	dptr,#(_modbus + 0x0004)
	mov	a,((_RXIP >> 0) & 0xFF)
	movx	@dptr,a
	mov	a,((_RXIP >> 8) & 0xFF)
	inc	dptr
	movx	@dptr,a
	mov	a,((_RXIP >> 16) & 0xFF)
	inc	dptr
	movx	@dptr,a
	mov	a,((_RXIP >> 24) & 0xFF)
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:87: modbus.src_socket.port  = RXPORT;
	mov	r6,((_RXPORT >> 0) & 0xFF)
	mov	r7,((_RXPORT >> 8) & 0xFF)
	mov	dptr,#(_modbus + 0x0008)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:88: modbus.src_socket.ch    = RXCH;
	mov	dptr,#(_modbus + 0x000a)
	mov	a,_RXCH
	movx	@dptr,a
;	..\VM_Src\mb.c:89: modbus.src_socket.rxlen = NETRXLEN;
	mov	dptr,#(_modbus + 0x000b)
	mov	a,_NETRXLEN
	movx	@dptr,a
;	..\VM_Src\mb.c:91: for(i=0; i<modbus.src_socket.rxlen; i++) {
	mov	r7,#0x00
00103$:
	mov	dptr,#(_modbus + 0x000b)
	movx	a,@dptr
	mov	r6,a
	clr	c
	mov	a,r7
	subb	a,r6
	jnc	00105$
;	..\VM_Src\mb.c:92: modbus.request.u.packet[i] = NETRXBUF[i];
	mov	a,r7
	add	a,#(_modbus + 0x0028)
	mov	r5,a
	clr	a
	addc	a,#((_modbus + 0x0028) >> 8)
	mov	r6,a
	mov	dpl,r7
	mov	dph,#(_NETRXBUF >> 8)
	movx	a,@dptr
	mov	r4,a
	mov	dpl,r5
	mov	dph,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:91: for(i=0; i<modbus.src_socket.rxlen; i++) {
	inc	r7
	sjmp	00103$
00105$:
;	..\VM_Src\mb.c:94: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_copy_mbap'
;------------------------------------------------------------
;	..\VM_Src\mb.c:99: void mb_copy_mbap(void)
;	-----------------------------------------
;	 function mb_copy_mbap
;	-----------------------------------------
_mb_copy_mbap:
;	..\VM_Src\mb.c:101: modbus.response.u.mbap.transaction_id   = modbus.request.u.mbap.transaction_id;
	mov	dptr,#(_modbus + 0x0028)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0128)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:102: modbus.response.u.mbap.protocol_id      = modbus.request.u.mbap.protocol_id;
	mov	dptr,#(_modbus + 0x002a)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x012a)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:103: modbus.response.u.mbap.length           = 0; // to be set later
	mov	dptr,#(_modbus + 0x012c)
	clr	a
	movx	@dptr,a
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:104: modbus.response.u.mbap.unit_id          = modbus.request.u.mbap.unit_id;
	mov	dptr,#(_modbus + 0x002e)
	movx	a,@dptr
	mov	dptr,#(_modbus + 0x012e)
	movx	@dptr,a
;	..\VM_Src\mb.c:105: modbus.response.u.mbap.function_code    = modbus.request.u.mbap.function_code;
	mov	dptr,#(_modbus + 0x002f)
	movx	a,@dptr
	mov	dptr,#(_modbus + 0x012f)
	movx	@dptr,a
;	..\VM_Src\mb.c:106: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_set_data_length'
;------------------------------------------------------------
;len                       Allocated with name '_mb_set_data_length_len_65536_49'
;__1310720024              Allocated with name '_mb_set_data_length___1310720024_131072_50'
;__1310720025              Allocated with name '_mb_set_data_length___1310720025_131072_51'
;val                       Allocated with name '_mb_set_data_length_val_196608_52'
;------------------------------------------------------------
;	..\VM_Src\mb.c:108: void mb_set_data_length(uint16_t len)
;	-----------------------------------------
;	 function mb_set_data_length
;	-----------------------------------------
_mb_set_data_length:
	mov	r7,dph
	mov	a,dpl
	mov	dptr,#_mb_set_data_length_len_65536_49
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:110: len += 2;  // plus function_code and unit_id bytes
	mov	dptr,#_mb_set_data_length_len_65536_49
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	a,#0x02
	add	a,r6
	mov	r6,a
	clr	a
	addc	a,r7
	mov	r7,a
	mov	dptr,#_mb_set_data_length_len_65536_49
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:111: modbus.response.u.mbap.length = u16swap(len);
	mov	dptr,#_mb_set_data_length_len_65536_49
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	..\VM_Src\mb.c:265: ERROR: no line number 265 in file ..\VM_Src\mb.c
	mov	r5,a
	mov	ar4,r6
	clr	a
	mov	r3,a
	mov	r2,a
	mov	a,r5
	orl	ar3,a
	mov	a,r2
	orl	ar4,a
;	..\VM_Src\mb.c:111: modbus.response.u.mbap.length = u16swap(len);
	mov	dptr,#(_modbus + 0x012c)
	mov	a,r3
	movx	@dptr,a
	mov	a,r4
	inc	dptr
	movx	@dptr,a
;	..\VM_Src\mb.c:112: modbus.response.length = len + 6; // the length of the whole packet including MBAP needed to set NETTXLEN
	mov	a,#0x06
	add	a,r6
	mov	dptr,#(_modbus + 0x0127)
	movx	@dptr,a
;	..\VM_Src\mb.c:113: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_set_exception_code'
;------------------------------------------------------------
;err_code                  Allocated with name '_mb_set_exception_code_err_code_65536_54'
;------------------------------------------------------------
;	..\VM_Src\mb.c:115: void mb_set_exception_code(uint8_t err_code)
;	-----------------------------------------
;	 function mb_set_exception_code
;	-----------------------------------------
_mb_set_exception_code:
	mov	a,dpl
	mov	dptr,#_mb_set_exception_code_err_code_65536_54
	movx	@dptr,a
;	..\VM_Src\mb.c:117: modbus.response.u.mbap.function_code += 0x80;
	mov	dptr,#(_modbus + 0x012f)
	movx	a,@dptr
	add	a,#0x80
	mov	dptr,#(_modbus + 0x012f)
	movx	@dptr,a
;	..\VM_Src\mb.c:118: modbus.response.u.error.code = err_code;
	mov	dptr,#_mb_set_exception_code_err_code_65536_54
	movx	a,@dptr
	mov	dptr,#(_modbus + 0x0130)
	movx	@dptr,a
;	..\VM_Src\mb.c:119: mb_set_data_length(1);  // only one byte -> the err_code
	mov	dptr,#0x0001
;	..\VM_Src\mb.c:120: }
	ljmp	_mb_set_data_length
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_device_information'
;------------------------------------------------------------
;ret                       Allocated with name '_mb_read_device_information_ret_65536_57'
;i                         Allocated with name '_mb_read_device_information_i_65536_57'
;------------------------------------------------------------
;	..\VM_Src\mb.c:122: uint8_t mb_read_device_information(void)
;	-----------------------------------------
;	 function mb_read_device_information
;	-----------------------------------------
_mb_read_device_information:
;	..\VM_Src\mb.c:127: if (modbus.request.u.RdDeviceId.MEI_Type != 0x0E)
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r7,a
	cjne	r7,#0x0e,00134$
	sjmp	00102$
00134$:
;	..\VM_Src\mb.c:128: return(MB_ERR_ILLEGAL_FUNCTION);
	mov	dpl,#0x01
	ret
00102$:
;	..\VM_Src\mb.c:130: if (modbus.request.u.RdDeviceId.ObjectId != 0x00)
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	jz	00104$
;	..\VM_Src\mb.c:131: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00104$:
;	..\VM_Src\mb.c:133: if (modbus.request.u.RdDeviceId.ReadDevIdCode != 0x01)
	mov	dptr,#(_modbus + 0x0031)
	movx	a,@dptr
	mov	r7,a
	cjne	r7,#0x01,00136$
	sjmp	00106$
00136$:
;	..\VM_Src\mb.c:134: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00106$:
;	..\VM_Src\mb.c:137: modbus.response.u.RdDeviceId.MEI_Type           = 0x0E;
	mov	dptr,#(_modbus + 0x0130)
	mov	a,#0x0e
	movx	@dptr,a
;	..\VM_Src\mb.c:138: modbus.response.u.RdDeviceId.ReadDevIdCode      = 0x01;
	mov	dptr,#(_modbus + 0x0131)
	mov	a,#0x01
	movx	@dptr,a
;	..\VM_Src\mb.c:139: modbus.response.u.RdDeviceId.ConformityLevel    = 0x01;
	mov	dptr,#(_modbus + 0x0132)
	movx	@dptr,a
;	..\VM_Src\mb.c:140: modbus.response.u.RdDeviceId.MoreFollows        = 0x00;
	mov	dptr,#(_modbus + 0x0133)
	clr	a
	movx	@dptr,a
;	..\VM_Src\mb.c:141: modbus.response.u.RdDeviceId.NextObjectId       = 0x00;
	mov	dptr,#(_modbus + 0x0134)
	movx	@dptr,a
;	..\VM_Src\mb.c:142: modbus.response.u.RdDeviceId.NumOfObjects       = 0x03;
	mov	dptr,#(_modbus + 0x0135)
	mov	a,#0x03
	movx	@dptr,a
;	..\VM_Src\mb.c:144: for(i=0;i<modbus.objects_size;i++) {
	mov	r7,#0x00
00109$:
	mov	dptr,#_modbus
	movx	a,@dptr
	mov	r6,a
	clr	c
	mov	a,r7
	subb	a,r6
	jnc	00107$
;	..\VM_Src\mb.c:145: modbus.response.u.RdDeviceId.Objects[i] = modbus.objects[i];
	mov	a,r7
	add	a,#(_modbus + 0x0136)
	mov	r4,a
	clr	a
	addc	a,#((_modbus + 0x0136) >> 8)
	mov	r5,a
	mov	dptr,#(_modbus + 0x0001)
	movx	a,@dptr
	mov	r1,a
	inc	dptr
	movx	a,@dptr
	mov	r2,a
	inc	dptr
	movx	a,@dptr
	mov	r3,a
	mov	a,r7
	add	a,r1
	mov	r1,a
	clr	a
	addc	a,r2
	mov	r2,a
	mov	dpl,r1
	mov	dph,r2
	mov	b,r3
	lcall	__gptrget
	mov	r1,a
	mov	dpl,r4
	mov	dph,r5
	movx	@dptr,a
;	..\VM_Src\mb.c:144: for(i=0;i<modbus.objects_size;i++) {
	inc	r7
	sjmp	00109$
00107$:
;	..\VM_Src\mb.c:149: mb_set_data_length(6 + modbus.objects_size);
	mov	r7,#0x00
	mov	a,#0x06
	add	a,r6
	mov	r6,a
	clr	a
	addc	a,r7
	mov	r7,a
	mov	dpl,r6
	mov	dph,r7
	lcall	_mb_set_data_length
;	..\VM_Src\mb.c:151: return(ret);
	mov	dpl,#0x00
;	..\VM_Src\mb.c:152: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_handler'
;------------------------------------------------------------
;ret                       Allocated with name '_mb_handler_ret_65536_61'
;------------------------------------------------------------
;	..\VM_Src\mb.c:154: void mb_handler(void)
;	-----------------------------------------
;	 function mb_handler
;	-----------------------------------------
_mb_handler:
;	..\VM_Src\mb.c:159: mb_backup_request();
	lcall	_mb_backup_request
;	..\VM_Src\mb.c:162: FNET = 0;
;	assignBit
	clr	_FNET
;	..\VM_Src\mb.c:165: mb_copy_mbap();
	lcall	_mb_copy_mbap
;	..\VM_Src\mb.c:167: switch(modbus.response.u.mbap.function_code) {
	mov	dptr,#(_modbus + 0x012f)
	movx	a,@dptr
	mov	r7,a
	cjne	r7,#0x01,00172$
	sjmp	00101$
00172$:
	cjne	r7,#0x02,00173$
	sjmp	00102$
00173$:
	cjne	r7,#0x03,00174$
	sjmp	00103$
00174$:
	cjne	r7,#0x04,00175$
	ljmp	00104$
00175$:
	cjne	r7,#0x05,00176$
	ljmp	00105$
00176$:
	cjne	r7,#0x06,00177$
	ljmp	00106$
00177$:
	cjne	r7,#0x0f,00178$
	ljmp	00107$
00178$:
	cjne	r7,#0x10,00179$
	ljmp	00108$
00179$:
	cjne	r7,#0x16,00180$
	ljmp	00109$
00180$:
	cjne	r7,#0x17,00181$
	ljmp	00110$
00181$:
	cjne	r7,#0x2b,00182$
	ljmp	00111$
00182$:
	ljmp	00112$
;	..\VM_Src\mb.c:168: case MB_CMD_READ_COILS:
00101$:
;	..\VM_Src\mb.c:169: ret = modbus.f.read_coils();
	mov	dptr,#(_modbus + 0x0014)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:170: break;
	ljmp	00113$
;	..\VM_Src\mb.c:171: case MB_CMD_READ_DISCRETE_INPUTS:
00102$:
;	..\VM_Src\mb.c:172: ret = modbus.f.read_discrete_inputs();
	mov	dptr,#(_modbus + 0x0016)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:173: break;
	ljmp	00113$
;	..\VM_Src\mb.c:174: case MB_CMD_READ_HOLDING_REGISTERS:
00103$:
;	..\VM_Src\mb.c:175: ret = modbus.f.read_holding_registers();
	mov	dptr,#(_modbus + 0x0018)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:176: break;
	ljmp	00113$
;	..\VM_Src\mb.c:177: case MB_CMD_READ_INPUT_REGISTERS:
00104$:
;	..\VM_Src\mb.c:178: ret = modbus.f.read_input_registers();
	mov	dptr,#(_modbus + 0x001a)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:179: break;
	ljmp	00113$
;	..\VM_Src\mb.c:180: case MB_CMD_WRITE_SINGLE_COIL:
00105$:
;	..\VM_Src\mb.c:181: ret = modbus.f.write_single_coil();
	mov	dptr,#(_modbus + 0x001c)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:182: break;
	ljmp	00113$
;	..\VM_Src\mb.c:183: case MB_CMD_WRITE_SINGLE_REGISTER:
00106$:
;	..\VM_Src\mb.c:184: ret = modbus.f.write_single_register();
	mov	dptr,#(_modbus + 0x001e)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:185: break;
	ljmp	00113$
;	..\VM_Src\mb.c:186: case MB_CMD_WRITE_MULTIPLE_COILS:
00107$:
;	..\VM_Src\mb.c:187: ret = modbus.f.write_multiple_coils();
	mov	dptr,#(_modbus + 0x0020)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:188: break;
;	..\VM_Src\mb.c:189: case MB_CMD_WRITE_MULTIPLE_REGISTERS:
	sjmp	00113$
00108$:
;	..\VM_Src\mb.c:190: ret = modbus.f.write_multiple_regsiters();
	mov	dptr,#(_modbus + 0x0022)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:191: break;
;	..\VM_Src\mb.c:192: case MB_CMD_WRITE_MASK_REGISTER:
	sjmp	00113$
00109$:
;	..\VM_Src\mb.c:193: ret = modbus.f.write_mask_register();
	mov	dptr,#(_modbus + 0x0024)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:194: break;
;	..\VM_Src\mb.c:195: case MB_CMD_WRITE_READ_MULTIPLE_REGISTERS:
	sjmp	00113$
00110$:
;	..\VM_Src\mb.c:196: ret = modbus.f.write_read_multiple_regsiters();
	mov	dptr,#(_modbus + 0x0026)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	push	ar7
	mov	dpl,r6
	mov	dph,r7
	lcall	__sdcc_call_dptr
	mov	r6,dpl
	pop	ar7
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,r6
	movx	@dptr,a
;	..\VM_Src\mb.c:197: break;
;	..\VM_Src\mb.c:198: case MB_CMD_READ_DEVICE_INFORMATION:
	sjmp	00113$
00111$:
;	..\VM_Src\mb.c:199: ret = mb_read_device_information();
	lcall	_mb_read_device_information
	mov	a,dpl
	mov	dptr,#_mb_handler_ret_65536_61
	movx	@dptr,a
;	..\VM_Src\mb.c:200: break;
;	..\VM_Src\mb.c:201: default:
	sjmp	00113$
00112$:
;	..\VM_Src\mb.c:202: ret = MB_ERR_ILLEGAL_FUNCTION;
	mov	dptr,#_mb_handler_ret_65536_61
	mov	a,#0x01
	movx	@dptr,a
;	..\VM_Src\mb.c:203: }
00113$:
;	..\VM_Src\mb.c:205: if (ret != MB_OK) {
	mov	dptr,#_mb_handler_ret_65536_61
	movx	a,@dptr
	mov	r7,a
	movx	a,@dptr
	jz	00115$
;	..\VM_Src\mb.c:206: mb_set_exception_code(ret);
	mov	dpl,r7
	lcall	_mb_set_exception_code
00115$:
;	..\VM_Src\mb.c:209: if (ret != MB_ERR_UNKNOWN) {
	mov	dptr,#_mb_handler_ret_65536_61
	movx	a,@dptr
	mov	r7,a
	cjne	r7,#0xff,00184$
	ret
00184$:
;	..\VM_Src\mb.c:210: net_sendbytes(modbus.response.u.packet, modbus.response.length, modbus.dst_socket.ch);
	mov	dptr,#(_modbus + 0x0127)
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0012)
	movx	a,@dptr
	mov	r6,a
	mov	dptr,#_net_sendbytes_PARM_2
	mov	a,r7
	movx	@dptr,a
	mov	dptr,#_net_sendbytes_PARM_3
	mov	a,r6
	movx	@dptr,a
	mov	dptr,#(_modbus + 0x0128)
	mov	b,#0x00
;	..\VM_Src\mb.c:212: }
	ljmp	_net_sendbytes
	.area CSEG    (CODE)
	.area CONST   (CODE)
	.area XINIT   (CODE)
	.area CABS    (ABS,CODE)
