;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.12 #12748 (MINGW64)
;--------------------------------------------------------
	.module main
	.optsdcc -mmcs51 --model-large
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _main
	.globl _mb_device_init
	.globl _mb_handler
	.globl _CY
	.globl _AC
	.globl _F0
	.globl _RS1
	.globl _RS0
	.globl _OV
	.globl _F1
	.globl _P
	.globl _FEXT
	.globl _FTMR
	.globl _FNET
	.globl _EEXT
	.globl _ETMR
	.globl _ENET
	.globl _NETTOUT
	.globl _NETSTAT
	.globl _NETRXLEN
	.globl _NETTXLEN
	.globl _NETCON
	.globl _RXCH
	.globl _RXPORT
	.globl _RXPORTH
	.globl _RXPORTL
	.globl _RXIP
	.globl _RXIP3
	.globl _RXIP2
	.globl _RXIP1
	.globl _RXIP0
	.globl _TXCH
	.globl _TXPORT
	.globl _TXPORTH
	.globl _TXPORTL
	.globl _TXIP
	.globl _TXIP3
	.globl _TXIP2
	.globl _TXIP1
	.globl _TXIP0
	.globl _TMR
	.globl _TMRH
	.globl _TMRL
	.globl _TMRCON
	.globl _IFLAG
	.globl _EXTCON
	.globl _I2CSTAT
	.globl _I2CRXLEN
	.globl _I2CTXLEN
	.globl _I2CFREQ
	.globl _SLVADDR
	.globl _I2CCON
	.globl _IE2
	.globl _B
	.globl _ACC
	.globl _PSW
	.globl _DPH
	.globl _DPL
	.globl _SP
	.globl _NETRXBUF
	.globl _NETTXBUF
	.globl _I2CRXBUF
	.globl _I2CTXBUF
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_IE2	=	0x00c0
_I2CCON	=	0x00c1
_SLVADDR	=	0x00c2
_I2CFREQ	=	0x00c3
_I2CTXLEN	=	0x00c4
_I2CRXLEN	=	0x00c5
_I2CSTAT	=	0x00c6
_EXTCON	=	0x00c7
_IFLAG	=	0x00c8
_TMRCON	=	0x00c9
_TMRL	=	0x00ca
_TMRH	=	0x00cb
_TMR	=	0xcbca
_TXIP0	=	0x00a9
_TXIP1	=	0x00aa
_TXIP2	=	0x00ab
_TXIP3	=	0x00ac
_TXIP	=	0xacabaaa9
_TXPORTL	=	0x00ad
_TXPORTH	=	0x00ae
_TXPORT	=	0xaead
_TXCH	=	0x00af
_RXIP0	=	0x00b1
_RXIP1	=	0x00b2
_RXIP2	=	0x00b3
_RXIP3	=	0x00b4
_RXIP	=	0xb4b3b2b1
_RXPORTL	=	0x00b5
_RXPORTH	=	0x00b6
_RXPORT	=	0xb6b5
_RXCH	=	0x00b7
_NETCON	=	0x00b9
_NETTXLEN	=	0x00ba
_NETRXLEN	=	0x00bb
_NETSTAT	=	0x00bc
_NETTOUT	=	0x00bd
;--------------------------------------------------------
; special function bits
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_ENET	=	0x00c0
_ETMR	=	0x00c1
_EEXT	=	0x00c2
_FNET	=	0x00c8
_FTMR	=	0x00c9
_FEXT	=	0x00ca
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;--------------------------------------------------------
; Stack segment in internal ram 
;--------------------------------------------------------
	.area	SSEG
__start__stack:
	.ds	1

;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; absolute internal ram data
;--------------------------------------------------------
	.area IABS    (ABS,DATA)
	.area IABS    (ABS,DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; paged external ram data
;--------------------------------------------------------
	.area PSEG    (PAG,XDATA)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_I2CTXBUF	=	0x0800
_I2CRXBUF	=	0x0900
_NETTXBUF	=	0x0a00
_NETRXBUF	=	0x0b00
_u16swap_val_65536_27:
	.ds 2
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area XABS    (ABS,XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
	.area HOME    (CODE)
	.area GSINIT0 (CODE)
	.area GSINIT1 (CODE)
	.area GSINIT2 (CODE)
	.area GSINIT3 (CODE)
	.area GSINIT4 (CODE)
	.area GSINIT5 (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; interrupt vector 
;--------------------------------------------------------
	.area HOME    (CODE)
__interrupt_vect:
	ljmp	__sdcc_gsinit_startup
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME    (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
	.globl __sdcc_gsinit_startup
	.globl __sdcc_program_startup
	.globl __start__stack
	.globl __mcs51_genXINIT
	.globl __mcs51_genXRAMCLEAR
	.globl __mcs51_genRAMCLEAR
	.area GSFINAL (CODE)
	ljmp	__sdcc_program_startup
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area HOME    (CODE)
__sdcc_program_startup:
	ljmp	_main
;	return from main will return to caller
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'u16swap'
;------------------------------------------------------------
;val                       Allocated with name '_u16swap_val_65536_27'
;------------------------------------------------------------
;	../VM_Inc/mb.h:263: static inline uint16_t u16swap(uint16_t val)
;	-----------------------------------------
;	 function u16swap
;	-----------------------------------------
_u16swap:
	ar7 = 0x07
	ar6 = 0x06
	ar5 = 0x05
	ar4 = 0x04
	ar3 = 0x03
	ar2 = 0x02
	ar1 = 0x01
	ar0 = 0x00
	mov	r7,dph
	mov	a,dpl
	mov	dptr,#_u16swap_val_65536_27
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	../VM_Inc/mb.h:265: return ((val >> 8) & 0x00FF) | ((val << 8) & 0xFF00);
	mov	dptr,#_u16swap_val_65536_27
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
	mov	dpl,r6
	mov	dph,r7
;	../VM_Inc/mb.h:266: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'main'
;------------------------------------------------------------
;	main.c:9: void main(void)
;	-----------------------------------------
;	 function main
;	-----------------------------------------
_main:
;	main.c:12: SET_I2CFREQ(100);   // set I2C SCL frequency to 100kHz
	mov	_I2CFREQ,#0x14
;	main.c:13: NETTOUT = 10;       // network transmitt timeout 10 * 10 = 100ms
	mov	_NETTOUT,#0x0a
;	main.c:15: mb_device_init();
	lcall	_mb_device_init
;	main.c:16: while(1)
00107$:
;	main.c:18: if (FNET) {
	jnb	_FNET,00107$
;	main.c:20: if (RXCH == CH_VMTCP) {
	mov	a,#0x03
	cjne	a,_RXCH,00102$
;	main.c:22: mb_handler();
	lcall	_mb_handler
	sjmp	00107$
00102$:
;	main.c:25: FNET = 0;
;	assignBit
	clr	_FNET
;	main.c:29: }
	sjmp	00107$
	.area CSEG    (CODE)
	.area CONST   (CODE)
	.area XINIT   (CODE)
	.area CABS    (ABS,CODE)
