;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 4.1.12 #12748 (MINGW64)
;--------------------------------------------------------
	.module mb_ltc1669_if
	.optsdcc -mmcs51 --model-large
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _BasicDeviceObjects
	.globl _mb_read_holding_registers
	.globl _mb_write_multiple_coils
	.globl _mb_write_single_register
	.globl _mb_write_single_coil
	.globl _mb_read_coils
	.globl _mb_set_data_length
	.globl _mb_init
	.globl _mb_register_function
	.globl _set_dac_cmd_bit
	.globl _write_dac_cmd
	.globl _write_dac_value
	.globl _read_dac_cmd
	.globl _read_dac_value
	.globl _CY
	.globl _AC
	.globl _F0
	.globl _RS1
	.globl _RS0
	.globl _OV
	.globl _F1
	.globl _P
	.globl _FEXT
	.globl _FTMR
	.globl _FNET
	.globl _EEXT
	.globl _ETMR
	.globl _ENET
	.globl _NETTOUT
	.globl _NETSTAT
	.globl _NETRXLEN
	.globl _NETTXLEN
	.globl _NETCON
	.globl _RXCH
	.globl _RXPORT
	.globl _RXPORTH
	.globl _RXPORTL
	.globl _RXIP
	.globl _RXIP3
	.globl _RXIP2
	.globl _RXIP1
	.globl _RXIP0
	.globl _TXCH
	.globl _TXPORT
	.globl _TXPORTH
	.globl _TXPORTL
	.globl _TXIP
	.globl _TXIP3
	.globl _TXIP2
	.globl _TXIP1
	.globl _TXIP0
	.globl _TMR
	.globl _TMRH
	.globl _TMRL
	.globl _TMRCON
	.globl _IFLAG
	.globl _EXTCON
	.globl _I2CSTAT
	.globl _I2CRXLEN
	.globl _I2CTXLEN
	.globl _I2CFREQ
	.globl _SLVADDR
	.globl _I2CCON
	.globl _IE2
	.globl _B
	.globl _ACC
	.globl _PSW
	.globl _DPH
	.globl _DPL
	.globl _SP
	.globl _NETRXBUF
	.globl _NETTXBUF
	.globl _I2CRXBUF
	.globl _I2CTXBUF
	.globl _mb_device_init
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_PSW	=	0x00d0
_ACC	=	0x00e0
_B	=	0x00f0
_IE2	=	0x00c0
_I2CCON	=	0x00c1
_SLVADDR	=	0x00c2
_I2CFREQ	=	0x00c3
_I2CTXLEN	=	0x00c4
_I2CRXLEN	=	0x00c5
_I2CSTAT	=	0x00c6
_EXTCON	=	0x00c7
_IFLAG	=	0x00c8
_TMRCON	=	0x00c9
_TMRL	=	0x00ca
_TMRH	=	0x00cb
_TMR	=	0xcbca
_TXIP0	=	0x00a9
_TXIP1	=	0x00aa
_TXIP2	=	0x00ab
_TXIP3	=	0x00ac
_TXIP	=	0xacabaaa9
_TXPORTL	=	0x00ad
_TXPORTH	=	0x00ae
_TXPORT	=	0xaead
_TXCH	=	0x00af
_RXIP0	=	0x00b1
_RXIP1	=	0x00b2
_RXIP2	=	0x00b3
_RXIP3	=	0x00b4
_RXIP	=	0xb4b3b2b1
_RXPORTL	=	0x00b5
_RXPORTH	=	0x00b6
_RXPORT	=	0xb6b5
_RXCH	=	0x00b7
_NETCON	=	0x00b9
_NETTXLEN	=	0x00ba
_NETRXLEN	=	0x00bb
_NETSTAT	=	0x00bc
_NETTOUT	=	0x00bd
;--------------------------------------------------------
; special function bits
;--------------------------------------------------------
	.area RSEG    (ABS,DATA)
	.org 0x0000
_ENET	=	0x00c0
_ETMR	=	0x00c1
_EEXT	=	0x00c2
_FNET	=	0x00c8
_FTMR	=	0x00c9
_FEXT	=	0x00ca
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
;--------------------------------------------------------
; overlayable register banks
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; absolute internal ram data
;--------------------------------------------------------
	.area IABS    (ABS,DATA)
	.area IABS    (ABS,DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; paged external ram data
;--------------------------------------------------------
	.area PSEG    (PAG,XDATA)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_I2CTXBUF	=	0x0800
_I2CRXBUF	=	0x0900
_NETTXBUF	=	0x0a00
_NETRXBUF	=	0x0b00
_u16swap_val_65536_31:
	.ds 2
_mb_read_coils_mask_65536_40:
	.ds 1
_mb_read_coils_val_196608_44:
	.ds 2
_mb_read_coils_val_196608_47:
	.ds 2
_mb_write_single_coil_ret_65536_50:
	.ds 1
_mb_write_single_coil_value_65536_50:
	.ds 1
_mb_write_single_coil_val_196608_56:
	.ds 2
_mb_write_single_coil_val_196608_59:
	.ds 2
_mb_write_single_register_ret_65536_62:
	.ds 1
_mb_write_single_register_val_196608_66:
	.ds 2
_mb_write_single_register_val_196608_69:
	.ds 2
_mb_write_multiple_coils_ret_65536_72:
	.ds 1
_mb_write_multiple_coils_mask_65536_72:
	.ds 1
_mb_write_multiple_coils_val_196608_78:
	.ds 2
_mb_write_multiple_coils_val_196608_81:
	.ds 2
_mb_read_holding_registers_ret_65536_84:
	.ds 1
_mb_read_holding_registers_len_65536_84:
	.ds 2
_mb_read_holding_registers_val_196608_89:
	.ds 2
_mb_read_holding_registers_val_196608_92:
	.ds 2
_mb_read_holding_registers_val_393216_95:
	.ds 2
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area XABS    (ABS,XDATA)
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
	.area HOME    (CODE)
	.area GSINIT0 (CODE)
	.area GSINIT1 (CODE)
	.area GSINIT2 (CODE)
	.area GSINIT3 (CODE)
	.area GSINIT4 (CODE)
	.area GSINIT5 (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area HOME    (CODE)
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area HOME    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'u16swap'
;------------------------------------------------------------
;val                       Allocated with name '_u16swap_val_65536_31'
;------------------------------------------------------------
;	../VM_Inc/mb.h:263: static inline uint16_t u16swap(uint16_t val)
;	-----------------------------------------
;	 function u16swap
;	-----------------------------------------
_u16swap:
	ar7 = 0x07
	ar6 = 0x06
	ar5 = 0x05
	ar4 = 0x04
	ar3 = 0x03
	ar2 = 0x02
	ar1 = 0x01
	ar0 = 0x00
	mov	r7,dph
	mov	a,dpl
	mov	dptr,#_u16swap_val_65536_31
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	../VM_Inc/mb.h:265: return ((val >> 8) & 0x00FF) | ((val << 8) & 0xFF00);
	mov	dptr,#_u16swap_val_65536_31
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
	mov	dpl,r6
	mov	dph,r7
;	../VM_Inc/mb.h:266: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_coils'
;------------------------------------------------------------
;__1310720027              Allocated with name '_mb_read_coils___1310720027_131072_40'
;__1310720024              Allocated with name '_mb_read_coils___1310720024_131072_40'
;value                     Allocated with name '_mb_read_coils_value_65536_40'
;ret                       Allocated with name '_mb_read_coils_ret_65536_40'
;mask                      Allocated with name '_mb_read_coils_mask_65536_40'
;i                         Allocated with name '_mb_read_coils_i_65536_40'
;startaddr                 Allocated with name '_mb_read_coils_startaddr_65536_40'
;numcoils                  Allocated with name '_mb_read_coils_numcoils_65536_40'
;__1310720025              Allocated with name '_mb_read_coils___1310720025_131072_43'
;val                       Allocated with name '_mb_read_coils_val_196608_44'
;__1310720028              Allocated with name '_mb_read_coils___1310720028_131072_46'
;val                       Allocated with name '_mb_read_coils_val_196608_47'
;------------------------------------------------------------
;	mb_ltc1669_if.c:35: uint8_t mb_read_coils(void)
;	-----------------------------------------
;	 function mb_read_coils
;	-----------------------------------------
_mb_read_coils:
;	mb_ltc1669_if.c:39: uint8_t mask = 0;
	mov	dptr,#_mb_read_coils_mask_65536_40
	clr	a
	movx	@dptr,a
;	mb_ltc1669_if.c:44: startaddr = u16swap(modbus.request.u.RdCoils.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ltc1669_if.c:45: numcoils = u16swap(modbus.request.u.RdCoils.NumCoils);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ltc1669_if.c:47: if ((numcoils < MB_RD_MIN_NUM_COILS) || (numcoils > MB_RD_MAX_NUM_COILS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0xd0
	subb	a,r2
	mov	a,#0x07
	subb	a,r3
	jnc	00102$
00101$:
;	mb_ltc1669_if.c:48: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ltc1669_if.c:50: if ((startaddr > (LTC1669_MAX_COILS-1)) || (numcoils > (LTC1669_MAX_COILS - startaddr)))
	clr	c
	mov	a,#0x02
	subb	a,r6
	clr	a
	subb	a,r7
	jc	00104$
	mov	a,#0x03
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00105$
00104$:
;	mb_ltc1669_if.c:51: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_ltc1669_if.c:53: value = read_dac_cmd();
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	lcall	_read_dac_cmd
	mov	a,dpl
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ltc1669_if.c:54: value >>= startaddr;
	mov	b,r6
	inc	b
	sjmp	00137$
00136$:
	clr	c
	rrc	a
00137$:
	djnz	b,00136$
	mov	r7,a
;	mb_ltc1669_if.c:55: for(i=0;i<numcoils;i++){
	mov	r6,#0x00
00111$:
	mov	ar2,r6
	mov	r3,#0x00
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00107$
;	mb_ltc1669_if.c:56: mask += (1<<i);
	mov	ar3,r6
	mov	b,r3
	inc	b
	mov	a,#0x01
	sjmp	00141$
00139$:
	add	a,acc
00141$:
	djnz	b,00139$
	mov	r3,a
	mov	dptr,#_mb_read_coils_mask_65536_40
	movx	a,@dptr
	mov	r2,a
	add	a,r3
	movx	@dptr,a
;	mb_ltc1669_if.c:55: for(i=0;i<numcoils;i++){
	inc	r6
	sjmp	00111$
00107$:
;	mb_ltc1669_if.c:58: value &= mask;
	mov	dptr,#_mb_read_coils_mask_65536_40
	movx	a,@dptr
	anl	ar7,a
;	mb_ltc1669_if.c:59: modbus.response.u.RdCoils.Count = 1;            // "Byte Count" -> 3Bits , therefore only a max/min of one byte
	mov	dptr,#(_modbus + 0x0130)
	mov	a,#0x01
	movx	@dptr,a
;	mb_ltc1669_if.c:60: modbus.response.u.RdCoils.Status[0] = value;    // "Coil Status"
	mov	dptr,#(_modbus + 0x0131)
	mov	a,r7
	movx	@dptr,a
;	mb_ltc1669_if.c:61: mb_set_data_length(2);                          // 2 bytes: 1x "Byte Count" and 1x Byte
	mov	dptr,#0x0002
	lcall	_mb_set_data_length
;	mb_ltc1669_if.c:64: return(ret);
	mov	dpl,#0x00
;	mb_ltc1669_if.c:65: }
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_single_coil'
;------------------------------------------------------------
;__1310720033              Allocated with name '_mb_write_single_coil___1310720033_131072_50'
;__1310720030              Allocated with name '_mb_write_single_coil___1310720030_131072_50'
;ret                       Allocated with name '_mb_write_single_coil_ret_65536_50'
;addr                      Allocated with name '_mb_write_single_coil_addr_65536_50'
;coilvalue                 Allocated with name '_mb_write_single_coil_coilvalue_65536_50'
;value                     Allocated with name '_mb_write_single_coil_value_65536_50'
;__1310720031              Allocated with name '_mb_write_single_coil___1310720031_131072_55'
;val                       Allocated with name '_mb_write_single_coil_val_196608_56'
;__1310720034              Allocated with name '_mb_write_single_coil___1310720034_131072_58'
;val                       Allocated with name '_mb_write_single_coil_val_196608_59'
;------------------------------------------------------------
;	mb_ltc1669_if.c:67: uint8_t mb_write_single_coil(void)
;	-----------------------------------------
;	 function mb_write_single_coil
;	-----------------------------------------
_mb_write_single_coil:
;	mb_ltc1669_if.c:74: addr = u16swap(modbus.request.u.WrSingleCoil.Addr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ltc1669_if.c:75: coilvalue = u16swap(modbus.request.u.WrSingleCoil.Value);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ltc1669_if.c:77: if (!((coilvalue == MB_COIL_LOW) || (coilvalue == MB_COIL_HIGH))){
	mov	a,r4
	orl	a,r5
	jz	00102$
	mov	ar2,r4
	mov	ar3,r5
	cjne	r2,#0x00,00137$
	cjne	r3,#0xff,00137$
	sjmp	00102$
00137$:
;	mb_ltc1669_if.c:78: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ltc1669_if.c:81: if (addr > (LTC1669_MAX_COILS-1))
	clr	c
	mov	a,#0x02
	subb	a,r6
	clr	a
	subb	a,r7
	jnc	00105$
;	mb_ltc1669_if.c:82: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_ltc1669_if.c:84: if (coilvalue == MB_COIL_HIGH) {
	cjne	r4,#0x00,00107$
	cjne	r5,#0xff,00107$
;	mb_ltc1669_if.c:85: value = 1;
	mov	dptr,#_mb_write_single_coil_value_65536_50
	mov	a,#0x01
	movx	@dptr,a
	sjmp	00108$
00107$:
;	mb_ltc1669_if.c:87: value = 0;
	mov	dptr,#_mb_write_single_coil_value_65536_50
	clr	a
	movx	@dptr,a
00108$:
;	mb_ltc1669_if.c:90: if (set_dac_cmd_bit(LTC1669_ADDR, addr, value)) {
	mov	dptr,#_mb_write_single_coil_value_65536_50
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#_set_dac_cmd_bit_PARM_2
	mov	a,r6
	movx	@dptr,a
	mov	dptr,#_set_dac_cmd_bit_PARM_3
	mov	a,r7
	movx	@dptr,a
	mov	dpl,#0x40
	lcall	_set_dac_cmd_bit
	mov	a,dpl
	jz	00110$
;	mb_ltc1669_if.c:91: modbus.response.u.WrSingleCoil.Addr = modbus.request.u.WrSingleCoil.Addr;
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:92: modbus.response.u.WrSingleCoil.Value = modbus.request.u.WrSingleCoil.Value;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:93: mb_set_data_length(4);
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_ltc1669_if.c:94: ret = MB_OK;
	mov	dptr,#_mb_write_single_coil_ret_65536_50
	clr	a
	movx	@dptr,a
	sjmp	00111$
00110$:
;	mb_ltc1669_if.c:95: } else ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_coil_ret_65536_50
	mov	a,#0x04
	movx	@dptr,a
00111$:
;	mb_ltc1669_if.c:97: return(ret);
	mov	dptr,#_mb_write_single_coil_ret_65536_50
	movx	a,@dptr
;	mb_ltc1669_if.c:98: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_single_register'
;------------------------------------------------------------
;__1310720039              Allocated with name '_mb_write_single_register___1310720039_131072_62'
;__1310720036              Allocated with name '_mb_write_single_register___1310720036_131072_62'
;ret                       Allocated with name '_mb_write_single_register_ret_65536_62'
;addr                      Allocated with name '_mb_write_single_register_addr_65536_62'
;value                     Allocated with name '_mb_write_single_register_value_65536_62'
;__1310720037              Allocated with name '_mb_write_single_register___1310720037_131072_65'
;val                       Allocated with name '_mb_write_single_register_val_196608_66'
;__1310720040              Allocated with name '_mb_write_single_register___1310720040_131072_68'
;val                       Allocated with name '_mb_write_single_register_val_196608_69'
;------------------------------------------------------------
;	mb_ltc1669_if.c:100: uint8_t mb_write_single_register(void)
;	-----------------------------------------
;	 function mb_write_single_register
;	-----------------------------------------
_mb_write_single_register:
;	mb_ltc1669_if.c:106: addr = u16swap(modbus.request.u.WrSingleReg.Addr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r7,a
	mov	r5,a
	mov	ar4,r6
	clr	a
	mov	r3,a
	mov	r2,a
	mov	a,r5
	orl	ar3,a
	mov	a,r2
	orl	ar4,a
;	mb_ltc1669_if.c:107: value = u16swap(modbus.request.u.WrSingleReg.Value);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r2,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r1,a
	mov	ar5,r2
	mov	r2,#0x00
	mov	ar0,r1
	mov	r1,#0x00
	mov	a,r0
	orl	ar2,a
	mov	a,r1
	orl	ar5,a
;	mb_ltc1669_if.c:109: modbus.response.u.WrSingleReg.Addr = modbus.request.u.WrSingleReg.Addr;
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:110: modbus.response.u.WrSingleReg.Value = modbus.request.u.WrSingleReg.Value;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:111: mb_set_data_length(4);
	mov	dptr,#0x0004
	push	ar5
	push	ar4
	push	ar3
	push	ar2
	lcall	_mb_set_data_length
	pop	ar2
	pop	ar3
	pop	ar4
	pop	ar5
;	mb_ltc1669_if.c:112: ret = MB_OK;
	mov	dptr,#_mb_write_single_register_ret_65536_62
	clr	a
	movx	@dptr,a
;	mb_ltc1669_if.c:114: switch(addr) {
	cjne	r3,#0x00,00104$
	cjne	r4,#0x00,00104$
;	mb_ltc1669_if.c:116: if (!write_dac_value(LTC1669_ADDR, value)) {
	mov	dptr,#_write_dac_value_PARM_2
	mov	a,r2
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x40
	lcall	_write_dac_value
	mov	a,dpl
	jnz	00105$
;	mb_ltc1669_if.c:117: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_single_register_ret_65536_62
	mov	a,#0x04
	movx	@dptr,a
;	mb_ltc1669_if.c:119: break;
;	mb_ltc1669_if.c:120: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00105$
00104$:
	mov	dptr,#_mb_write_single_register_ret_65536_62
	mov	a,#0x02
	movx	@dptr,a
;	mb_ltc1669_if.c:122: }
00105$:
;	mb_ltc1669_if.c:123: return(ret);
	mov	dptr,#_mb_write_single_register_ret_65536_62
	movx	a,@dptr
;	mb_ltc1669_if.c:124: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_write_multiple_coils'
;------------------------------------------------------------
;__1310720045              Allocated with name '_mb_write_multiple_coils___1310720045_131072_72'
;__1310720042              Allocated with name '_mb_write_multiple_coils___1310720042_131072_72'
;ret                       Allocated with name '_mb_write_multiple_coils_ret_65536_72'
;startaddr                 Allocated with name '_mb_write_multiple_coils_startaddr_65536_72'
;numcoils                  Allocated with name '_mb_write_multiple_coils_numcoils_65536_72'
;coils_state               Allocated with name '_mb_write_multiple_coils_coils_state_65536_72'
;value                     Allocated with name '_mb_write_multiple_coils_value_65536_72'
;mask                      Allocated with name '_mb_write_multiple_coils_mask_65536_72'
;i                         Allocated with name '_mb_write_multiple_coils_i_65536_72'
;__1310720043              Allocated with name '_mb_write_multiple_coils___1310720043_131072_77'
;val                       Allocated with name '_mb_write_multiple_coils_val_196608_78'
;__1310720046              Allocated with name '_mb_write_multiple_coils___1310720046_131072_80'
;val                       Allocated with name '_mb_write_multiple_coils_val_196608_81'
;------------------------------------------------------------
;	mb_ltc1669_if.c:126: uint8_t mb_write_multiple_coils(void)
;	-----------------------------------------
;	 function mb_write_multiple_coils
;	-----------------------------------------
_mb_write_multiple_coils:
;	mb_ltc1669_if.c:133: uint8_t mask = 0;
	mov	dptr,#_mb_write_multiple_coils_mask_65536_72
	clr	a
	movx	@dptr,a
;	mb_ltc1669_if.c:136: startaddr = u16swap(modbus.request.u.WrMultCoils.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ltc1669_if.c:137: numcoils = u16swap(modbus.request.u.WrMultCoils.NumCoils);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ltc1669_if.c:139: if ((numcoils < MB_WR_MIN_NUM_COILS) || (numcoils > MB_WR_MAX_NUM_COILS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0xb0
	subb	a,r2
	mov	a,#0x07
	subb	a,r3
	jnc	00102$
00101$:
;	mb_ltc1669_if.c:140: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ltc1669_if.c:142: if (modbus.src_socket.rxlen < MB_WRITE_MIN_PACKET_SIZE)
	mov	dptr,#(_modbus + 0x000b)
	movx	a,@dptr
	mov	r3,a
	cjne	r3,#0x0e,00153$
00153$:
	jnc	00105$
;	mb_ltc1669_if.c:143: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00105$:
;	mb_ltc1669_if.c:145: if (modbus.request.u.WrMultCoils.Count != (modbus.src_socket.rxlen - (MB_WRITE_MIN_PACKET_SIZE-1)))
	mov	dptr,#(_modbus + 0x0034)
	movx	a,@dptr
	mov	r2,a
	mov	ar1,r3
	mov	r3,#0x00
	mov	a,r1
	add	a,#0xf3
	mov	r1,a
	mov	a,r3
	addc	a,#0xff
	mov	r3,a
	mov	ar0,r2
	mov	r2,#0x00
	mov	a,r0
	cjne	a,ar1,00155$
	mov	a,r2
	cjne	a,ar3,00155$
	sjmp	00107$
00155$:
;	mb_ltc1669_if.c:146: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00107$:
;	mb_ltc1669_if.c:148: if ((startaddr > (LTC1669_MAX_COILS-1)) || (numcoils > (LTC1669_MAX_COILS - startaddr)))
	clr	c
	mov	a,#0x02
	subb	a,r6
	clr	a
	subb	a,r7
	jc	00108$
	mov	a,#0x03
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00109$
00108$:
;	mb_ltc1669_if.c:149: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00109$:
;	mb_ltc1669_if.c:151: coils_state = modbus.request.u.WrMultCoils.Value[0];
	mov	dptr,#(_modbus + 0x0035)
	movx	a,@dptr
	mov	r3,a
;	mb_ltc1669_if.c:153: value = read_dac_cmd();
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_read_dac_cmd
	mov	r2,dpl
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ltc1669_if.c:155: for(i=0;i<numcoils;i++){
	mov	r1,#0x00
00118$:
	push	ar2
	mov	ar0,r1
	mov	r2,#0x00
	clr	c
	mov	a,r0
	subb	a,r4
	mov	a,r2
	subb	a,r5
	pop	ar2
	jnc	00111$
;	mb_ltc1669_if.c:156: mask += (1<<i);
	push	ar2
	mov	ar0,r1
	mov	b,r0
	inc	b
	mov	a,#0x01
	sjmp	00161$
00159$:
	add	a,acc
00161$:
	djnz	b,00159$
	mov	r0,a
	mov	dptr,#_mb_write_multiple_coils_mask_65536_72
	movx	a,@dptr
	add	a,r0
	movx	@dptr,a
;	mb_ltc1669_if.c:155: for(i=0;i<numcoils;i++){
	inc	r1
	pop	ar2
	sjmp	00118$
00111$:
;	mb_ltc1669_if.c:158: mask <<= startaddr;
	mov	dptr,#_mb_write_multiple_coils_mask_65536_72
	movx	a,@dptr
	mov	r5,a
	mov	b,r6
	inc	b
	mov	a,r5
	sjmp	00164$
00162$:
	add	a,acc
00164$:
	djnz	b,00162$
	mov	dptr,#_mb_write_multiple_coils_mask_65536_72
	movx	@dptr,a
;	mb_ltc1669_if.c:159: value &= ~mask;
	movx	a,@dptr
	mov	r7,a
	cpl	a
	anl	ar2,a
;	mb_ltc1669_if.c:160: coils_state <<= startaddr;
	mov	b,r6
	inc	b
	mov	a,r3
	sjmp	00167$
00165$:
	add	a,acc
00167$:
	djnz	b,00165$
;	mb_ltc1669_if.c:161: coils_state &= mask;
	anl	a,r7
;	mb_ltc1669_if.c:162: value |= coils_state;
	mov	dptr,#_write_dac_cmd_PARM_2
	orl	a,r2
	movx	@dptr,a
;	mb_ltc1669_if.c:164: if (write_dac_cmd(LTC1669_ADDR, value)) {
	mov	dpl,#0x40
	lcall	_write_dac_cmd
	mov	a,dpl
	jz	00113$
;	mb_ltc1669_if.c:165: modbus.response.u.WrMultCoils.StartAddr = modbus.request.u.WrMultCoils.StartAddr;
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0130)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:166: modbus.response.u.WrMultCoils.NumCoils = modbus.request.u.WrMultCoils.NumCoils;
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
	mov	r7,a
	mov	dptr,#(_modbus + 0x0132)
	mov	a,r6
	movx	@dptr,a
	mov	a,r7
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:167: mb_set_data_length(4);
	mov	dptr,#0x0004
	lcall	_mb_set_data_length
;	mb_ltc1669_if.c:168: ret = MB_OK;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_72
	clr	a
	movx	@dptr,a
	sjmp	00114$
00113$:
;	mb_ltc1669_if.c:170: ret = MB_ERR_SLAVE_DEVICE_FAILURE;
	mov	dptr,#_mb_write_multiple_coils_ret_65536_72
	mov	a,#0x04
	movx	@dptr,a
00114$:
;	mb_ltc1669_if.c:172: return(ret);
	mov	dptr,#_mb_write_multiple_coils_ret_65536_72
	movx	a,@dptr
;	mb_ltc1669_if.c:173: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_read_holding_registers'
;------------------------------------------------------------
;__1310720051              Allocated with name '_mb_read_holding_registers___1310720051_131072_84'
;__1310720048              Allocated with name '_mb_read_holding_registers___1310720048_131072_84'
;ret                       Allocated with name '_mb_read_holding_registers_ret_65536_84'
;addr                      Allocated with name '_mb_read_holding_registers_addr_65536_84'
;numregs                   Allocated with name '_mb_read_holding_registers_numregs_65536_84'
;len                       Allocated with name '_mb_read_holding_registers_len_65536_84'
;i                         Allocated with name '_mb_read_holding_registers_i_65536_84'
;u16value                  Allocated with name '_mb_read_holding_registers_u16value_65536_84'
;__1310720049              Allocated with name '_mb_read_holding_registers___1310720049_131072_88'
;val                       Allocated with name '_mb_read_holding_registers_val_196608_89'
;__1310720052              Allocated with name '_mb_read_holding_registers___1310720052_131072_91'
;val                       Allocated with name '_mb_read_holding_registers_val_196608_92'
;__3276800054              Allocated with name '_mb_read_holding_registers___3276800054_327680_87'
;__3276800055              Allocated with name '_mb_read_holding_registers___3276800055_327680_94'
;val                       Allocated with name '_mb_read_holding_registers_val_393216_95'
;------------------------------------------------------------
;	mb_ltc1669_if.c:175: uint8_t mb_read_holding_registers(void)
;	-----------------------------------------
;	 function mb_read_holding_registers
;	-----------------------------------------
_mb_read_holding_registers:
;	mb_ltc1669_if.c:177: uint8_t ret = MB_ERR_UNKNOWN;
	mov	dptr,#_mb_read_holding_registers_ret_65536_84
	mov	a,#0xff
	movx	@dptr,a
;	mb_ltc1669_if.c:184: addr = u16swap(modbus.request.u.RdHoldingRegs.StartAddr);
	mov	dptr,#(_modbus + 0x0030)
	movx	a,@dptr
	mov	r6,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r5,a
	mov	ar7,r6
	clr	a
	mov	r6,a
	mov	r4,a
	mov	a,r5
	orl	ar6,a
	mov	a,r4
	orl	ar7,a
;	mb_ltc1669_if.c:185: numregs = u16swap(modbus.request.u.RdHoldingRegs.NumRegisters);
	mov	dptr,#(_modbus + 0x0032)
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	r3,a
	mov	ar5,r4
	clr	a
	mov	r4,a
	mov	r2,a
	mov	a,r3
	orl	ar4,a
	mov	a,r2
	orl	ar5,a
;	mb_ltc1669_if.c:187: if ((numregs < MB_RD_MIN_NUM_REGS) || (numregs > MB_RD_MAX_NUM_REGS))
	mov	ar2,r4
	mov	ar3,r5
	clr	c
	mov	a,r2
	subb	a,#0x01
	mov	a,r3
	subb	a,#0x00
	jc	00101$
	mov	a,#0x7d
	subb	a,r2
	clr	a
	subb	a,r3
	jnc	00102$
00101$:
;	mb_ltc1669_if.c:188: return(MB_ERR_ILLEGAL_DATA_VALUE);
	mov	dpl,#0x03
	ret
00102$:
;	mb_ltc1669_if.c:190: if ((addr > (LTC1669_MAX_REGS-1)) || (numregs > (LTC1669_MAX_REGS - addr)))
	mov	a,r6
	orl	a,r7
	jnz	00104$
	mov	a,#0x01
	clr	c
	subb	a,r6
	mov	r2,a
	clr	a
	subb	a,r7
	mov	r3,a
	clr	c
	mov	a,r2
	subb	a,r4
	mov	a,r3
	subb	a,r5
	jnc	00105$
00104$:
;	mb_ltc1669_if.c:191: return(MB_ERR_ILLEGAL_DATA_ADDRESS);
	mov	dpl,#0x02
	ret
00105$:
;	mb_ltc1669_if.c:193: modbus.response.u.RdHoldingRegs.Count = (uint8_t)(numregs * 2);
	mov	ar3,r4
	mov	a,r3
	add	a,r3
	mov	dptr,#(_modbus + 0x0130)
	movx	@dptr,a
;	mb_ltc1669_if.c:194: len = 1;
	mov	dptr,#_mb_read_holding_registers_len_65536_84
	mov	a,#0x01
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:196: for (i = addr; i<(addr + numregs); i++) {
	mov	ar3,r6
	mov	a,r4
	add	a,r6
	mov	r4,a
	mov	a,r5
	addc	a,r7
	mov	r5,a
00115$:
	mov	ar1,r3
	mov	r2,#0x00
	clr	c
	mov	a,r1
	subb	a,r4
	mov	a,r2
	subb	a,r5
	jc	00143$
	ljmp	00110$
00143$:
;	mb_ltc1669_if.c:197: switch(i) {
	cjne	r3,#0x00,00144$
	sjmp	00145$
00144$:
	ljmp	00108$
00145$:
;	mb_ltc1669_if.c:199: u16value = read_dac_value();
	push	ar4
	push	ar5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_read_dac_value
	mov	r1,dpl
	mov	r2,dph
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ltc1669_if.c:200: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	mov	ar0,r3
	mov	r5,#0x00
	mov	a,r0
	clr	c
	subb	a,r6
	mov	r0,a
	mov	a,r5
	subb	a,r7
	mov	r5,a
	mov	a,r0
	add	a,r0
	mov	r0,a
	mov	a,r5
	rlc	a
	mov	r5,a
	mov	a,r0
	add	a,#(_modbus + 0x0131)
	mov	dpl,a
	mov	a,r5
	addc	a,#((_modbus + 0x0131) >> 8)
	mov	dph,a
;	mb_ltc1669_if.c:265: ERROR: no line number 265 in file mb_ltc1669_if.c
	mov	ar5,r2
	mov	ar2,r1
	clr	a
	mov	r1,a
	mov	r4,a
	mov	a,r5
	orl	ar1,a
	mov	a,r4
	orl	ar2,a
;	mb_ltc1669_if.c:200: modbus.response.u.RdHoldingRegs.Value[i - addr] = u16swap(u16value);
	mov	a,r1
	movx	@dptr,a
	mov	a,r2
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:201: len += 2;
	mov	dptr,#_mb_read_holding_registers_len_65536_84
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	a,#0x02
	add	a,r4
	mov	r4,a
	clr	a
	addc	a,r5
	mov	r5,a
	mov	dptr,#_mb_read_holding_registers_len_65536_84
	mov	a,r4
	movx	@dptr,a
	mov	a,r5
	inc	dptr
	movx	@dptr,a
;	mb_ltc1669_if.c:202: mb_set_data_length(len);
	mov	dptr,#_mb_read_holding_registers_len_65536_84
	movx	a,@dptr
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
	mov	dpl,r4
	mov	dph,r5
	push	ar7
	push	ar6
	push	ar5
	push	ar4
	push	ar3
	lcall	_mb_set_data_length
	pop	ar3
	pop	ar4
	pop	ar5
	pop	ar6
	pop	ar7
;	mb_ltc1669_if.c:203: ret = MB_OK;
	mov	dptr,#_mb_read_holding_registers_ret_65536_84
	clr	a
	movx	@dptr,a
;	mb_ltc1669_if.c:204: break;
	pop	ar5
	pop	ar4
;	mb_ltc1669_if.c:205: default: ret = MB_ERR_ILLEGAL_DATA_ADDRESS;
	sjmp	00116$
00108$:
;	mb_ltc1669_if.c:206: return(ret);
	mov	dpl,#0x02
;	mb_ltc1669_if.c:208: }
	ret
00116$:
;	mb_ltc1669_if.c:196: for (i = addr; i<(addr + numregs); i++) {
	inc	r3
	ljmp	00115$
00110$:
;	mb_ltc1669_if.c:210: return(ret);
	mov	dptr,#_mb_read_holding_registers_ret_65536_84
	movx	a,@dptr
;	mb_ltc1669_if.c:211: }
	mov	dpl,a
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'mb_device_init'
;------------------------------------------------------------
;	mb_ltc1669_if.c:213: void mb_device_init(void)
;	-----------------------------------------
;	 function mb_device_init
;	-----------------------------------------
_mb_device_init:
;	mb_ltc1669_if.c:215: mb_init(BasicDeviceObjects, sizeof(BasicDeviceObjects), CH_VMTCP);
	mov	dptr,#_mb_init_PARM_2
	mov	a,#0x22
	movx	@dptr,a
	mov	dptr,#_mb_init_PARM_3
	mov	a,#0x03
	movx	@dptr,a
	mov	dptr,#_BasicDeviceObjects
	mov	b,#0x80
	lcall	_mb_init
;	mb_ltc1669_if.c:217: mb_register_function(MB_CMD_READ_COILS, mb_read_coils);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_read_coils
	movx	@dptr,a
	mov	a,#(_mb_read_coils >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x01
	lcall	_mb_register_function
;	mb_ltc1669_if.c:219: mb_register_function(MB_CMD_READ_HOLDING_REGISTERS, mb_read_holding_registers);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_read_holding_registers
	movx	@dptr,a
	mov	a,#(_mb_read_holding_registers >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x03
	lcall	_mb_register_function
;	mb_ltc1669_if.c:221: mb_register_function(MB_CMD_WRITE_SINGLE_COIL, mb_write_single_coil);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_single_coil
	movx	@dptr,a
	mov	a,#(_mb_write_single_coil >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x05
	lcall	_mb_register_function
;	mb_ltc1669_if.c:222: mb_register_function(MB_CMD_WRITE_SINGLE_REGISTER, mb_write_single_register);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_single_register
	movx	@dptr,a
	mov	a,#(_mb_write_single_register >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x06
	lcall	_mb_register_function
;	mb_ltc1669_if.c:223: mb_register_function(MB_CMD_WRITE_MULTIPLE_COILS, mb_write_multiple_coils);
	mov	dptr,#_mb_register_function_PARM_2
	mov	a,#_mb_write_multiple_coils
	movx	@dptr,a
	mov	a,#(_mb_write_multiple_coils >> 8)
	inc	dptr
	movx	@dptr,a
	mov	dpl,#0x0f
;	mb_ltc1669_if.c:227: }
	ljmp	_mb_register_function
	.area CSEG    (CODE)
	.area CONST   (CODE)
_BasicDeviceObjects:
	.db #0x00	; 0
	.db #0x0d	; 13
	.db #0x43	; 67	'C'
	.db #0x6f	; 111	'o'
	.db #0x70	; 112	'p'
	.db #0x74	; 116	't'
	.db #0x6f	; 111	'o'
	.db #0x6e	; 110	'n'
	.db #0x69	; 105	'i'
	.db #0x78	; 120	'x'
	.db #0x20	; 32
	.db #0x47	; 71	'G'
	.db #0x6d	; 109	'm'
	.db #0x62	; 98	'b'
	.db #0x48	; 72	'H'
	.db #0x01	; 1
	.db #0x0a	; 10
	.db #0x4d	; 77	'M'
	.db #0x42	; 66	'B'
	.db #0x20	; 32
	.db #0x4c	; 76	'L'
	.db #0x54	; 84	'T'
	.db #0x43	; 67	'C'
	.db #0x31	; 49	'1'
	.db #0x36	; 54	'6'
	.db #0x36	; 54	'6'
	.db #0x39	; 57	'9'
	.db #0x02	; 2
	.db #0x05	; 5
	.db #0x56	; 86	'V'
	.db #0x31	; 49	'1'
	.db #0x2e	; 46
	.db #0x30	; 48	'0'
	.db #0x30	; 48	'0'
	.area XINIT   (CODE)
	.area CABS    (ABS,CODE)
