#include "vmdevice.h"
#include <stdint.h>
#include "net.h"
#include "i2c.h"

void main(void)
{
    uint8_t loop;

    while(1) {
        if (FNET) {
            TXCH = RXCH;            //Copy RX socket number to the TX socket
            NETTXLEN = NETRXLEN;    //Set number of bytes to send - loop back

            //Copy data received from RX buffer to output to TX buffer
            for(loop=0; loop < NETTXLEN; loop++) {
                NETTXBUF[loop] = NETRXBUF[loop];
            }
            FNET = 0;       //Clear NET Flag to allow new coming data
            NETCON = NETWR; //Start data transmission
            while(NETSTAT == NET_TRANSMIT_PENDING); //wait until data is sent
        }
    }
}
